package org.exoplatform.portlets.content.categorybrowser.component;

import javax.jcr.NodeIterator;
import javax.jcr.query.QueryResult;

import org.exoplatform.faces.core.component.UIExoCommand;
import org.exoplatform.faces.core.component.model.Parameter;
import org.exoplatform.faces.core.event.ExoActionEvent;
import org.exoplatform.faces.core.event.ExoActionListener;
import org.exoplatform.portal.Information;
import org.exoplatform.portlets.content.jcr.JCRExceptionManager;
import org.exoplatform.portlets.content.jcr.component.UIJCRExplorer;

public class UIResults extends UIExoCommand{
  
  protected QueryResult results_;
  protected long duration_;  
  
  static Parameter[] CHANGE_NODE_PARAMS = { new Parameter(ACTION,
      UIJCRExplorer.CHANGE_NODE_ACTION) };    
  
  public UIResults() {
    setId("UIResults") ;
    setRendererType("VelocityRenderer") ;    
    addActionListener(ChangeNodeActionListener.class, UIJCRExplorer.CHANGE_NODE_ACTION);
  }
  
  public Parameter[] getChangeNodeParams() {
    return CHANGE_NODE_PARAMS;
  }    
  
  public boolean hasResults() throws Exception {
    if(results_ == null) return false;
    return results_.getNodes().hasNext();
  }
  
  public long searchTime() {
    return duration_;
  }
  
  public NodeIterator getNodeIterator() throws Exception {
    return results_.getNodes();
  }

  public void setQueryResults(long duration, QueryResult queryResult) {
    duration_ = duration;
    results_ = queryResult;    
  }  
  
  static public class ChangeNodeActionListener extends ExoActionListener {
    public void execute(ExoActionEvent event) throws Exception {
      UIResults uicomp = (UIResults) event.getComponent();
      UICategoryExplorer uiExplorer = (UICategoryExplorer) uicomp
          .getAncestorOfType(UICategoryExplorer.class);
      String uri = event.getParameter(OBJECTID);
      Information iprovider = findInformationProvider(uicomp);
      try {
        if ("../".equals(uri)) {
          if (!"/".equals(uiExplorer.getSelectNode().getPath())) {
            uiExplorer.setSelectNode(uiExplorer.getSelectNode().getParent());
          }
        }
        uiExplorer.setSelectNode(uri);
      } catch (Exception e) {
        JCRExceptionManager.process(iprovider, e);
      }
    }
  }    

}
