package org.exoplatform.portlets.content.display.dynamic.component;

import java.util.ArrayList;
import java.util.List;

import javax.faces.context.ExternalContext;
import javax.faces.context.FacesContext;
import javax.portlet.PortletPreferences;
import javax.portlet.PortletRequest;

import org.exoplatform.faces.application.ExoFacesMessage;
import org.exoplatform.faces.core.component.InformationProvider;
import org.exoplatform.faces.core.component.UISelectBox;
import org.exoplatform.faces.core.component.UISimpleForm;
import org.exoplatform.faces.core.component.model.SelectItem;
import org.exoplatform.faces.core.event.ExoActionEvent;
import org.exoplatform.faces.core.event.ExoActionListener;
import org.exoplatform.portal.Information;

public class UIAdminView extends UISimpleForm {
  
  private UISelectBox selectBox;
  
  public UIAdminView(){
    super("viewForm", "post", null) ;
    setRendererType("SimpleFormVelocityRenderer") ;

    List layouts = new ArrayList();
    layouts.add(new SelectItem("tab", "tab"));
    layouts.add(new SelectItem("list", "list"));
    
    selectBox = new UISelectBox("layouts", "", layouts);
    add(selectBox);
    
    addActionListener(SaveActionListener.class, SAVE_ACTION) ;
  }
  
  public String getCurrentLayout(){
    ExternalContext eContext = FacesContext.getCurrentInstance().getExternalContext();    
    PortletRequest request = (PortletRequest) eContext.getRequest();        
    PortletPreferences prefs = request.getPreferences();
    return prefs.getValue(UIContentPortlet.LAYOUT, "tabs");        
  }
  
  static public class SaveActionListener extends ExoActionListener {
    public void execute(ExoActionEvent event) throws Exception {
      UIAdminView uiForm = (UIAdminView) event.getComponent() ;
      String value = uiForm.selectBox.getValue();
      if(value != null && !"".equals(value)){
        ExternalContext eContext = FacesContext.getCurrentInstance().getExternalContext();    
        PortletRequest request = (PortletRequest) eContext.getRequest();        
        PortletPreferences prefs = request.getPreferences();
        prefs.setValue(UIContentPortlet.LAYOUT, value);
        prefs.store();        
        Information iprovider = findInformationProvider(uiForm) ;
        iprovider.addMessage(new ExoFacesMessage("#{UIAdminView.msg.view-changed}")) ;        
      }
    }
  }
      
}
