/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portlets.content.display.model;

import org.apache.commons.lang.StringUtils;
import org.exoplatform.portlets.content.display.dynamic.component.ContentConfigConstants;

/**
 * Apr 26, 2004
 * 
 * @author: Tuan Nguyen
 * @email: tuan08@users.sourceforge.net
 * @version: $Id: ContentConfig.java,v 1.1 2004/07/16 09:29:51 oranheim Exp $
 */
public class ContentConfig implements ContentConfigConstants{

  private String name_;

  private String uri_;

  private String position_;

  private String configType_;  
  
  private String documentType_;

  public ContentConfig() {
  }

  public ContentConfig(String name, String[] values) {
    name_ = name;
    for (int i = 0; i < values.length; i++) {
      String[] tmp = StringUtils.split(values[i], "=");
      if (tmp.length == 2) {
        if (URI.equals(tmp[0])) {
          uri_ = tmp[1];
        } else if (POSITION.equals(tmp[0])) {
          position_ = tmp[1];
        } else if (DOCUMENT_TYPE.equals(tmp[0])) {
          documentType_ = tmp[1];
        }  else if (CONFIG_TYPE.equals(tmp[0])) {
          configType_ = tmp[1];
        }
      }
    }
  }

  public String getPosition() {
    return position_;
  }
  public void setPosition(String position) {
    this.position_ = position;
  }

  public String getName() {
    return name_;
  }
  public void setName(String name_) {
    this.name_ = name_;
  }  

  public String getUri() {
    if (uri_ == null)
      uri_ = "";
    return uri_;
  }

  public void setUri(String uri_) {
    this.uri_ = uri_;
  }
  
  public String getConfigType() {
    return configType_;
  }

  public void setConfigType(String configType) {
    this.configType_ = configType;
  }  

  public String getDocumentType() {
    return documentType_;
  }

  public void setDocumentType(String documentType) {
    this.documentType_ = documentType;
  }
  
  public boolean isEntry(){
    if(ENTRY_TYPE.equals(configType_))
        return true;
    return false;
  }

}