/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portlets.content.jcr;

import java.io.IOException;
import javax.jcr.Repository;
import javax.jcr.Session;
import javax.servlet.ServletException;
import javax.servlet.ServletOutputStream;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.exoplatform.commons.utils.ExceptionUtil;
import org.exoplatform.container.PortalContainer;
import org.exoplatform.container.RootContainer;
import org.exoplatform.container.SessionContainer;
import org.exoplatform.services.jcr.RepositoryService;
/**
 * Created by The eXo Platform SARL        .
 * Sun, Dec 28, 2003 @ 14:57 
 * @author: Tuan Nguyen
 * @version: $Id: FileContentServlet.java,v 1.3 2004/06/23 03:19:01 tuan08 Exp $
 * @email: tuan08@yahoo.com
 */
public class JCRExportServlet {
  
  public void service(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
    ServletOutputStream os = response.getOutputStream() ;
    try {
      String path = request.getParameter("path") ;
      String portal = request.getParameter("portal") ;
      if(path == null || path.length() == 0) path = "/" ;
      boolean useDocView = "docview".equals(request.getParameter("doctype"));
      RepositoryService service = getRepositoryService(portal) ;
      Repository repository = service.getRepository(); 
      Session session = repository.login();
      //available mime type: application/octet-stream, 
      response.setContentType("application/octet-stream");
      if(useDocView) {
        session.exportDocumentView(path, os, false, false) ;
      } else {
        session.exportSystemView(path, os, false, false) ;
      }
    } catch (Throwable ex) {
      String s = ExceptionUtil.getStackTrace(ex, 20) ;
      os.println(s) ;
    } finally {
      PortalContainer.setInstance(null) ;
      SessionContainer.setInstance(null) ;
    }
  }
  
  protected RepositoryService getRepositoryService(String portal) throws Exception {
    PortalContainer pcontainer = RootContainer.getInstance().getPortalContainer(portal) ;
    if(pcontainer == null){
      throw new Exception("Cannot find the portal container:  " + portal) ;
    }
    PortalContainer.setInstance(pcontainer) ;
    pcontainer.createSessionContainer("id", "exo");
    RepositoryService service = 
      (RepositoryService) pcontainer.getComponentInstanceOfType(RepositoryService.class) ;    
    return service ;
  }  
  
}