package org.exoplatform.services.cms.actions;

import javax.jcr.PropertyType;
import javax.jcr.RepositoryException;
import javax.jcr.Value;
import javax.jcr.nodetype.NoSuchNodeTypeException;
import javax.jcr.nodetype.NodeDefinition;
import javax.jcr.nodetype.NodeType;
import javax.jcr.nodetype.NodeTypeManager;
import javax.jcr.nodetype.PropertyDefinition;
import javax.jcr.version.OnParentVersionAction;

import org.exoplatform.services.jcr.impl.core.nodetype.NodeTypeImpl;
import org.exoplatform.services.jcr.impl.core.nodetype.PropertyDefinitionImpl;
import org.exoplatform.services.jcr.impl.core.value.StringValue;

public class ActionType extends NodeTypeImpl {

  public ActionType(NodeTypeManager manager) throws NoSuchNodeTypeException, RepositoryException {
    super(manager);
    this.name = "exo:action";
    this.mixin = false;
    this.orderableChild = false;
    this.primaryItemName = null;
    this.declaredSupertypes = new NodeType[1];
    this.declaredSupertypes[0] = manager.getNodeType("nt:base");
    
    this.declaredPropertyDefinitions = new PropertyDefinition[4];
    
    this.declaredPropertyDefinitions[0] = 
      new PropertyDefinitionImpl("exo:name",             //name
                            this,                        //declaringNodeType
                            PropertyType.STRING,         //requiredType
                            null,                        //valueConstraints 
                            NULL_VALUES,                        //defaultValues
                            false,                       //autoCreate       
                            true,                        //mandatory        
                            OnParentVersionAction.IGNORE,//onVersion        
                            false,                       //readOnly         
                            false                        //multiple         
      );

    this.declaredPropertyDefinitions[1] = 
        new PropertyDefinitionImpl("exo:description",    //name
                            this,                        //declaringNodeType
                            PropertyType.STRING,         //requiredType
                            null,                        //valueConstraints 
                            NULL_VALUES,                        //defaultValues
                            false,                       //autoCreate       
                            false,                       //mandatory        
                            OnParentVersionAction.IGNORE,//onVersion        
                            false,                       //readOnly         
                            false                        //multiple         
        );
    
    Value[] defaultType = {new StringValue(ActionServiceContainer.ADD_PHASE)}; 
    this.declaredPropertyDefinitions[2] = 
      new PropertyDefinitionImpl("exo:lifecyclePhase", //name
                          this,                        //declaringNodeType
                          PropertyType.STRING,         //requiredType
                          null,                        //valueConstraints 
                          defaultType,                 //defaultValues
                          false,                       //autoCreate       
                          true,                        //mandatory        
                          OnParentVersionAction.IGNORE,//onVersion        
                          false,                       //readOnly         
                          false                        //multiple         
    );    

    Value[] defaultRoles = {new StringValue("*")};
    this.declaredPropertyDefinitions[3] = 
      new PropertyDefinitionImpl("exo:roles",          //name
                          this,                        //declaringNodeType
                          PropertyType.STRING,         //requiredType
                          null,                        //valueConstraints 
                          defaultRoles,                //defaultValues
                          true,                        //autoCreate       
                          true,                        //mandatory        
                          OnParentVersionAction.IGNORE,//onVersion        
                          false,                       //readOnly         
                          true                         //multiple         
    );        
    
    this.declaredChildNodeDefinitions = new NodeDefinition[0];
  }
}