package org.exoplatform.services.cms.templates.impl;

import javax.jcr.PropertyType;
import javax.jcr.RepositoryException;
import javax.jcr.Value;
import javax.jcr.nodetype.NoSuchNodeTypeException;
import javax.jcr.nodetype.NodeDefinition;
import javax.jcr.nodetype.NodeType;
import javax.jcr.nodetype.NodeTypeManager;
import javax.jcr.nodetype.PropertyDefinition;
import javax.jcr.version.OnParentVersionAction;

import org.exoplatform.services.jcr.impl.core.nodetype.ItemDefinitionImpl;
import org.exoplatform.services.jcr.impl.core.nodetype.NodeTypeImpl;
import org.exoplatform.services.jcr.impl.core.nodetype.PropertyDefinitionImpl;
import org.exoplatform.services.jcr.impl.core.value.StringValue;

public class TemplateType extends NodeTypeImpl {

  public TemplateType(NodeTypeManager manager) throws NoSuchNodeTypeException, RepositoryException {
    super(manager);
    this.name = "exo:template";
    this.mixin = false;
    this.orderableChild = false;
    this.primaryItemName = null;
    this.declaredSupertypes = new NodeType[1];
    this.declaredSupertypes[0] = manager.getNodeType("nt:base");
    
    this.declaredPropertyDefinitions = new PropertyDefinition[2];
    
    this.declaredPropertyDefinitions[0] = 
        new PropertyDefinitionImpl("exo:templateFile",   //name
                            this,                        //declaringNodeType
                            PropertyType.STRING,         //requiredType
                            null,                        //valueConstraints 
                            NULL_VALUES,                        //defaultValues
                            false,                       //autoCreate       
                            true,                        //mandatory        
                            OnParentVersionAction.IGNORE,//onVersion        
                            false,                       //readOnly         
                            false                        //multiple         
        );

    Value[] defaultRoles = {new StringValue(ItemDefinitionImpl.RESIDUAL_SET)};
    this.declaredPropertyDefinitions[1] = 
      new PropertyDefinitionImpl("exo:roles",          //name
                          this,                        //declaringNodeType
                          PropertyType.STRING,         //requiredType
                          null,                        //valueConstraints 
                          defaultRoles,                //defaultValues
                          true,                        //autoCreate       
                          true,                        //mandatory        
                          OnParentVersionAction.IGNORE,//onVersion        
                          false,                       //readOnly         
                          true                         //multiple         
    );        
    
    this.declaredChildNodeDefinitions = new NodeDefinition[0];
  }
}
