package org.exoplatform.portlets.calendar;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.Iterator;
import java.util.List;

import javax.jcr.Node;
import javax.jcr.RepositoryException;

import org.exoplatform.container.PortalContainer;
import org.exoplatform.portlets.calendar.component.UICalendar;
import org.exoplatform.portlets.calendar.component.UICalendarPortlet;
import org.exoplatform.services.calendar.CalendarService;

public class Utils {
	private CalendarService calendarService_ ;

	public void Utils() {
    PortalContainer manager = PortalContainer.getInstance();
    CalendarService calendarService = (CalendarService) manager.getComponentInstanceOfType(CalendarService.class);
	}

	private static Collection getCalendarsNames(Collection list) {
		if (list == null) return null ;
		List nameList = new ArrayList() ;
		Iterator iter = list.iterator() ;
		while (iter.hasNext()) {
			Node node = (Node) iter.next() ;
			try {
				nameList.add(node.getName()) ;
			} catch (RepositoryException e) {
				return null ;
			}
		}
		Collections.sort(nameList) ;
		return nameList ;
	}
	
	public static Collection getPrivateCalendars(String user) {
    PortalContainer manager = PortalContainer.getInstance();
    CalendarService calendarService = (CalendarService) manager.getComponentInstanceOfType(CalendarService.class);
		List l = new ArrayList() ;
		try {
			l = (List) calendarService.getPrivateCalendars(user) ;
		} catch (Exception e) {
			e.printStackTrace() ;
			return null ;
		}
		return l ;
	}
	
	public static Collection getPrivateCalendarsName(String user) {
		return getCalendarsNames(getPrivateCalendars(user)) ;
	}
	
	public static Collection getPublicCalendars(String user) {
    PortalContainer manager = PortalContainer.getInstance();
    CalendarService calendarService = (CalendarService) manager.getComponentInstanceOfType(CalendarService.class);
		List l = new ArrayList() ;
		try {
			l = (List) calendarService.getPublicCalendars(user) ;
		} catch (Exception e) {
			e.printStackTrace() ;
			return null ;
		}
		return l ;
	}
	
	public static Collection getPublicCalendarsName(String user) {
		return getCalendarsNames(getPublicCalendars(user)) ;
	}
}
