/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portlets.pmanager.component;

import java.util.ArrayList;
import java.util.List;
import javax.faces.component.UIComponent;
import org.exoplatform.faces.core.component.model.SelectItem;
import org.exoplatform.faces.search.component.UISearchBar;
import org.exoplatform.faces.search.component.UISearcher;
import org.exoplatform.services.jcr.index.JCRIndexerPlugin;
import org.exoplatform.services.pmanager.Project;
import org.exoplatform.services.indexing.IndexingService;
import org.exoplatform.services.indexing.Searcher;
/**
 * @author Tuan Nguyen (tuan08@users.sourceforge.net)
 * @since Aug 27, 2004
 * @version $Id$
 */
public class UIDocumentSearcher extends UISearcher {
  private JCRIndexerPlugin plugin_ ;
  
  public UIDocumentSearcher(IndexingService service) throws Exception {
  	setId("UISearcher") ;
    plugin_ = (JCRIndexerPlugin)service.getIndexerPlugin(JCRIndexerPlugin.MODULE) ;
    init(service) ;
    getChildren().add(new UIDocuments());
  }
  
  public void setData(Project project, Class backComponent) throws Exception { 
    UIDocuments uiDocuments = (UIDocuments)getChildComponentOfType(UIDocuments.class) ;
    uiDocuments.setData(project, backComponent) ;
    setRenderedComponent(UIDocuments.class) ;
  } 
  
  public Searcher getSearcher()  throws Exception {
    Searcher searcher = plugin_.getSearcher();
    return searcher ;
  }
  
  protected UIComponent customizeUISearchBar(IndexingService service ) throws Exception {
    UISearchBar uiBar =  new UISearchBar();
    List options = new ArrayList() ;
    options.add(new SelectItem("#{UIDocumentSearcher.label.all}", ""));
    options.add(new SelectItem("#{UIDocumentSearcher.label.owner}", JCRIndexerPlugin.OWNER_FIELD) );
    options.add(new SelectItem("#{UIDocumentSearcher.label.document}", JCRIndexerPlugin.DATA_FIELD));
    uiBar.setSearchOptions(options) ;
    return uiBar ;
  }
  
  public void showAdvancedSearch() throws Exception {
    this.setRenderedComponent(UIDocumentAdvancedSearch.class) ;
  }
  
  protected UIComponent customizeUIAdvancedSearch(IndexingService service) throws Exception {
    return new UIDocumentAdvancedSearch()  ;
  }
}