/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portlets.pmanager.component;

import org.exoplatform.faces.core.component.UISimpleForm;
import org.exoplatform.faces.core.component.UIStringInput;
import org.exoplatform.faces.core.component.UITextArea;
import org.exoplatform.faces.core.event.ExoActionEvent;
import org.exoplatform.faces.core.event.ExoActionListener;
import org.exoplatform.services.pmanager.Project;
import org.exoplatform.services.pmanager.ProjectUtil;
/**
 * @email:   tuan08@users.sourceforge.net
 * @version: $Id$
 */
public class UIProjectComponentForm extends UISimpleForm {
  static String NAME= "name".intern(), DESCRIPTION = "description".intern() ;

  Project project_ ;
  Class backComponent_ ;
  
  public UIProjectComponentForm() {
    super("UIProjectComponentForm", "post", null) ;
    setId("UIProjectComponentForm") ;
    setRendererType("SimpleFormVelocityRenderer") ;
    add(new UIStringInput(NAME, "")) ;
    add(new UITextArea(DESCRIPTION, "")) ;
   
    addActionListener(SaveActionListener.class, SAVE_ACTION)  ;
    addActionListener(CancelActionListener.class, CANCEL_ACTION)  ;
  }
  
  public void setData(Project project, Class backComponent) {
    project_  = project ;
    backComponent_ = backComponent ;
  }
  
  static public class SaveActionListener extends ExoActionListener {
		public void execute(ExoActionEvent event) throws Exception {
      UIProjectComponentForm uiForm = (UIProjectComponentForm) event.getComponent() ;
      String name = uiForm.getUIStringInput(NAME).getValue() ;
      String description = uiForm.getUIStringInput(DESCRIPTION).getValue() ;
      ProjectUtil.createComponent(uiForm.project_, name, description) ;
      uiForm.project_.save() ;
      uiForm.setRenderedSibling(uiForm.backComponent_);
		}
	}
  
  static public class CancelActionListener extends ExoActionListener {
		public void execute(ExoActionEvent event) throws Exception {
      UIProjectComponentForm uiForm = (UIProjectComponentForm) event.getComponent() ;
      uiForm.setRenderedSibling(uiForm.backComponent_);
		}
	}
}