/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portlets.pmanager.component;

import org.exoplatform.faces.core.component.UISimpleForm;
import org.exoplatform.faces.core.component.UIStringInput;
import org.exoplatform.faces.core.event.ExoActionEvent;
import org.exoplatform.faces.core.event.ExoActionListener;
import org.exoplatform.services.pmanager.ProjectManager;
/**
 * @email:   tuan08@users.sourceforge.net
 * @version: $Id$
 */
public class UIProjectForm extends UISimpleForm {
  static String NAME= "name", DESCRIPTION = "description"  ;
  
  ProjectManager pmanager_ ;
  
  public UIProjectForm() {
    super("projectForm", "post", null) ;
    setId("UIProjectForm") ;
    setClazz("UIExoForm") ;
    setRendererType("SimpleFormVelocityRenderer") ;
    add(new UIStringInput(NAME, "")) ;
    add(new UIStringInput(DESCRIPTION, "")) ;
   
    addActionListener(SaveActionListener.class, SAVE_ACTION)  ;
    addActionListener(CancelActionListener.class, CANCEL_ACTION)  ;
  }
  
  public void setProjectManager(ProjectManager manager) {
    pmanager_ = manager ;
  }
  
  static public class SaveActionListener extends ExoActionListener {
		public void execute(ExoActionEvent event) throws Exception {
      UIProjectForm uiForm = (UIProjectForm) event.getComponent() ;
      uiForm.setRenderedSibling(UIProjectManager.class) ;
      String name = uiForm.getUIStringInput(NAME).getValue() ;
      String description = uiForm.getUIStringInput(DESCRIPTION).getValue() ;
      uiForm.pmanager_.createProject(name, description, "exo") ;
      UIProjectManager uicomp = 
        (UIProjectManager) uiForm.getSibling(UIProjectManager.class) ;
      uicomp.update() ;
      uiForm.setRenderedSibling(UIProjectManager.class);
		}
	}
  
  static public class CancelActionListener extends ExoActionListener {
		public void execute(ExoActionEvent event) throws Exception {
      UIProjectForm uiForm = (UIProjectForm) event.getComponent() ;
      uiForm.setRenderedSibling(UIProjectManager.class);
		}
	}
}