/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portlets.pmanager.component;

import org.exoplatform.faces.core.component.UICommandPortlet ;
import org.exoplatform.faces.core.component.UIToolbar;
import org.exoplatform.faces.core.component.model.Button;
import org.exoplatform.faces.core.component.model.Parameter;
import org.exoplatform.faces.core.event.ExoActionEvent;
import org.exoplatform.faces.core.event.ExoActionListener;
import org.exoplatform.services.pmanager.ProjectManager;
/**
 * Wed, Dec 22, 2003 @ 23:14 
 * @author: Tuan Nguyen
 * @email:   tuan08@users.sourceforge.net
 * @version: $Id: UIFilePortlet.java,v 1.3 2004/08/17 13:07:02 tuan08 Exp $
 */
public class UIProjectManagerPortlet extends UICommandPortlet {
  static String VIEW_DEFAULT = "viewDefault" ;
  static String NEW_PROJECT = "newProject" ;
  static String LIST_MANAGERS = "listManagers" ;
  static String ADD_URI = "addURI" ;
  static String NEW_PMANAGER = "new" ;
  
  static Parameter[] VIEW_DEFAULT_PARAMS = { new Parameter(ACTION , VIEW_DEFAULT)} ;
  static Parameter[] NEW_PROJECT_PARAMS = { new Parameter(ACTION , NEW_PROJECT)} ;
  static Parameter[] LIST_MANAGERS_PARAMS = { new Parameter(ACTION , LIST_MANAGERS)} ;
  static Parameter[] ADD_URI_PARAMS = { new Parameter(ACTION , ADD_URI)} ;
  static Parameter[] NEW_PMANAGER_PARAMS = { new Parameter(ACTION , NEW_PMANAGER)} ;
  
  public UIProjectManagerPortlet() throws Exception {
    setRendererType("ChildrenRenderer") ;
    UIToolbar uitoolbar = new UIToolbar("UIToolbar");  
    uitoolbar.addLeftButton(new Button("#{UIProjectManagerPortlet.button.view-default}", VIEW_DEFAULT_PARAMS));
    uitoolbar.addLeftButton(new Button("#{UIProjectManagerPortlet.button.new-project}", NEW_PROJECT_PARAMS));
    
    uitoolbar.addRightButton(new Button("#{UIProjectManagerPortlet.button.list-managers}", LIST_MANAGERS_PARAMS)); 
    uitoolbar.addRightButton(new Button("#{UIProjectManagerPortlet.button.add-uri}", ADD_URI_PARAMS)); 
    uitoolbar.addRightButton(new Button("#{UIProjectManagerPortlet.button.new}", NEW_PMANAGER_PARAMS)); 
    getChildren().add(uitoolbar) ; 
    
    addChild(UIProjectManager.class) ;
    addChild(UIProjectManagers.class).setRendered(false) ;
    addChild(UIProjectManagerForm.class).setRendered(false) ;
    addChild(UIAddURIForm.class).setRendered(false) ;
    addChild(UIProjectForm.class).setRendered(false) ;
    addChild(UIDocumentForm.class).setRendered(false) ;
    addChild(UIDocumentSearcher.class).setRendered(false) ;
    addChild(UIDocument.class).setRendered(false) ;
    addChild(UIIssueForm.class).setRendered(false) ;
    addChild(UIIssueSearcher.class).setRendered(false) ;
    addChild(UIIssue.class).setRendered(false) ;
    addChild(UIUploadForm.class).setRendered(false) ;
    addChild(UIProjectVersionForm.class).setRendered(false) ;
    addChild(UIProjectVersions.class).setRendered(false) ;
    addChild(UIProjectComponentForm.class).setRendered(false) ;
    addChild(UIProjectComponents.class).setRendered(false) ;
    addChild(UIProjectParticipants.class).setRendered(false) ;
    addChild(UIProjectParticipantForm.class).setRendered(false) ;
    addChild(UITaskForm.class).setRendered(false) ;
    addChild(UICommentForm.class).setRendered(false) ;
    addChild(UIProjectPermissionsForm.class).setRendered(false) ;
    
    addActionListener(ViewDefaultActionListener.class, VIEW_DEFAULT) ;
    addActionListener(ListManagersActionListener.class, LIST_MANAGERS) ;
    addActionListener(AddURIActionListener.class, ADD_URI) ;
    addActionListener(NewActionListener.class, NEW_PMANAGER) ;
    addActionListener(NewProjectActionListener.class, NEW_PROJECT) ;
  }
  
  static public class ViewDefaultActionListener extends ExoActionListener {
    public void execute(ExoActionEvent event) throws Exception {
      UIProjectManagerPortlet uicomp = (UIProjectManagerPortlet) event.getComponent() ;
      uicomp.setRenderedComponent(UIProjectManager.class) ;
    }
  }
  
  static public class ListManagersActionListener extends ExoActionListener {
    public void execute(ExoActionEvent event) throws Exception {
      UIProjectManagerPortlet uicomp = (UIProjectManagerPortlet) event.getComponent() ;
      uicomp.setRenderedComponent(UIProjectManagers.class) ;
    }
  }
  
  static public class AddURIActionListener extends ExoActionListener {
    public void execute(ExoActionEvent event) throws Exception {
      UIProjectManagerPortlet uicomp = (UIProjectManagerPortlet) event.getComponent() ;
      UIAddURIForm uiForm = (UIAddURIForm) uicomp.getChildComponentOfType(UIAddURIForm.class) ;
      uiForm.reset() ;
      uicomp.setRenderedComponent(UIAddURIForm.class) ;
    }
  }
  
  static public class NewActionListener extends ExoActionListener {
    public void execute(ExoActionEvent event) throws Exception {
      UIProjectManagerPortlet uicomp = (UIProjectManagerPortlet) event.getComponent() ;
      UIProjectManagerForm uiForm = 
        (UIProjectManagerForm) uicomp.getChildComponentOfType(UIProjectManagerForm.class) ;
      uiForm.reset() ;
      uicomp.setRenderedComponent(UIProjectManagerForm.class) ;
    }
  }
  
  static public class NewProjectActionListener extends ExoActionListener {
    public void execute(ExoActionEvent event) throws Exception {
      UIProjectManagerPortlet uicomp = (UIProjectManagerPortlet) event.getComponent() ;
      UIProjectManager uiProjectManager = 
        (UIProjectManager) uicomp.getChildComponentOfType(UIProjectManager.class) ;
      ProjectManager pmanager = uiProjectManager.getProjectManager() ;
      UIProjectForm uiForm = 
        (UIProjectForm) uicomp.getChildComponentOfType(UIProjectForm.class) ;
      uiForm.setProjectManager(pmanager) ;
      uicomp.setRenderedComponent(UIProjectForm.class) ;
    }
  }
}