/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portlets.pmanager.component;

import javax.jcr.Node;
import javax.jcr.NodeIterator;
import org.exoplatform.faces.core.component.UIExoCommand;
import org.exoplatform.faces.core.component.model.Parameter;
import org.exoplatform.faces.core.event.ExoActionEvent;
import org.exoplatform.faces.core.event.ExoActionListener;
import org.exoplatform.services.pmanager.Project;
import org.exoplatform.services.pmanager.Constant ;
/**
 * @email:   tuan08@users.sourceforge.net
 * @version: $Id$
 */
public class UIProjectVersions extends UIExoCommand {
  static String CREATE_VERSION = "createIssue".intern() ;      
  static Parameter[] CREATE_VERSION_PARAMS = { new Parameter(ACTION , CREATE_VERSION)} ;
  
  Project project_ ;
  
  public UIProjectVersions() throws Exception {
    setRendererType("VelocityRenderer") ;
    addActionListener(CreateIssueActionListener.class, CREATE_VERSION)  ;
  }
 
  public Parameter[] getCreateVersionParams() { return CREATE_VERSION_PARAMS ; }
  
  public void setData(Project project, Class backComponent) throws Exception { 
    project_ = project ;
  } 
 
  public NodeIterator getVersions() throws Exception {
    return project_.getVersions() ;
  }
  
  public String getVersionNumber(Node node) throws Exception {
    return node.getProperty(Constant.PROJECT_VERSION_NUMBER).getString() ;
  }
  
  public String getVersionName(Node node) throws Exception {
    return node.getProperty(Constant.PROJECT_VERSION_NAME).getString() ;
  }
  
  public String getVersionDescription(Node node) throws Exception {
    return node.getProperty(Constant.PROJECT_VERSION_DESCRIPTION).getString() ;
  }
  
  static public class CreateIssueActionListener extends ExoActionListener {
    public void execute(ExoActionEvent event) throws Exception {
      UIProjectVersions uicomp = (UIProjectVersions) event.getComponent() ;
    }
  }
}