package org.exoplatform.services.calendar ;

import java.util.Calendar ;
import java.util.Collection ;
import java.util.Map ;
import javax.jcr.Node ;

public interface CalendarService {
	
	public final static String DEFAULT_CALENDAR = "default" ;
	public final static String PRIVATE_CALENDAR_TYPE = "private" ;
	public final static String PUBLIC_CALENDAR_TYPE = "public" ;
	public final static String DEFAULT_CALENDAR_TYPE = PRIVATE_CALENDAR_TYPE ;

	public void createUserCalendarIfNeeded(String user) throws Exception ;
	public void createUserCalendar(String user) throws Exception ;
	public void removeUserCalendar(String user) throws Exception ;

	public void createCalendar(String user, String calendarType, String calendarName) ;
	public void renameCalendar(String user, String oldCalendarType, String oldCalendarName, 
			String newCalendarType, String newCalendarName) ;
	public void removeCalendar(String user, String calendarType, String calendarName) ;
	public void removeCalendar(Node calendarNode) ;
	
	public String saveCalendarEvent(String user, String calendarType, String calendarName, Map rawInputs) throws Exception ;
	public String saveCalendarEvent(String user, Map rawInputs) throws Exception ;

	public Node removeCalendarEvent(String id) throws Exception ;
	public Node removeCalendarEvent(String user, String id) throws Exception ;
	public Node removeCalendarEvent(Node eventNode) throws Exception ;
	
  public Collection getCalendars(String user, String type) ;
  public Collection getPrivateCalendars(String user) ;
  public Collection getPublicCalendars(String user) ;
  public Node getCalendar(String user, String calendarType, String calendarName) ;
	
	public Node getCalendarEventById(String id) throws Exception ;
	public Node getCalendarEventByUserAndId(String user, String id) throws Exception ;
	public Node getCalendarEventByPath(String nodePath) throws Exception ;
	public Collection getCalendarEventByUserAndDate(String user, String calendareShareType, String calendarName, 
					Calendar date) throws Exception ;
	
	
}