/***************************************************************************
 * Copyright 2001-2005 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.services.calendar.impl;

import javax.jcr.PropertyType;
import javax.jcr.RepositoryException;
import javax.jcr.nodetype.NoSuchNodeTypeException;
import javax.jcr.nodetype.NodeDefinition;
import javax.jcr.nodetype.NodeType;
import javax.jcr.nodetype.NodeTypeManager;
import javax.jcr.nodetype.PropertyDefinition;
import javax.jcr.version.OnParentVersionAction;

//import org.exoplatform.services.jcr.impl.core.nodetype.ItemDefinitionImpl;
//import org.exoplatform.services.jcr.impl.core.nodetype.NodeDefinitionImpl;
import org.exoplatform.services.jcr.impl.core.nodetype.ItemDefinitionImpl;
import org.exoplatform.services.jcr.impl.core.nodetype.NodeDefinitionImpl;
import org.exoplatform.services.jcr.impl.core.nodetype.NodeTypeImpl;
import org.exoplatform.services.jcr.impl.core.nodetype.PropertyDefinitionImpl;

public class CalendarType extends NodeTypeImpl {

  public CalendarType(NodeTypeManager manager) throws NoSuchNodeTypeException, RepositoryException {
    super(manager);
    this.name = "exo:calendar";
    this.mixin = false;
    this.orderableChild = false;
    this.primaryItemName = null;
    this.declaredSupertypes = new NodeType[1];
    this.declaredSupertypes[0] = manager.getNodeType("nt:base");
    
    this.declaredPropertyDefinitions = new PropertyDefinition[1];
     // shared
     this.declaredPropertyDefinitions[0] = 
         new PropertyDefinitionImpl("exo:shared",        //name
                            this,                        //declaringNodeType
                            PropertyType.BOOLEAN,        //requiredType
                            null,                        //valueConstraints 
                            null,                        //defaultValues
                            false,                       //autoCreate       
                            false,                        //mandatory        
                            OnParentVersionAction.IGNORE,//onVersion        
                            false,                       //readOnly         
                            false                        //multiple         
        ); 
       
     this.declaredChildNodeDefinitions = new NodeDefinition[1];
     NodeType[] types = {manager.getNodeType("exo:calendarEventShareCategory")};

     this.declaredChildNodeDefinitions[0] = new NodeDefinitionImpl(
         ItemDefinitionImpl.RESIDUAL_SET,  // name
         this,                             // declaringNodeType
         types,                            // requiredNodeTypes
         null,                             // defaultNodeType  
         false,                            // autoCreate       
         false,                            // mandatory        
         OnParentVersionAction.IGNORE,     // onVersion        
         false,                            // protected        
         false                             // same-name sibling
         );
  }
}
