/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.services.forum.hibernate;

import org.exoplatform.services.backup.XMLObjectConverter;
import org.exoplatform.xml.object.XMLObject;
/**
 * @author Tuan Nguyen (tuan08@users.sourceforge.net)
 * @since Apr 20, 2005
 * @version $Id$
 */
public class V11XMLObjectConverter extends XMLObjectConverter {
  static String CATEGORY_TYPE = CategoryImpl.class.getName().intern() ;
  static String FORUM_TYPE = ForumImpl.class.getName().intern() ;
  static String TOPIC_TYPE = TopicImpl.class.getName().intern() ;
  static String TOPIC_BACKUP = TopicBackup.class.getName().intern() ;
  static String POST_TYPE = PostImpl.class.getName().intern() ;
  
  static String CATEGORY_TYPE_V1 = "org.exoplatform.services.communication.forum.hibernate.CategoryImpl";
  static String FORUM_TYPE_V1 = "org.exoplatform.services.communication.forum.hibernate.ForumImpl" ;
  static String TOPIC_TYPE_V1 = "org.exoplatform.services.communication.forum.hibernate.TopicImpl" ;
  static String POST_TYPE_V1 = "org.exoplatform.services.communication.forum.hibernate.PostImpl" ;
  static String TOPIC_BACKUP_V1 = "org.exoplatform.services.communication.forum.hibernate.TopicBackup";

  public void update(XMLObject xmlobject) {
    String type = xmlobject.getType() ;   
    if(CATEGORY_TYPE.equals(type) || CATEGORY_TYPE_V1.equals( type) ) {
      try{
        xmlobject.setType( CategoryImpl.class.getName());        
      }catch( Exception exp){
        exp.printStackTrace();
      }
    } else if(FORUM_TYPE.equals(type) || FORUM_TYPE_V1.equals(type)) {
      try{
        xmlobject.setType( ForumImpl.class.getName());        
      }catch( Exception exp){
        exp.printStackTrace();
      }
    } else if(TOPIC_TYPE.equals(type) || TOPIC_TYPE_V1.equals(type)) {
      try{
        xmlobject.setType( TopicImpl.class.getName());
      }catch( Exception exp){
        exp.printStackTrace();
      }
    } else if(POST_TYPE.equals(type) || POST_TYPE_V1.equals(type)) {
      try{
        xmlobject.setType( PostImpl.class.getName());
      }catch( Exception exp){
        exp.printStackTrace();
      }
    } else if(TOPIC_BACKUP.equals(type) || TOPIC_BACKUP_V1.equals(type)) {
      try{
        xmlobject.setType( TopicBackup.class.getName());
      }catch( Exception exp){
        exp.printStackTrace();
      }
    }
    
  }
  public void pack(XMLObject xmlobject) {
    
  }
}
