/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.services.pmanager.test;

import javax.jcr.Node;
import javax.jcr.Repository;
import javax.jcr.Session;
import javax.jcr.SimpleCredentials;

import junit.framework.TestCase;

import org.exoplatform.container.PortalContainer;
import org.exoplatform.container.RootContainer;
import org.exoplatform.container.SessionContainer;
import org.exoplatform.container.client.MockClientInfo;
import org.exoplatform.services.cms.templates.TemplateService;
import org.exoplatform.services.log.LogService;
import org.exoplatform.services.organization.OrganizationService;
import org.exoplatform.services.pmanager.ProjectManagerService;

import com.sun.corba.se.impl.activation.RepositoryImpl;

/**
 * @author Tuan Nguyen
 */
public class BaseTest extends TestCase{
  
  protected static final String WORKSPACE = "ws";
  protected Repository jcrRepository_;
  protected SimpleCredentials credentials_;
  protected OrganizationService orgService;
  protected TemplateService tservice_;
  
  protected ProjectManagerService pmservice_ ;

  public void setUp() throws Exception{
    PortalContainer pcontainer  = PortalContainer.getInstance();
    LogService service = (LogService) RootContainer.getInstance().
      getComponentInstanceOfType(LogService.class);    
    service.setLogLevel("org.exoplatform.services.jcr", LogService.DEBUG, true);    
    RepositoryService jcrService = (RepositoryService) pcontainer.
       getComponentInstanceOfType(RepositoryService.class);    
    jcrRepository_ = jcrService.getRepository();           
    
    SessionContainer scontainer = PortalContainer.getInstance().createSessionContainer("id", "exo");
    scontainer.setClientInfo(new MockClientInfo()) ;
    
    if(System.getProperty("java.security.auth.login.config") == null)
      System.setProperty("java.security.auth.login.config", "src/resource/login.conf" );    
    
    credentials_ = new SimpleCredentials("exo", "exo".toCharArray());
    
    if(!((RepositoryImpl) jcrRepository_).isWorkspaceInitialized("ws"));
    ((RepositoryImpl) jcrRepository_).initWorkspace("ws", "nt:unstructured");
    Session session = jcrRepository_.login(credentials_, WORKSPACE );
    Node root = session.getRootNode();
    Node cms  = root.addNode("cms", "exo:resource") ;
    root.save() ;
    
    orgService = (OrganizationService)pcontainer.getComponentInstanceOfType(OrganizationService.class);    
    tservice_ = (TemplateService) pcontainer.getComponentInstanceOfType(TemplateService.class);
    pmservice_ = (ProjectManagerService) pcontainer.getComponentInstanceOfType(ProjectManagerService.class);
  }
}
