/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.services.pmanager.test;

import javax.jcr.Node;
import javax.jcr.Session;
import javax.jcr.nodetype.NodeDefinition;
import javax.jcr.nodetype.NodeType;
import org.exoplatform.services.pmanager.Project;
import org.exoplatform.services.pmanager.ProjectUtil ;
import org.exoplatform.services.pmanager.ProjectManager;

/**
 * @author Tuan Nguyen
 */
public class TestProjectManagerNodeTypes extends BaseTest{

  public void testArticleNodeType() throws Exception{
    Session session = jcrRepository_.login(WORKSPACE);
    ProjectManager pmanager = pmservice_.getProjectManager(null ,"/cms/ProjectManager") ;
    
    Project project = pmanager.createProject("project","a description", "admin") ;
    ProjectUtil.createVersion(project, "1.0", "Version 1.0", "This is a test") ;
    ProjectUtil.createComponent(project,"component", "This is a test") ;
    project.createDocument("admin", "mydocument1", "text/plain") ;
    project.createDocument("admin", "mydocument2", "text/plain") ;
    
    Node issueNode1 = project.createIssue("admin", "bug") ;
    issueNode1.setProperty("exo:summary", "test bug 1");
    
    Node commentsNode = issueNode1.getNode("comments");
    Node commentNode = commentsNode.addNode("comment1", "exo:comment");
    commentNode.setProperty("exo:owner", "admin");
    
    Node tasksNode = issueNode1.getNode("tasks");
    Node taskNode = tasksNode.addNode("task1", "exo:task");
    taskNode.setProperty("exo:assignee", "admin");
    taskNode.setProperty("exo:todo", "create a bug tracker");
    
    session.save();
  }
  
  private void printNodeDefinition(Node node) throws Exception {
    NodeDefinition def = node.getDefinition();
    NodeType nodeType = def.getDeclaringNodeType();
    NodeDefinition[] defs = nodeType.getDeclaredChildNodeDefinitions();
    for (int i = 0; i < defs.length; i++) {
      System.out.println("NAMEEEEEE " + defs[i].getName());
    }
  }
  
}
