package org.exoplatform.faces.captchas.component;

import org.exoplatform.container.PortalContainer;
import org.exoplatform.faces.core.component.UIStringInput;
import org.exoplatform.services.idgenerator.IDGeneratorService;

import com.sun.org.apache.bcel.internal.generic.GETFIELD;

public class UICaptchaInput extends UIStringInput {

  public static final String COMPONENT_FAMILY = "org.exoplatform.faces.captchas.component.UICaptchaInput";
  
  private String captchaId;

  public UICaptchaInput(String name, String text) {
    super(name, text);
    setRendererType("CaptchaInputRenderer");
    IDGeneratorService generator = (IDGeneratorService) PortalContainer
        .getInstance().getComponentInstanceOfType(IDGeneratorService.class);
    this.captchaId = generator.generateStringID(this); 
  }

  public String getCaptchaId() {
    return this.captchaId;
  }
  
  public String getLocale() {
    return "en";
  }
  
  public String getFamily() {
    return COMPONENT_FAMILY;
  }

}
