package org.exoplatform.faces.captchas.validator;

import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.validator.Validator;
import javax.faces.validator.ValidatorException;

import org.exoplatform.container.RootContainer;
import org.exoplatform.faces.application.ExoFacesMessage;
import org.exoplatform.faces.captchas.component.UICaptchaInput;

import com.octo.captcha.service.image.ImageCaptchaService;

public class ConfirmCaptchaValidator implements Validator {
  
  public void validate(FacesContext context, 
      UIComponent component, 
      Object value) throws ValidatorException {
    String s = (String) value ;
    UICaptchaInput input = (UICaptchaInput)component;
    String captchaId = input.getCaptchaId();
    
    ImageCaptchaService captchaService = (ImageCaptchaService) RootContainer.
    getInstance().getComponentInstanceOfType(ImageCaptchaService.class);    
    Boolean isChallenge = captchaService.validateResponseForID(captchaId, value);
    if(!isChallenge.booleanValue()) {            
      throw new ValidatorException(new ExoFacesMessage("#{UICaptchaInput.msg.wrong-answer}")) ;
    }    
  }
}
