package org.exoplatform.services.captchas;

import java.awt.image.BufferedImage;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.util.Locale;

import org.exoplatform.container.RootContainer;

import com.octo.captcha.service.image.ImageCaptchaService;
import com.sun.image.codec.jpeg.JPEGCodec;
import com.sun.image.codec.jpeg.JPEGImageEncoder;

import junit.framework.TestCase;

public class TestCaptchaService extends TestCase {
 
  
  private ImageCaptchaService captchaService;

  public void setUp() throws Exception {
    if(this.captchaService == null) {
      this.captchaService = (ImageCaptchaService) RootContainer
        .getInstance().getComponentInstanceOfType(ImageCaptchaService.class);
    }
  }
  
  public void testGetChallenge() throws Exception {
    BufferedImage challenge = captchaService.getImageChallengeForID("id", 
        new Locale("en"));        
    FileOutputStream os = new FileOutputStream(new File("target/my_file.jpg"));        
    JPEGImageEncoder jpegEncoder = JPEGCodec.createJPEGEncoder(os);
    jpegEncoder.encode(challenge);    
    os.close();        
  }

}
