/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please visit http://www.exoplatform.org for more license detail.        *
 **************************************************************************/

package org.exoplatform.eclipse.core.extension;

import org.eclipse.core.runtime.IConfigurationElement;
import org.eclipse.core.runtime.IExtension;

/**
 * An interface to be implemented by classes interested in processing the top
 * configuration elements for extensions.
 *
 * @author Hatim Khan
 * @version $Revision: 1.1 $
 */
public interface IExtensionProcessor
{
  public static final String CLASS_VERSION = "$Id: IExtensionProcessor.java,v 1.1 2004/04/19 03:45:46 hatimk Exp $"; //$NON-NLS-1$

  /**   
   * For each top configuration element of each extension this method gets
   * called.
   *
   * @param pExtension the extension that contains the given element
   * @param pMember the top configuration element contained in the given
   *        extension
   * @param pResultCollector an object that can be used to hold the result
   */
  public void process(IExtension pExtension, IConfigurationElement pMember,
    Object pResultCollector);
}
