/***************************************************************************
 * Copyright 2001-2004 The eXo Platform SARL         All rights reserved.  *
 * Please visit http://www.exoplatform.org for more license detail.        *
 **************************************************************************/

package org.exoplatform.eclipse.core.launching;

import org.exoplatform.eclipse.core.ExoCorePlugin;

/**
 * DOCUMENT ME!
 * 
 * @author Hatim Khan
 * @version $Revision: 1.1 $
 */
public interface IExoLaunchingConfigurationConstants
{
  public static final String CLASS_VERSION = "$Id: IExoLaunchingConfigurationConstants.java,v 1.1 2004/09/20 01:39:13 hatimk Exp $"; //$NON-NLS-1$

  /**
   * Launch configuration attribute key. The value is the id (String) of an eXo Tomcat
   * runtime configuration provider.
   */
  public static final String ATTR_EXO_TOMCAT_RUNTIME_CONFIGURATION_PROVIDER_ID = ExoCorePlugin.PLUGIN_ID
      + "ATTR_EXO_TOMCAT_RUNTIME_CONFIGURATION_PROVIDER_ID"; //$NON-NLS-1$

  /**
   * Launch configuration attribute key. The value is location of Tomcat installation.
   */
  public static final String ATTR_TOMCAT_INSTALLATION_DIR = ExoCorePlugin.PLUGIN_ID
      + "ATTR_TOMCAT_INSTALLATION_DIR"; //$NON-NLS-1$

  /**
   * Launch configuration attribute key. The value is location of Tomcat source
   * installation.
   */
  public static final String ATTR_TOMCAT_SOURCE_DIR = ExoCorePlugin.PLUGIN_ID + "ATTR_TOMCAT_SOURCE_DIR"; //$NON-NLS-1$

  /**
   * Launch configuration attribute key. The value is location of eXo source installation.
   */
  public static final String ATTR_EXO_SOURCE_DIR = ExoCorePlugin.PLUGIN_ID + "ATTR_EXO_SOURCE_DIR"; //$NON-NLS-1$

  /**
   * Launch configuration attribute key. The value is a list of portlet names (String).
   */
  public static final String ATTR_PORTLET_PROJECT_LIST = ExoCorePlugin.PLUGIN_ID
      + "ATTR_PORTLET_PROJECT_LIST"; //$NON-NLS-1$

  /**
   * Launch configuration attribute key. The value is a boolean to determine if we are
   * shuting down rather starting up an eXo platform. Null value means false.
   */
  public static final String ATTR_EXO_SHUTDOWN = ExoCorePlugin.PLUGIN_ID + "ATTR_EXO_SHUTDOWN"; //$NON-NLS-1$

}