/***************************************************************************
 * Copyright 2001-2004 The eXo Platform SARL         All rights reserved.  *
 * Please visit http://www.exoplatform.org for more license detail.        *
 **************************************************************************/

package org.exoplatform.eclipse.core.launching;

import org.eclipse.core.runtime.IPath;
import org.eclipse.jdt.launching.IRuntimeClasspathEntry;


/**
 * Used to represent a Tomcat Runtime Configuration.
 * 
 * For an example of the implemenation, please see GenericTomcatConfiguration. 
 *
 * @author Hatim Khan
 * @version $Revision: 1.1 $
 */
public interface ITomcatRuntimeConfiguration
{
  public static final String CLASS_VERSION = "$Id: ITomcatRuntimeConfiguration.java,v 1.1 2004/09/20 01:39:14 hatimk Exp $"; //$NON-NLS-1$
	public String getConfigurationId();  
  public String getConfigurationName();
  public String getMainTypeName();
  public String[] getStartupProgramArguments();
  public String[] getShutdownProgramArguments();
  public IPath getWorkingDirectory();
	public IRuntimeClasspathEntry[] getBinLibraries();  
	public IRuntimeClasspathEntry[] getServerLibraries();	
  public IRuntimeClasspathEntry[] getCommonLibraries();
  public IRuntimeClasspathEntry[] getSharedLibraries();
  public IRuntimeClasspathEntry[] getServerWebappsLibraries();
  public IRuntimeClasspathEntry[] getDefaultWebappsLibraries();
	public IRuntimeClasspathEntry[] getClasspathLibraries();
	public IRuntimeClasspathEntry[] getEndorsedLibraries();  
  public VMArgument[] getVMArguments();
}