/***************************************************************************
 * Copyright 2001-2005 The eXo Platform SARL         All rights reserved.  *
 * Please visit http://www.exoplatform.org for more license detail.        *
 **************************************************************************/
package org.exoplatform.eclipse.core.portal.model;

/**
 * When a model object implements this interface, it is simply indicating that it can
 * provide information about its context structure. For example, if the model object
 * implements this interface and returns false for the method isRemovable(), it means that
 * the model object should not be removed from its containing structure.
 * 
 * @author Hatim Khan
 */
public interface IStructureAttributesProvider
{
  /**
   * @return true if the implementing object can be removed from its containing structure
   */
  public boolean isRemovable();

  /**
   * @return true if the implementing object can be replaced with an equivalent object. 
   */
  public boolean isReplacable();
  
}