/***************************************************************************
 * Copyright 2001-2005 The eXo Platform SARL         All rights reserved.  *
 * Please visit http://www.exoplatform.org for more license detail.        *
 **************************************************************************/
package org.exoplatform.eclipse.internal.ui.editor;

import org.eclipse.swt.widgets.Composite;
import org.eclipse.ui.forms.widgets.FormToolkit;
import org.exoplatform.eclipse.core.portal.PortalSettings;

/**
 * This details page displays the detail properties parameter entry information. This page
 * does not change the model or have any field to allow the user to enter data, however,
 * this page should receive model change events and marks itself as stale. However, since
 * this page extends from ParameterInfoDetailPart, it does not need to monitor model
 * changes or mark itself as stale since it is being done in ParameterInfoDetailPart
 * class.
 * 
 * @author Hatim Khan
 */
public class PropertiesParamInfoDetailPart extends ParameterInfoDetailPart
{

  public PropertiesParamInfoDetailPart(PortalSettings pPortalSettings)
  {
    super(pPortalSettings, "Properties Parameter", "Parameter Details",
        "Detailed information about the selected parameter");
  }

  /**
   * @see org.exoplatform.eclipse.internal.ui.editor.ParameterInfoDetailPart#addValuesContent(org.eclipse.swt.widgets.Composite,
   *      org.eclipse.ui.forms.widgets.FormToolkit)
   */
  protected void addValuesContent(Composite pClient, FormToolkit pToolkit)
  {
    addTreeValuesContent(pClient, pToolkit);
  }

}