/***************************************************************************
 * Copyright 2001-2004 The eXo Platform SARL         All rights reserved.  *
 * Please visit http://www.exoplatform.org for more license detail.        *
 **************************************************************************/

package org.exoplatform.eclipse.internal.ui.launching;

import org.eclipse.debug.ui.AbstractLaunchConfigurationTabGroup;
import org.eclipse.debug.ui.CommonTab;
import org.eclipse.debug.ui.EnvironmentTab;
import org.eclipse.debug.ui.ILaunchConfigurationDialog;
import org.eclipse.debug.ui.ILaunchConfigurationTab;
import org.eclipse.debug.ui.sourcelookup.SourceLookupTab;

/**
 * Provides the tabs to help the user manage the launch configuration for 'eXo Platform with Tomcat'
 * type.
 *
 * @author Hatim Khan
 * @version $Revision: 1.1 $
 */
public class ExoTomcatLaunchTabGroup extends AbstractLaunchConfigurationTabGroup
{
  public static final String CLASS_VERSION = "$Id: ExoTomcatLaunchTabGroup.java,v 1.1 2004/09/20 01:42:56 hatimk Exp $"; //$NON-NLS-1$

  /**   
   * @see org.eclipse.debug.ui.ILaunchConfigurationTabGroup#createTabs(org.eclipse.debug.ui.ILaunchConfigurationDialog,
   *      java.lang.String)
   */
  public void createTabs(ILaunchConfigurationDialog pDialog, String pMode)
  {
    //TODO in the running mode we might not need to display the source tab
    ILaunchConfigurationTab[] tabs =
      new ILaunchConfigurationTab[] { new ExoTomcatHomeTab(), new ExoTomcatJDKTab(), new ExoSourcePortletsTab(), new EnvironmentTab(), new SourceLookupTab(), new CommonTab() };
    setTabs(tabs);
  }
}
