/***************************************************************************
 * Copyright 2001-2005 The eXo Platform SARL         All rights reserved.  *
 * Please visit http://www.exoplatform.org for more license detail.        *
 **************************************************************************/
package org.exoplatform.eclipse.ui.common;

import java.util.MissingResourceException;
import java.util.ResourceBundle;

/**
 * A resource bundle that contains all the formatted 'Did You Know' messages
 * 
 * @author Hatim Khan
 */
public class DidYouKnowMessages
{
  private static final String BUNDLE_NAME = "org.exoplatform.eclipse.ui.common.DidYouKnowMessages"; //$NON-NLS-1$
  private static final ResourceBundle RESOURCE_BUNDLE = ResourceBundle.getBundle(BUNDLE_NAME);

  private DidYouKnowMessages()
  {
  }

  public static String getString(String key)
  {
    try
    {
      return RESOURCE_BUNDLE.getString(key);
    }
    catch (MissingResourceException e)
    {
      return "!" + key + "!";
    }
  }
}