/***************************************************************************
 * Copyright 2001-2005 The eXo Platform SARL         All rights reserved.  *
 * Please visit http://www.exoplatform.org for more license detail.        *
 **************************************************************************/
package org.exoplatform.eclipse.ui.dialog;

import org.eclipse.jface.wizard.IWizardContainer2;
import org.eclipse.swt.events.DisposeEvent;
import org.eclipse.swt.events.DisposeListener;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.ui.forms.events.ExpansionAdapter;
import org.eclipse.ui.forms.events.ExpansionEvent;
import org.eclipse.ui.forms.widgets.ExpandableComposite;
import org.eclipse.ui.forms.widgets.FormToolkit;
import org.eclipse.ui.forms.widgets.ScrolledForm;
import org.eclipse.ui.forms.widgets.TableWrapData;
import org.eclipse.ui.forms.widgets.TableWrapLayout;
import org.exoplatform.eclipse.ui.common.UICompositeUtil;

/**
 * @author Hatim Khan
 */
public class DidYouKnowForm
{
  private FormToolkit mFormToolkit;
  private ScrolledForm mForm;
  private IWizardContainer2 mWizardContainer;
  private ExpandableComposite mExpandableComposite;

  public DidYouKnowForm(Composite pParent, String pTaggedText)
  {
    this(pParent, pTaggedText, null);
  }

  public DidYouKnowForm(Composite pParent, String pTaggedText, IWizardContainer2 pWizardContainer)
  {
    mWizardContainer = pWizardContainer;
    mFormToolkit = new FormToolkit(pParent.getDisplay());
    pParent.addDisposeListener(new DisposeListener()
    {
      public void widgetDisposed(DisposeEvent pEvent)
      {
        if (mFormToolkit != null)
        {
          mFormToolkit.dispose();
        }
      }
    });

    mForm = mFormToolkit.createScrolledForm(pParent);
    mForm.setLayoutData(new GridData(GridData.FILL_BOTH));
    TableWrapLayout layout = new TableWrapLayout();
    mForm.setLayout(layout);

    layout = new TableWrapLayout();
    mForm.getBody().setLayout(layout);
    mForm.getBody().setLayoutData(new TableWrapData(TableWrapData.FILL_GRAB));

    mExpandableComposite = UICompositeUtil.createFormattedTextExpandable(mForm.getBody(), mFormToolkit, pTaggedText);
    mExpandableComposite.setText("Did you know?");
    mExpandableComposite.addExpansionListener(new ExpansionAdapter()
    {
      public void expansionStateChanged(ExpansionEvent pEvent)
      {
        mForm.reflow(true);
        //if (mWizardContainer != null) mWizardContainer.updateSize();
      }
    });
    mExpandableComposite.setExpanded(false);
  }

  /**
   * @return Returns the expandableComposite.
   */
  public ExpandableComposite getExpandableComposite()
  {
    return mExpandableComposite;
  }
}