/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.eclipse.webunit;

import java.util.MissingResourceException;
import java.util.ResourceBundle;

import org.eclipse.ui.plugin.AbstractUIPlugin;
import org.osgi.framework.BundleContext;

/**
 * The main plugin class to be used in the desktop.
 */
public class WebunitPlugin extends AbstractUIPlugin {
  //The shared instance.
  private static WebunitPlugin plugin_ ;
  //Resource bundle.
  private ResourceBundle res_;
  
  public WebunitPlugin() {
    super();
    plugin_ = this;
    res_ = ResourceBundle.getBundle("org.exoplatform.eclipse.webunit.resource");
  }
  
  public void start(BundleContext context) throws Exception {
    super.start(context);
  }
  
  public void stop(BundleContext context) throws Exception {
    super.stop(context);
  }
  
  
  public static WebunitPlugin getDefault() {
    return plugin_;
  }
  
  public static String getResourceString(String key) {
    ResourceBundle bundle = WebunitPlugin.getDefault().getResourceBundle();
    try {
      return (bundle != null) ? bundle.getString(key) : key;
    } catch (MissingResourceException e) {
      return key;
    }
  }
  
  public ResourceBundle getResourceBundle() {
    return res_;
  }
}
