/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.eclipse.webunit.views;

import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.TabFolder;
import org.eclipse.swt.widgets.TabItem;
import org.eclipse.swt.widgets.Text;
import org.exoplatform.eclipse.webunit.widgets.ExoText;
/**
 * @author Tuan Nguyen (tuan08@users.sourceforge.net)
 * @since Oct 4, 2004
 * @version $Id: ResultView.java,v 1.3 2004/10/09 19:08:59 tuan08 Exp $
 */
public class ResultView extends Composite {
  private BrowserView browserView_ ;
  private HtmlTextEditorView htmlView_ ;
  private Text error_ ;
  private TabFolder tabFolder_ ;
  
  public ResultView(Composite parent) {
    super(parent, SWT.NONE)  ;
    setLayout(new GridLayout());
    GridData gridData = 
      new GridData(GridData.FILL_BOTH | GridData.GRAB_HORIZONTAL | GridData.GRAB_VERTICAL);
    tabFolder_ = new TabFolder(this, SWT.NULL) ;
    tabFolder_.setLayoutData(gridData) ;
    
    TabItem browserTab = new TabItem( tabFolder_, SWT.NULL );
    browserTab.setText("Browser") ;
    browserView_ = new BrowserView(tabFolder_);
    browserTab.setControl(browserView_) ;
    
    TabItem htmlCodeTab = new TabItem( tabFolder_, SWT.NULL );
    htmlCodeTab.setText("Html") ;
    htmlView_ = new HtmlTextEditorView(tabFolder_);
    htmlCodeTab.setControl(htmlView_) ;

    TabItem errorTab = new TabItem( tabFolder_, SWT.NULL );
    errorTab.setText("Error") ;
    error_ = new ExoText(tabFolder_,  SWT.NONE  | SWT.MULTI );
    error_.setText("") ;
    error_.setEditable(false) ;
    errorTab.setControl(error_) ;
  }
  
  public BrowserView getBrowserView() { return browserView_ ; }
  public Text  getErrorView() { return error_ ; }
  public HtmlTextEditorView  getHtmlEditorView() { return htmlView_ ; }
  
  public void showBrowser() { tabFolder_.setSelection(0) ; }
  public void showHtmlEditor() { tabFolder_.setSelection(1) ; }
  public void showError() { tabFolder_.setSelection(2) ; }
  
  public boolean setFocus() {  
    browserView_.setFocus();
    return true  ;
  }
}