/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.eclipse.webunit.views;

import org.eclipse.core.resources.IProject;
import org.eclipse.core.runtime.IPath;
import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.exoplatform.eclipse.webunit.ExceptionUtil;
/**
 * @author Tuan Nguyen (tuan08@users.sourceforge.net)
 * @since Oct 4, 2004
 * @version $Id: ViewController.java,v 1.3 2004/10/12 03:30:42 tuan08 Exp $
 */
public class ViewController extends Composite {
  private ExoWebUnitView unitsView_ = null;
  private ResultView resultView_ ;
  private ClassLoader unitTestLoader_ ;
  
  public ViewController(IPath resource , IProject iproject, Composite main) {
    super(main, SWT.NONE) ;
    try {
    GridLayout gridLayout = new GridLayout();
    gridLayout.numColumns = 2;
    gridLayout.marginHeight = 0 ;
    gridLayout.marginWidth = 0  ;
    gridLayout.verticalSpacing = 0 ;
    gridLayout.horizontalSpacing = 0 ;
    GridData mainGridData = 
      new GridData(GridData.FILL_BOTH | GridData.GRAB_HORIZONTAL | GridData.GRAB_VERTICAL);
    setLayout(gridLayout);
    setLayoutData(mainGridData) ;
    
    //create unit view area
    GridData unitViewGridData = new GridData(GridData.FILL_VERTICAL | GridData.GRAB_VERTICAL);
    unitViewGridData.widthHint = 200 ;
    unitsView_ = new ExoWebUnitView(this) ;
    unitsView_.setLayoutData(unitViewGridData) ;
    
    // Create result view area
    GridData resultGridData = 
      new GridData(GridData.FILL_BOTH | GridData.GRAB_HORIZONTAL | GridData.GRAB_VERTICAL);
    resultView_ = new ResultView(this) ;
    resultView_.setLayoutData(resultGridData) ;
    }catch (Throwable t) {
      t.printStackTrace() ;
    }
    
    //create unit controller view area
    try {
    /*
    URL[] url = findProjectClassPath(resource, iproject) ;
    unitTestLoader_ = new URLClassLoader(url, getClass().getClassLoader()) ;
    
    selectClass = selectClass.replace('/', '.') ;
    if(selectClass.endsWith(".java")) {
      selectClass = selectClass.substring(0, selectClass.length() - 5) ;
    }
    
    unitsView_.setTestSuites(selectClass) ;
    */
    } catch (Throwable t) {
      t.printStackTrace() ;
    } 
  }
  
  public ClassLoader getUnitTestClassLoader() { return unitTestLoader_ ;}
  
  public ResultView getResultView() { return resultView_ ; }
  
  public ExoWebUnitView getUnitTestView() { return unitsView_ ; }
  
  public UnitTestControllerView getUnitTestControlellerView() { 
    return  unitsView_.getUnitTestControlellerView(); 
  }
  
  public void showError(Throwable t, String message) { 
    if (t != null) {
      message = "<pre>" + ExceptionUtil.getStackTrace(t, 100) + "</pre>";
    }
    resultView_.getErrorView().setText(message) ;
    resultView_.showError();
  }
  
  public boolean setFocus() {  
    resultView_.setFocus();
    return true  ;
  }
  
  
  
  public static ViewController findController(Control control) {
    Composite parent = control.getParent() ;
    while(parent != null) {
      if(parent instanceof ViewController) return (ViewController) parent ;
      parent = parent.getParent() ;
    }
    return null ; 
  }
}