/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portlets.addrbook.renderer.html;

import java.io.IOException;
import java.util.Iterator;
import java.util.ResourceBundle;
import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.context.ResponseWriter;
import org.exoplatform.faces.core.component.model.Parameter;
import org.exoplatform.faces.core.renderer.html.HtmlBasicRenderer;
import org.exoplatform.portlets.addrbook.component.UIAddrUserInfo;
import org.exoplatform.services.addrbook.model.AddrBook;
/**
 * @email:   tuan08@users.sourceforge.net
 * @version: $Id: UserInfoRenderer.java,v 1.15 2004/10/21 15:25:17 tuan08 Exp $
 */
public class AddrUserInfoRenderer extends  HtmlBasicRenderer {
  private static Parameter[] backParams = {new Parameter(ACTION , "back")} ;

  final public void encodeBegin( FacesContext context, UIComponent component ) throws IOException {
    ResourceBundle res = getApplicationResourceBundle(context.getExternalContext()) ;
    ResponseWriter w = context.getResponseWriter() ;
 
    UIAddrUserInfo uiAddrUserInfo = (UIAddrUserInfo) component ;
    w.write("<table class='UIAddrUserInfo'>");
    w.  write("<tr>");
    w.    write("<td>");
    addAddrUserInfo(w, res, uiAddrUserInfo) ;
    w.    write("</td>");
    w.  write("</tr>");
    w.  write("<tr>");
    w.    write("<td colspan='2'>");
//    uiAddrUserInfo.appendLink(w, res.getString("UIAddrUserInfo.button.back"), backParams, "") ;
    w.    write("</td>");
    w.  write("</tr>");
    w.write("</table>");
  }

  private void addAddrUserInfo(ResponseWriter w,
                                  ResourceBundle res, UIAddrUserInfo uiAddrUserInfo) throws IOException {
    AddrBook addrBook = uiAddrUserInfo.getAddrBookInfo() ;
    w.write("<table>");
    w.  write("<tr>");
    w.    write("<td>");w.write(res.getString("UIAddrUserInfo.label.name")); w.write("</td>");
    w.    write("<td>");w.write(addrBook.getName()); w.write("</td>");
    w.  write("</tr>");
    w.  write("<tr>");
    w.    write("<td>"); w.write(res.getString("UIAddrUserInfo.label.address")); w.write("</td>");
    w.    write("<td>");w.write(addrBook.getAddress()); w.write("</td>");
    w.  write("</tr>");
    w.  write("<tr>");
    w.    write("<td>"); w.write(res.getString("UIAddrUserInfo.label.telBusiness")); w.write("</td>");
    w.    write("<td>"); w.write(addrBook.getTelBusiness());w.write("</td>");
    w.  write("</tr>");
    w.  write("<tr>");
    w.    write("<td>"); w.write(res.getString("UIAddrUserInfo.label.telHome")); w.write("</td>");
    w.    write("<td>"); w.write(addrBook.getTelHome()); w.write("</td>");
    w.  write("</tr>");
    w.  write("</tr>");
    w.  write("<tr>");
    w.    write("<td>"); w.write(res.getString("UIAddrUserInfo.label.zipCode"));  w.write("</td>");
    w.    write("<td>"); w.write(addrBook.getZipCode()); w.write("</td>");
    w.  write("</tr>");
    w.    write("<td>"); w.write(res.getString("UIAddrUserInfo.label.email"));  w.write("</td>");
    w.    write("<td>"); w.write(addrBook.getEmail()); w.write("</td>");
    w.  write("</tr>");
    w.write("</table>");
  }
}