/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portlets.bookmark.renderer.html;

import java.io.IOException;
import java.util.*;
import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.context.ResponseWriter;
import org.exoplatform.faces.core.component.model.Parameter;
import org.exoplatform.faces.core.renderer.html.HtmlBasicRenderer;
import org.exoplatform.portlets.bookmark.component.UIBookmarkExplorer;
import org.exoplatform.services.bookmark.model.BookmarkCategory;
import org.exoplatform.services.bookmark.model.Bookmark;
/**
 * @email:   danny_xcz@163.com
 * @version: $Id: BookmarkExplorerRenderer.java,v 1.12 2004/10/22 14:23:31 tuan08 Exp $
 */
public class BookmarkExplorerRenderer extends HtmlBasicRenderer {

	private static Parameter[] CONFIG_CATEGORY =
		{ new Parameter(ACTION, "configBookmarkCategory")};
	private static Parameter[] EXIT_CONFIG_CATEGORY =
		{ new Parameter(ACTION, "exitConfigBookmarkCategory")};

	private static Parameter CHANGE_CATEGORY =
		new Parameter(ACTION, "changeBookmarkCategory");
	private static Parameter[] ADD_CATEGORY =
		{ new Parameter(ACTION, "addBookmarkCategory")};

	private static Parameter SEARCH = new Parameter(ACTION, "search");

	final public void encodeBegin(FacesContext context, UIComponent component)
		throws IOException {
		ResourceBundle res =
			getApplicationResourceBundle(context.getExternalContext());
		ResponseWriter w = context.getResponseWriter();
		UIBookmarkExplorer uiExplorer = (UIBookmarkExplorer) component;
		Collection childrenBookmarkCategory = uiExplorer.getChildrenBookmarkCategory();
		BookmarkCategory currentBookmarkCategory = uiExplorer.getCurrentBookmarkCategory();
		BookmarkCategory parentBookmarkCategory = uiExplorer.getParentBookmarkCategory();
		String groupName = "ROOT";
		if (currentBookmarkCategory != null)
			groupName = currentBookmarkCategory.getName();
		Object[] args = { groupName };
		//The head line
		w.write("<table class='UIBookmarkExplorer'>");
		w.write("<tr>");
		w.write("<th class='header' colspan='2'>");
		w.write(
			ft_.format(res.getString("UIBookmarkExplorer.label.category"), args));
			

		w.write("</th>");
		w.write("</tr>");
		//The middle line
		w.write("<tr>");
		w.write("<td class='tree'>");
		
		if (uiExplorer.getConfigState() == 0) {
			linkRenderer_.render(
				w,
				uiExplorer,
				res.getString("UIBookmarkExplorer.button.config-category"),
				CONFIG_CATEGORY);
		} else if (uiExplorer.getConfigState() == 1) {
			linkRenderer_.render(
				w,
				uiExplorer,
				res.getString("UIBookmarkExplorer.button.exit-config-category"),
				EXIT_CONFIG_CATEGORY);
		}
		
		
		if (uiExplorer.getConfigState() == 0) {
			addBookmarkCategoryTreeTable(
				parentBookmarkCategory,
				childrenBookmarkCategory,
				w,
				res,
				uiExplorer);
		} else if (uiExplorer.getConfigState() == 1) {
			addConfigBookmarkCategoryTreeTable(
				parentBookmarkCategory,
				childrenBookmarkCategory,
				w,
				res,
				uiExplorer);
		}
		w.write("</td>");
		w.write("<td>");
	   // if(currentBookmarkCategory!=null){
	    
		renderChildren(context, uiExplorer);
		//}
		//else {
		//	w.write("no category selected!");
		//}
		w.write("</td>");
		w.write("</tr>");
		//The bottom line
		w.write("<tr>");
		w.write("<td colspan='2' class='footer'>");
		//String parentBookmarkCategoryId = "" ;
		//if (currentBookmarkCategory != null) parentBookmarkCategoryId = currentBookmarkCategory.getId() ;
		// Parameter groupParam = new Parameter(UIBookmarkExplorer.CATEGORY_ID, parentBookmarkCategoryId) ;
		//w.write("search");

		w.write("</td>");
		w.write("</tr>");

		w.write("</table>");
	}

	private void addBookmarkCategoryTreeTable(
		BookmarkCategory parentBookmarkCategory,
		Collection childrenBookmarkCategory,
		ResponseWriter w,
		ResourceBundle res,
		UIBookmarkExplorer uiBookmarkExplorer)
		throws IOException {
		Parameter categoryIdParam =
			new Parameter(UIBookmarkExplorer.CATEGORY_ID, "");
		Parameter[] changeBookmarkCategoryParams = { CHANGE_CATEGORY, categoryIdParam };

		Iterator i = childrenBookmarkCategory.iterator();
		String parentBookmarkCategoryId = "";
		if (parentBookmarkCategory != null){
			parentBookmarkCategoryId = parentBookmarkCategory.getId();
		}else {
			parentBookmarkCategoryId = "/";
		}
		String groupIcon = res.getString("UIBookmarkExplorer.img.category-icon");
		w.write("<table>");
		w.write("<tr>");
		w.write("<td>");
		categoryIdParam.setValue(parentBookmarkCategoryId);
//		uiBookmarkExplorer.appendLink(w, "[..]", changeBookmarkCategoryParams, "");
		w.write("</td>");
		w.write("</tr>");
		while (i.hasNext()) {
			BookmarkCategory category = (BookmarkCategory) i.next();
			w.write("<tr>");
			w.write("<td style='padding-left: 10px'>");
			w.write(groupIcon);
			categoryIdParam.setValue(category.getId());
//			uiBookmarkExplorer.appendLink( w, category.getName(),	changeBookmarkCategoryParams,	"");
			w.write("</td>");
			w.write("</tr>");
		}
		w.write("</table>");

	}

	private void addConfigBookmarkCategoryTreeTable(
		BookmarkCategory parentBookmarkCategory,
		Collection childrenBookmarkCategory,
		ResponseWriter w,
		ResourceBundle res,
		UIBookmarkExplorer uiBookmarkExplorer)
		throws IOException {
		Parameter categoryIdParam =
			new Parameter(UIBookmarkExplorer.CATEGORY_ID, "");
		Parameter[] changeBookmarkCategoryParams = { CHANGE_CATEGORY, categoryIdParam };

		Iterator i = childrenBookmarkCategory.iterator();
		String parentBookmarkCategoryId = "";
		if (parentBookmarkCategory != null)
			parentBookmarkCategoryId = parentBookmarkCategory.getId();
		String groupIcon = res.getString("UIBookmarkExplorer.img.category-icon");
		w.write("<table>");
		w.write("<tr>");
		w.write("<td>");
		categoryIdParam.setValue(parentBookmarkCategoryId);
//		uiBookmarkExplorer.appendLink(w, "[..]", changeBookmarkCategoryParams, "");
		w.write("</td>");
		w.write("</tr>");
		while (i.hasNext()) {
			BookmarkCategory category = (BookmarkCategory) i.next();
			w.write("<tr>");
			w.write("<td style='padding-left: 10px'>");
			w.write(groupIcon);
			categoryIdParam.setValue(category.getId());
//			uiBookmarkExplorer.appendLink( w, category.getName(),	changeBookmarkCategoryParams, "");
			w.write("</td>");
			w.write("</tr>");
		}
		w.write("<tr>");
		w.write("<td>");
		linkRenderer_.render(
			w,
			uiBookmarkExplorer,
			res.getString("UIBookmarkExplorer.button.add-category"),
			ADD_CATEGORY);
		w.write("</td>");
		w.write("</tr>");
		w.write("</table>");

	}

}