/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portlets.ftp.component;

import java.io.ByteArrayOutputStream;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.SocketException;
import java.util.List;
import java.util.ResourceBundle;

import javax.faces.context.ExternalContext;
import javax.faces.context.FacesContext;
import javax.faces.context.ResponseStream;
import javax.faces.context.ResponseWriter;
import javax.portlet.ActionResponse;
import javax.portlet.PortletRequest;
import javax.portlet.PortletResponse;
import javax.servlet.ServletOutputStream;
import javax.servlet.http.*;

import org.exoplatform.faces.core.component.UIExoCommand;
import org.exoplatform.faces.core.component.UIFileUpload;
import org.exoplatform.faces.core.component.model.Parameter;
import org.exoplatform.faces.core.event.ExoActionEvent;
import org.exoplatform.faces.core.event.ExoActionListener;
import org.exoplatform.portlets.ftp.component.util.FtpConnection;
import org.apache.commons.net.ftp.*;
import org.apache.commons.net.ftp.parser.*;
import org.exoplatform.commons.utils.*;
import org.exoplatform.portlets.ftp.component.util.*;
/**
 * @author Tuan Nguyen (tuan08@users.sourceforge.net)
 * @since Aug 27, 2004
 * @version $Id: UIAccount.java,v 1.7 2004/09/20 01:00:17 tuan08 Exp $
 */
public class UIFtp extends UIExoCommand {
	private FtpConnection ftpConn_;
	private ResourceBundle res_;
	//private FTPClient ftp_;
	private FTPFile[] ftpFiles_ = null;
	//private String currentDir_ = "";

	public UIFtp(FtpConnection ftpConn, ResourceBundle res) {
		setId("UIFtp");
		setClazz("UIFtp");
		setRendererType("FtpRenderer");
		res_ = res;
		ftpConn_ = ftpConn;
		//currentDir_ = "/";

		try {
			update();
		} catch (Exception e1) {
			e1.printStackTrace();
		}

		addActionListener(EditFileActionListener.class, "editFile");
		addActionListener(ChangeDirActionListener.class, "changeDir");
		addActionListener(DownloadActionListener.class, "download");
		addActionListener(NewFolderActionListener.class, "newFolder");
		addActionListener(UploadFileActionListener.class, "uploadFile");
	}

	public FTPFile[] getFiles() {
		return ftpFiles_;
	}

	//public String getCurrentDir() {
	//	return currentDir_;
	//}

	public FtpConnection getFtpConnection() {
		return ftpConn_;
	}

	public void update() throws Exception {
		//ftpConn_.changeCurrentDirectory();
		ftpFiles_ = ftpConn_.listFiles();
	}

	static public class NewFolderActionListener extends ExoActionListener {
		public void execute(ExoActionEvent event) throws Exception {
			UIFtp uiFtp = (UIFtp) event.getComponent();
			String file = event.getParameter("file");

			UIFileForm uiFileForm =
				(UIFileForm) uiFtp.getSibling(UIFileForm.class);

			uiFileForm.setNewFileData();

			UIFtpPortlet ftpPortlet =
				(UIFtpPortlet) uiFtp.getAncestorOfType(UIFtpPortlet.class);
			ftpPortlet.setRenderedComponent(UIFileForm.class);

		}
	}

	static public class UploadFileActionListener extends ExoActionListener {
		public void execute(ExoActionEvent event) throws Exception {
			UIFtp uiFtp = (UIFtp) event.getComponent();
			//String file = event.getParameter("file");

			UIFileUpload uiFileUpload =
				(UIFileUpload) uiFtp.getSibling(UIFileUpload.class);

			//uiFileUpload.setEditFileData(file);

			UIFtpPortlet ftpPortlet =
				(UIFtpPortlet) uiFtp.getAncestorOfType(UIFtpPortlet.class);
			ftpPortlet.setRenderedComponent(UIFileUpload.class);

		}
	}

	static public class EditFileActionListener extends ExoActionListener {
		public void execute(ExoActionEvent event) throws Exception {
			UIFtp uiFtp = (UIFtp) event.getComponent();
			String file = event.getParameter("file");

			UIFileForm uiFileForm =
				(UIFileForm) uiFtp.getSibling(UIFileForm.class);

			uiFileForm.setEditFileData(file);

			UIFtpPortlet ftpPortlet =
				(UIFtpPortlet) uiFtp.getAncestorOfType(UIFtpPortlet.class);
			ftpPortlet.setRenderedComponent(UIFileForm.class);

		}
	}

	static public class ChangeDirActionListener extends ExoActionListener {
		public void execute(ExoActionEvent event) throws Exception {
			UIFtp uiFtp = (UIFtp) event.getComponent();
			System.out.println(
				TextUtil.urlDecodeUTF8(event.getParameter("dir")));
			/*
			System.out.println(
				new String(
					TextUtil.urlDecodeUTF8(event.getParameter("dir")).getBytes(
						"GBK"),
					"ISO-8859-1"));
			String temp =
				new String(
					TextUtil.urlDecodeUTF8(event.getParameter("dir")).getBytes(
						"GBK"),
					"ISO-8859-1");
			System.out.println(event.getParameter("dir"));
			*/
			uiFtp.ftpConn_.setCurrentDir(
				TextUtil.urlDecodeUTF8(event.getParameter("dir")));

			//uiFtp.currentDir_ = event.getParameter("dir");
			uiFtp.update();

		}
	}

	static public class DownloadActionListener extends ExoActionListener {
		public void execute(ExoActionEvent event) throws Exception {
			UIFtp uiFtp = (UIFtp) event.getComponent();
			String file = event.getParameter("downloadfile");

			PortletResponse response =
				(PortletResponse) uiFtp
					.getFacesContext()
					.getExternalContext()
					.getResponse();
			HttpServletResponse httpResponse = (HttpServletResponse) response;
			httpResponse.reset();
			httpResponse.setHeader(
				"Content-Disposition",
				"filename=\"" + file + "\"");
			//httpResponse.setHeader(
			//	"Content-disposition",
			//	"attachment; filename=test.xls");
			httpResponse.setContentType("application/octet-stream");
			uiFtp.ftpConn_.retrieveFile(file, httpResponse.getOutputStream());
			//System.out.println(httpResponse.getOutputStream().toString());
			httpResponse.getOutputStream().flush();
			httpResponse.getOutputStream().close();
			uiFtp.getFacesContext().responseComplete();
		
			//file = "down.exe";
			//byte[] buffer = new byte[input.available()];
			//byte[] buffer = IOUtil.getStreamContentAsBytes(input);

			//System.out.println("***");
			///System.out.println(new String(buffer, 0));
			//System.out.println("***");
			/*
						ExternalContext eContext =
							uiFtp.getFacesContext().getExternalContext();
						ActionResponse response = (ActionResponse) eContext.getResponse();
						response.addProperty("username", uiFtp.ftpConn_.getUsername());
						response.addProperty("password", uiFtp.ftpConn_.getPassword());
						response.addProperty("host", uiFtp.ftpConn_.getHost());
						response.addProperty("port", uiFtp.ftpConn_.getPort());
						response.addProperty("anonymous", uiFtp.ftpConn_.getAnonymous());
						response.addProperty("file", file);
						String loginPath_ = "/ftp/download.jsp";
			
						response.sendRedirect(loginPath_);
			*/
			/*
						FacesContext ctx = uiFtp.getFacesContext();
			
						if (!ctx.getResponseComplete()) {
							String fileName = "someFile.txt";
							String contentType = "text/plain";
			
							HttpServletResponse response =
								(HttpServletResponse) ctx
									.getExternalContext()
									.getResponse();
							response.reset();
			*/
			//response.setContentType(contentType);
			//response.setHeader(
			//	"Content-Disposition",
			//	"filename=\"" + fileName + "\"");
			//response.setHeader("Content-disposition", "attachment; filename=test.xls");//
			// response.setContentType("application/octet-stream");

			//ServletOutputStream out = response.getOutputStream();
			//out.write(buffer);
			//out.flush();
			//response.sendRedirect("http://www.ujs.edu.cn");
			//ctx.responseComplete();
			//response.sendRedirect("http://www.ujs.edu.cn");

			//FacesContext.getCurrentInstance().responseComplete();
			//out.close();
			//input.close();

			//}

		}
	}

}