/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portlets.publish.component;

import java.util.List;
import org.exoplatform.faces.core.component.UIExoCommand;
import org.exoplatform.faces.core.component.UIPageListIterator;
import org.exoplatform.faces.core.component.model.PageListDataHandler;
import org.exoplatform.faces.core.component.model.Parameter;
import org.exoplatform.faces.core.event.ExoActionEvent;
import org.exoplatform.faces.core.event.ExoActionListener;
import org.exoplatform.services.publish.model.*;
import org.exoplatform.services.publish.PublishService;
/**
 * @author Tuan Nguyen (tuan08@users.sourceforge.net)
 * @since Aug 27, 2004
 * @version $Id: UIAccount.java,v 1.9 2004/10/23 01:58:56 tuan08 Exp $
 */
public class UIContentTitles extends UIExoCommand  {
	
  private UIPageListIterator uiPageIterator_ ;
  private Section section_ ;
  //private Content selectedContent_ ;
  private PublishService service_ ;
	
  
  public final static String READ_CONTENT_ACTION = "readContent" ;
  public final static String CONTENT_ID = "contentId" ;

  
  public UIContentTitles(PublishService service) {
    setId("UIContentTitles") ;
    //setClazz("UIContentTitles");
    setRendererType("ContentTitlesRenderer");
    service_ = service ;
    uiPageIterator_ = new UIPageListIterator(new ContentDataHandler()) ;
    getChildren().add(uiPageIterator_);
    addActionListener(ReadContentActionListener.class, READ_CONTENT_ACTION) ;
    addActionListener(BackActionListener.class, "back") ;
  }
  
  public String getFamily() {
	  return "org.exoplatform.portlets.publish.component.UIContentTitles";
  }
  
  public void setUIContentTitlesData(String sectionId) throws Exception {
    if(!sectionId.equals("/")) {
    section_ = service_.findSectionById(sectionId) ; 
    uiPageIterator_.setPageList(service_.findContentsBySection(section_.getId())) ;
    } else {
    uiPageIterator_.setPageList(service_.findContentsBySection("/")) ;
    }
  }
  
  public UIPageListIterator getUIPageIterator() { return uiPageIterator_ ; }
  
  static public class ContentDataHandler extends PageListDataHandler {
	  private Content content_;

	  public String getData(String fieldName) {
		  if ("contentId".equals(fieldName))
			  return content_.getContentId();
		  if ("title".equals(fieldName))
			  return content_.getTitle();
		  if ("introText".equals(fieldName))
			  return content_.getIntroText();
		  if ("createBy".equals(fieldName))
			  return content_.getCreatedBy();
		  if ("createDate".equals(fieldName))
			  return content_.getCreatedDate().toGMTString();
		  return null;
	  }

	  public void setCurrentObject(Object o) {
		  content_ = (Content) o;
	  }
  }
  
  static public class ReadContentActionListener extends ExoActionListener {
    public void execute(ExoActionEvent event) throws Exception {
      UIContentTitles uiContentTitles = (UIContentTitles) event.getSource() ;
      String contentId = event.getParameter("contentId") ;
      //Content selectedContent = uiContentTitles.service_.findContentById(contentId) ;
      
      UIContentDisplay uiContentDisplay = 
        (UIContentDisplay)uiContentTitles.getSibling(UIContentDisplay.class) ;
      uiContentDisplay.setUIContentDisplayData(contentId) ;
      uiContentTitles.setRenderedSibling(UIContentDisplay.class) ;
      
      			UIContentsReaderPortlet uiContentsReaderPortlet =
				(UIContentsReaderPortlet) uiContentTitles.getParent();
			uiContentsReaderPortlet.addHistoryElement(uiContentTitles);
    }
  }
  
    static public class BackActionListener extends ExoActionListener {
    public void execute(ExoActionEvent event) throws Exception {
      UIContentTitles uiContentTitles = (UIContentTitles) event.getSource() ;
			UIContentsReaderPortlet uiContentsReaderPortlet =
				(UIContentsReaderPortlet) uiContentTitles.getParent();
			uiContentsReaderPortlet.undo();
    }
  }
  
}