/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portlets.publish.component;

import java.util.Enumeration;
import java.util.List;

import javax.faces.context.ExternalContext;
import javax.faces.context.FacesContext;
import javax.portlet.PortletPreferences;
import javax.portlet.PortletRequest;

import org.exoplatform.faces.core.component.UIExoCommand;


import org.exoplatform.portlets.publish.component.model.ContentConfig;
import org.exoplatform.services.publish.PublishService;

/**
 * Wed, Dec 22, 2003 @ 23:14
 * @author: Daniel Summer
 * @email: danny_xcz@163.com
 * @version: $Id: UIContentPortlet.java,v 1.2 2004/07/26 02:27:18 tuan08 Exp $
 */
public class UIContentTitlesBlocks extends UIExoCommand {
	final static public String[] DEFAULT_VALUES =
		{ "title=", "uri=", "item-to-show=" };
	public UIContentTitlesBlocks(PublishService service) throws Exception {
		setId("UIContentTitlesBlocks");
		//setClazz("UIContentTitlesBlocks");
		setRendererType("ContentTitlesBlocksRenderer");

		ExternalContext eContext =
			FacesContext.getCurrentInstance().getExternalContext();
		PortletRequest request = (PortletRequest) eContext.getRequest();
		PortletPreferences prefs = request.getPreferences();
		Enumeration enum = prefs.getNames();
		List children = getChildren();

		while (enum.hasMoreElements()) {
			String name = (String) enum.nextElement();
			String[] values = prefs.getValues(name, DEFAULT_VALUES);
			ContentConfig contentConfig = new ContentConfig(name, values);
			UIContentTitlesBlock uiContentTitlesBlock = new UIContentTitlesBlock(service,contentConfig);
			children.add(uiContentTitlesBlock);
			
		}

	}
	public String getFamily() {
		return "org.exoplatform.portlets.publish.component.UIContentTitlesBlocks";
	}
}