/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.ria.component.browser;


import java.net.URL;

import org.jdesktop.jdic.browser.WebBrowserEvent;
import org.jdesktop.jdic.browser.WebBrowserListener;
/**
 * Created by The eXo Platform SARL
 * Author : Tuan Nguyen
 *          tuan08@users.sourceforge.net
 * Jul 4, 2005
 */
public class ExoWebBrowserListener implements WebBrowserListener {
  private ExoWebBrowser browser_ ;
  
  public ExoWebBrowserListener(ExoWebBrowser browser) {
    browser_ = browser ;
  }
  
  public void downloadStarted(WebBrowserEvent event) {
    browser_.updateStatusInfo("Loading page..........");
  }
  
  public void downloadCompleted(WebBrowserEvent event) {
    browser_.addrToolbar_.backBt_.setEnabled(browser_.webBrowser.isBackEnabled());
    browser_.addrToolbar_.forwardBt_.setEnabled(browser_.webBrowser.isForwardEnabled());
    browser_.updateStatusInfo("Loading completed.");
    URL currentUrl = browser_.webBrowser.getURL();
    if (currentUrl != null) {
      browser_.addrToolbar_.addressField_.setText(currentUrl.toString());
    }
  }
  
  public void downloadProgress(WebBrowserEvent event) {
  }
  
  public void downloadError(WebBrowserEvent event) {
    browser_.updateStatusInfo("Loading error.");
  }
  
  public void documentCompleted(WebBrowserEvent event) {
    browser_.updateStatusInfo("Document loading completed.");
  }
  
  public void titleChange(WebBrowserEvent event) {
    browser_.updateStatusInfo("Title of the browser window changed.");
  }  
  
  public void statusTextChange(WebBrowserEvent event) {
  }  
}