/**
 * Copyright 2001-2004 The eXo platform SARL All rights reserved.
 * Please look at license.txt in info directory for more license detail.
 **/
package org.exoplatform.services.css.scanner.model;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;


/**
 * @author Ove Ranheim (oranheim@yahoo.no)
 * @since 02.jul.2004 13:23:45
 */
public class Document implements Serializable {
    
    private Map _paths;
    private List _rules;
    private List _selectors;

    public Document() {
        _paths = new HashMap();
        _rules = new ArrayList();
        _selectors = new ArrayList();
    }
    
    public List getRules() {
        return _rules;
    }

    public List getSelectors() {
        return _selectors;
    }
    
    public void addSelector(Selector selector) {
        _selectors.add(selector);
    }   
    
    public void addPath(String path, Selector selector) {
        _paths.put(path, selector);
    }
    
    public Map getPaths() {
        return _paths;
    }

    public Selector resolveSelector(String path) {
        return (Selector) _paths.get(path);
    }
    
}
