/**
 * Copyright 2001-2004 The eXo platform SARL All rights reserved.
 * Please look at license.txt in info directory for more license detail.
 **/
package org.exoplatform.services.css.scanner.model;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;


/**
 * @author Ove Ranheim (oranheim@yahoo.no)
 * @since 02.jul.2004 12:29:57
 */
public class Selector extends Statement implements Serializable{

    private List _properties;
    private Selector _parent;
    private Selector _next;
    
    public Selector(Selector parent) {
        _properties = new ArrayList();
        _parent = parent;
    }
    
    public Selector(String name, int start, int end) {
        setName(name);
        setStart(start);
        setEnd(end);
    }
       
    public Selector getNext() {
        return _next;
    }
    
    public void setNext(Selector next) {
        _next = next;
    }
    
    public Selector getParent() {
        return _parent;
    }
    
    public void setParent(Selector parent) {
        _parent = parent;
    }
    
    public List getProperties() {
        return _properties;
    }
    
    public void setProperties(List properties) {
        _properties = properties;
    }
    
    public Property addProperty() {
        Property block = new Property();
        _properties.add(block);
        return block;
    }

    public Property addProperty(String name, int start, int end) {
        Property block = new Property();
        block.setName(name);
        block.setStart(start);
        block.setEnd(end);
        _properties.add(block);
        return block;
    }
    
    public Property getProperty(String name) {
        for(Iterator i = _properties.iterator(); i.hasNext(); ) {
            Property p = (Property) i.next();
            if (name.equals(p.getName())) {                    
                return p;
            }
        }
        return null;
    }
    
    public void removeBlock(Property block) {
        _properties.remove(block);
    }
    
    
    
}
