/**
 * Copyright 2001-2004 The eXo platform SARL All rights reserved.
 * Please look at license.txt in info directory for more license detail.
 **/
package org.exoplatform.services.css.scanner.event;

import org.exoplatform.services.css.scanner.event.ScannerEvent;
import org.exoplatform.services.css.scanner.event.ScannerListener;
import org.exoplatform.services.css.scanner.model.Document;
import org.exoplatform.services.css.scanner.model.Selector;



/**
 * @author Ove Ranheim (oranheim@yahoo.no)
 * @since 02.jul.2004 15:14:11
 */
public class DefaultScannerListener implements ScannerListener {

    private Document _document;
    private StringBuffer _path;
    
    public DefaultScannerListener() {
        _path = new StringBuffer();
    }
    
    /**
     * @param document
     */
    public void setDocument(Document document) {
        _document = document;
    }
    
    /* 
     * @see exo.services.portal.sac.event.ScannerListener#matchedRule(exo.services.portal.sac.event.ScannerEvent)
     */
    public void startRule(ScannerEvent event) {
    }

    /* 
     * @see org.exoplatform.services.css.scanner.event.ScannerListener#endRule(org.exoplatform.services.css.scanner.event.ScannerEvent)
     */
    public void endRule(ScannerEvent event) {
    }

    /* 
     * @see exo.services.portal.sac.impl.event.ScannerListener#execute(exo.services.portal.sac.impl.event.ScannerEvent)
     */
    public void startSelector(ScannerEvent event) {
        Selector selector = (Selector) event.getEventObject();
        _path.append(selector.getName()+" ");
    }

    /* 
     * @see org.exoplatform.services.css.scanner.event.ScannerListener#endSelector(org.exoplatform.services.css.scanner.event.ScannerEvent)
     */
    public void endSelector(ScannerEvent event) {
        _document.addPath(_path.toString().trim(), (Selector)event.getEventObject());
        _path = new StringBuffer();
    }

    /* 
     * @see exo.services.portal.sac.event.ScannerListener#matchedProperty(exo.services.portal.sac.event.ScannerEvent)
     */
    public void startProperty(ScannerEvent event) {
    }


    /* 
     * @see org.exoplatform.services.css.scanner.event.ScannerListener#endProperty(org.exoplatform.services.css.scanner.event.ScannerEvent)
     */
    public void endProperty(ScannerEvent event) {
    }

    /* 
     * @see exo.services.portal.sac.event.ScannerListener#matchedComment(exo.services.portal.sac.event.ScannerEvent)
     */
    public void startComment(ScannerEvent event) {
    }

    /* 
     * @see org.exoplatform.services.css.scanner.event.ScannerListener#endComment(org.exoplatform.services.css.scanner.event.ScannerEvent)
     */
    public void endComment(ScannerEvent event) {
    }


}
