/**
 * Copyright 2001-2004 The eXo platform SARL All rights reserved.
 * Please look at license.txt in info directory for more license detail.
 **/
package org.exoplatform.services.css.scanner.event;

import java.util.HashMap;
import java.util.Map;
import org.exoplatform.services.css.scanner.event.ScannerEvent;
import org.exoplatform.services.css.scanner.model.Statement;




/**
 * @author Ove Ranheim (oranheim@yahoo.no)
 * @since 02.jul.2004 14:21:24
 */
public class ScannerEventImpl implements ScannerEvent {

    private Statement _statement;
    private int _depth;
    private boolean _hasNext;
    
    public ScannerEventImpl() {
    }
    
    /* 
     * @see exo.services.portal.sac.impl.event.ScannerEvent#getEventObject()
     */
    public Statement getEventObject() {
        return _statement;
    }

    /* 
     * @see exo.services.portal.sac.impl.event.ScannerEvent#setEventObject(exo.services.portal.sac.impl.model.AbstractStatement)
     */
    public void setEventObject(Statement statement) {
        _statement = statement;
    }

    /* 
     * @see exo.services.portal.sac.event.ScannerEvent#depth()
     */
    public int depth() {
        return _depth;
    }

    /* 
     * @see exo.services.portal.sac.event.ScannerEvent#hasNext()
     */
    public boolean hasNext() {
        return _hasNext;
    }

    /* 
     * @see exo.services.portal.sac.event.ScannerEvent#isRoot()
     */
    public boolean isRoot() {
        return false;
    }

    /* 
     * @see exo.services.portal.sac.event.ScannerEvent#isChild()
     */
    public boolean isChild() {
        return false;
    }

    /* 
     * @see exo.services.portal.sac.event.ScannerEvent#isSibling()
     */
    public boolean isSibling() {
        return false;
    }

    /**
     * @param depth
     */
    public void setDepth(int depth) {
        _depth = depth;
    }
    
    public void setHasNext(boolean b) {
        _hasNext = b;
    }


}
