/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.services.grammar.bbcode.impl;

import java.io.* ;
import org.exoplatform.services.grammar.Analyzer;
import org.exoplatform.services.grammar.TokenHandler;
import org.exoplatform.services.grammar.bbcode.impl.parser.*;
/**
 * @author Tuan Nguyen (tuan08@users.sourceforge.net)
 * @since Oct 19, 2004
 * @version $Id: BBCodeAnalyzerImpl.java,v 1.1 2004/10/20 14:17:26 tuan08 Exp $
 */
public class BBCodeAnalyzerImpl implements Analyzer {
  private static ByteArrayInputStream EMPTY = new ByteArrayInputStream("EMPTY".getBytes()) ;
  private BBCodeParser stringParser_ ;
  private BBCodeParser streamParser_ ;
  
  public BBCodeAnalyzerImpl() {
    stringParser_ = new BBCodeParser((Reader) null) ;
    streamParser_ = new BBCodeParser(EMPTY) ;
  }
  
  public void analyze(StringBuffer outBuf, InputStream in) throws Exception  {
    streamParser_.ReInit(in) ;
    streamParser_.analyze(outBuf) ;
  }
  
  public void analyze(StringBuffer outBuf, String text) throws Exception  {
    stringParser_.ReInit(new StringReader(text)) ;
    stringParser_.analyze(outBuf) ;
  }
  
  public void registerTokenHandler(String name, TokenHandler handler) throws Exception {
    stringParser_.registerTokenHandler(name, handler) ;
    streamParser_.registerTokenHandler(name, handler) ;
  }
}