/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.services.grammar.bbcode.impl;

import java.util.*  ; 
import org.exoplatform.services.grammar.TokenHandler;
/**
 * @author Tuan Nguyen (tuan08@users.sourceforge.net)
 * @since Oct 19, 2004
 * @version $Id: SmileyTokenHandler.java,v 1.1 2004/10/20 14:17:26 tuan08 Exp $
 */
public class SmileyTokenHandler implements TokenHandler {
  private Map smileys_ ;
  public SmileyTokenHandler() {
    smileys_ = new HashMap() ;
    smileys_.put(":-)", ":-) image") ;
    smileys_.put(":-))", ":-)) image") ;
    smileys_.put(":-D", ":-D image") ;
    smileys_.put(":-(", ":-( image") ;
    smileys_.put(":-((", ":-(( image") ;
  }
  
  final public void encodeBegin(StringBuffer outBuf)  {  }
  
  final public void encode(StringBuffer outBuf, String token)  {
    String image = (String)smileys_.get(token) ;
    if(image != null) outBuf.append(image) ;
    else outBuf.append(token) ;
  }
  
  final public void encodeEnd(StringBuffer outBuf)  {  }
}