/**
 * Copyright 2001-2004 The eXo Platform SARL         All rights reserved.
 * Please look at license.txt in info directory for more license detail.
 **/
package org.exoplatform.services.publish;

import org.exoplatform.services.publish.model.*;
import java.util.*;
import org.exoplatform.commons.utils.PageList;
/**
 * Created by The eXo Platform SARL
 * Author : Daniel Summer
 *          danny_xcz@users.sourceforge.net
 * Date: Nov 29, 2004
 * Time: 3:22:54 PM
 */
public interface PublishService {
	public Content createContentInstance();
	public Content createContent(Section section,Content content) throws Exception;
	public void updateContent(Content content) throws Exception;
	public Content removeContent(String contentId) throws Exception;
	

	public Content findContentById(String contentId) throws Exception;
	//public Content findContentByAuthor(String userName) throws Exception;
	//public PageList findContentsByAuthor(String userName) throws Exception;
	
	public PageList findContentsBySection(String sectionId) throws Exception;
	public List findContentsBySectionAndNumber(String sectionId,int num) throws Exception;
	public PageList findContents(ContentQuery query) throws Exception;
	
	public Section createSectionInstance();
	public Section createSection(Section section) throws Exception ;
	public Section addChild(Section parent, Section child) throws Exception;
	public void updateSection(Section section) throws Exception ;
	public Section removeSection(Section section) throws Exception ;
	public Section findSectionById(String sectionId) throws Exception ;
	public Collection findSectionsByParent(Section parent) throws Exception ;

}
