/**
 * Copyright 2001-2004 The eXo platform SARL All rights reserved.
 * Please look at license.txt in info directory for more license detail.
 **/
package org.exoplatform.services.rdf.query;

import org.exoplatform.services.rdf.query.RDFQueryService;
import com.hp.hpl.jena.rdf.model.Model;
import com.hp.hpl.jena.rdql.Query;
import com.hp.hpl.jena.rdql.QueryEngine;
import com.hp.hpl.jena.rdql.QueryExecution;

/**
 * Created by the Exo Development team.
 * 
 * @author Ove Ranheim (oranheim@users.sourceforge.net)
 * @since 08.apr.2004 11:31:15
 */
public class RDFQueryServiceImpl implements RDFQueryService {

    public RDFQueryServiceImpl() {
    }

    /*
     * @see org.exoplatform.services.rdf.query.RDFQueryService#createQuery(com.hp.hpl.jena.rdf.model.Model)
     */
    public Query createQuery(Model model) {
        Query q = new Query();
        q.setSource(model);
        return q;
    }

    /*
     * @see org.exoplatform.services.rdf.query.RDFQueryService#createQuery(java.lang.String)
     */
    public Query createQuery(String sourceURL) {
        Query q = new Query();
        q.setSourceURL(sourceURL);
        return q;
    }

    /*
     * @see org.exoplatform.services.rdf.query.RDFQueryService#createQuery(com.hp.hpl.jena.rdf.model.Model,
     *      java.lang.String)
     */
    public Query createQuery(Model model, String queryString) {
        Query q = new Query(queryString);
        q.setSource(model);
        return q;
    }

    /*
     * @see org.exoplatform.services.rdf.query.RDFQueryService#createQuery(java.lang.String,
     *      java.lang.String)
     */
    public Query createQuery(String sourceURL, String queryString) {
        Query q = new Query(queryString);
        q.setSourceURL(sourceURL);
        return q;
    }

    /*
     * @see org.exoplatform.services.rdf.query.RDFQueryService#prepare(com.hp.hpl.jena.rdql.Query)
     */
    public QueryExecution prepare(Query query) {
        QueryEngine qe = new QueryEngine(query);
        return qe;
    }

}