/**
 * Copyright 2001-2004 The eXo platform SARL All rights reserved.
 * (c) Copyright 2003, 2004, Hewlett-Packard Development Company, LP All rights reserved.
 * Please look at license.txt and license_hp in info directory for more license detail.
 **/


package org.exoplatform.services.rdf.jena.tutorial;

import java.io.InputStream;
import java.io.InputStreamReader;

import com.hp.hpl.jena.rdf.model.Model;

/**
 * Created by the Exo Development team.
 * 
 * @author Ove Ranheim (oranheim@users.sourceforge.net)
 * @since 08.apr.2004 12:59:40
 */
public class TestTutorial05 extends JenaTestCase {

    /**
     * NOTE that the file is loaded from the class-path and so requires that the
     * data-directory, as well as the directory containing the compiled class,
     * must be added to the class-path when running this and subsequent
     * examples.
     */
    static final String inputFileName = "vc-db-1.rdf";

    public TestTutorial05(String name) {
        super(name);
    }
    
    public void testReadFromFileAndWriteToStdout() {
        // create an empty model
        Model model = _modelservice.createDefaultModel();

        InputStream in = getRDFResource(inputFileName);
        if (in == null) { throw new IllegalArgumentException("File: " + inputFileName + " not found"); }
        assertNotNull(in);

        // read the RDF/XML file
        model.read(new InputStreamReader(in), "");
        
        assertNotNull(model);

        // write it to standard out
        model.write(System.out);
    }
}
