/**
 * Copyright 2001-2004 The eXo platform SARL All rights reserved.
 * (c) Copyright 2003, 2004, Hewlett-Packard Development Company, LP All rights reserved.
 * Please look at license.txt and license_hp in info directory for more license detail.
 **/


package org.exoplatform.services.rdf.jena.tutorial;

import java.io.PrintWriter;

import com.hp.hpl.jena.rdf.model.Model;
import com.hp.hpl.jena.rdf.model.Resource;
import com.hp.hpl.jena.vocabulary.RDFS;

/**
 * Created by the Exo Development team.
 * 
 * @author Ove Ranheim (oranheim@users.sourceforge.net)
 * @since 08.apr.2004 12:59:40
 */
public class TestTutorial11 extends JenaTestCase {

    public TestTutorial11(String name) {
        super(name);
    }
    
    public void testMoreOnLiterals() {
        // create an empty graph
        Model model = _modelservice.createDefaultModel();

        // create the resource
        Resource r = model.createResource();

        // add the property
        r.addProperty(RDFS.label, model.createLiteral("chat", "en")).addProperty(RDFS.label,
                model.createLiteral("chat", "fr")).addProperty(RDFS.label, model.createLiteral("<em>chat</em>", true));

        // write out the graph
        model.write(new PrintWriter(System.out));
        System.out.println();

        // create an empty graph
        model = _modelservice.createDefaultModel();

        // create the resource
        r = model.createResource();

        // add the property
        r.addProperty(RDFS.label, "11").addProperty(RDFS.label, 11);
        assertEquals("11", r.getProperty(RDFS.label).getObject().toString() );

        // write out the graph
        model.write(System.out, "N-TRIPLE");
    }
}
