package org.vietspider.veis.impl.core.crawler;

import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.List;

import org.vietspider.veis.api.core.agent.Agent;
import org.vietspider.veis.impl.core.agent.AgentImpl;
import org.vietspider.veis.impl.core.io.net.UrlCreation;

public class AgentLinkStore {
  
  private ArrayList<String> array;
  
  public AgentLinkStore() {
    array = new ArrayList<String>();
  }
  public int size(){
    return array.size();
  }
  public synchronized void add( List<String> col, String address,
      UrlCreation creation, AgentChecker checker, String pattern, boolean bound){
    boolean add ;
    for( String ele : col){
      add = true;     
      ele = creation.createURL( address, ele);
      add = !array.contains( ele);      
      if( add){
        try{
          add = !(bound && ( checker.isUrl( ele, false) ||checker.isNotPart( pattern, ele)));
        }catch( Exception exp){
          exp.printStackTrace();
        }
      }      
      if( add)
        array.add( ele);
    }
    
    Collections.sort( array, new Comparator<String>() {
      public int compare( String o1, String o2) {
        return o2.length() - o1.length();
      }
    });
    
  }
  public synchronized Agent get( Agent parent, int level) {
    Agent agent = null;
    try{ 
      agent = new AgentImpl( array.get(0), level);      
      agent.setName( parent.getName());
      agent.setHome( parent.getHome());
      agent.setDomain( parent.getDomain());
      agent.setCharset( parent.getCharset());
      agent.setDepth( parent.getDepth());     
      agent.setPattern( parent.getPattern());
      agent.setAdd( parent.getAdd());
      agent.setRemove( parent.getRemove()); 
    }
    catch( Exception exp){      
    }
    if( array.size() > 0)  array.remove(0);
    return agent;
    
  }
  
}
