package org.vietspider.veis.impl.core.crawler;

import java.net.URL;
import java.util.List;

import org.vietspider.veis.api.core.agent.Agent;
import org.vietspider.veis.api.core.agent.AgentStatusLoading;
import org.vietspider.veis.api.core.agent.AgentManager;
import org.vietspider.veis.impl.core.io.base.DataBuffer;
import org.vietspider.veis.impl.core.io.net.HttpClientImpl;
import org.vietspider.veis.impl.core.io.net.UrlCreation;
import org.vietspider.veis.impl.core.text.html.DocumentProcessor;
import org.vietspider.veis.impl.core.text.html.DocumentRemover;
import org.vietspider.veis.impl.core.text.html.NodeProcessor;

public class AgentManagerImpl implements AgentManager, AgentStatusLoading {
  
  private String [] status ; 
  private AgentConfigStore config;
  
  private AgentChecker checker;  
  private HttpClientImpl connection;
  private AgentStore store;
  
  private DocumentProcessor documentProcessor;
  private NodeProcessor nodeProcessor;
  private DataBuffer buffer;
  
  private DocumentRemover remover;
  
  private Agent agent;
  private boolean cycle = false;
  
  private int time = -1;  
  
  private UrlCreation creation;
  
	public AgentManagerImpl() throws Exception {
		super();
    this.status = new String[ AgentConfig.TOTAL_THREAD];	
    this.config = new AgentConfigStore();
    
    this.documentProcessor = new DocumentProcessor();
    this.nodeProcessor = new NodeProcessor();
    this.buffer = new DataBuffer();   
    
    this.checker = new AgentChecker();
    this.store = new AgentStore();
    
    this.creation = new UrlCreation();    
	}
  
  public DataBuffer getBuffer(){
    return this.buffer;
  }
  public DocumentProcessor getDocumentProcessor(){
    return this.documentProcessor;    
  }
  public NodeProcessor getNodeProcessor(){
    return this.nodeProcessor;    
  }
  public AgentChecker getChecker(){
    return this.checker;
  }
  public HttpClientImpl getConnection(){
    return this.connection;
  }
  public UrlCreation getCreation(){
    return this.creation;
  }
  public AgentStore getStore(){
    return this.store;
  }
  
  public DocumentRemover getRemover(){
    return this.remover;
  }
  
  public void add(List<String> link, int l, String address, String name, String domain){   
    if( !name.equals( agent.getName()) || !domain.equals( agent.getDomain())) return;   
    this.store.add( link, l, address,
        this.creation, this.checker, agent.getPattern(), (l == agent.getDepth()));
    time = -1;   
  }
	
	private void init() throws Exception{  
//    end = System.currentTimeMillis();
//    System.out.println("mat khoang "+ ((end-start)/1000));
//    start = end;
    this.agent = config.get();		   
		if( this.agent == null) return;   
    
    URL u = new URL( agent.getUrl());
    this.connection = new HttpClientImpl( u.getProtocol(), u.getHost(), u.getPort());    
    this.store.init( agent); 
    if( agent.getRemove() != null && agent.getRemove().length>0){
      this.remover = new DocumentRemover( this.connection,
          this.agent.getPattern(), this.agent.getAdd(), this.agent.getRemove());     
    }else{
      this.remover = null;
    }
    cycle = false;
    time = 0;
	}  
	
	public synchronized Agent get() throws Exception {   
    if( AgentConfig.CHANGE_THREAD > -1){
      this.config.set( AgentConfig.CHANGE_THREAD);
      AgentConfig.CHANGE_THREAD = -1;
      init();
      return null;      
    }
    if( time > -1) time++;
    if( time >= 200) agent = null;
//    if( agent != null)
//      System.out.println( "have connection" +agent.getHome());
		if( this.agent == null){
      init();
      return null;      
    }
    
    if( !this.cycle){
      this.cycle = true;
      return this.agent;
    }
    
    if( this.store.end()){
      init();
      return null;
    }   
      
    if( this.store.begin()){
      return null;
    }    
    return  this.store.get();  
	}
  
  public void setStatus( String st, int id){     
      this.status[id] = st;
  }
  public String getStatus( int id){
    return status[id];
  }
}
