package org.vietspider.veis.impl.core.io.base;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.util.Properties;

public class IOProperties {	  
  
  protected synchronized  Properties load(String path ) throws Exception {	         
    return load( new File( path));
  }
  protected synchronized  Properties load( File f) throws Exception {    
    if(!f.exists())  f.createNewFile();    
    Properties p = new Properties();    
    FileInputStream input = new FileInputStream( f);
    p.load(input);
    
    input.close();    
    return p;   
  }
  protected synchronized  void save(File f, Properties p) throws Exception {
    FileOutputStream output = new FileOutputStream( f);
    p.store( output, "/* properties config by veis */");
    output.flush();
    output.close();
    output = null;
  }
  
  protected synchronized void save(String path, Properties p) throws Exception {
    save( new File( path), p);
  }
  
  
  public synchronized  void copy(String from,String dis) throws Exception {
    Properties p = load( from);
    save ( dis,p);	         
  }	
  public synchronized void delete( String path) throws Exception {
    File f=new File( path);
    if(f.exists())
      f.delete();	
  }
  
}
