package org.vietspider.veis.impl.core.io.base;

import javax.swing.filechooser.*;

import org.vietspider.veis.impl.core.text.check.NameChecker;

import java.io.File;
import java.io.FileFilter;
import java.io.IOException;
import java.net.URL;
import java.text.MessageFormat;
import java.util.Arrays;
import java.util.Comparator;

public class UtilFile extends FileSystemView {
  
  private String folder ="";
  
  public File createNewFolder(File containingDir ) throws IOException {		
    if(containingDir == null) 
      throw new IOException("Containing directory is null:");
    
    File newFolder = null;		// Using NT's default folder name
    newFolder = createFileObject(containingDir, folder);
    int i = 2;
    while (newFolder.exists() && (i < 100)) {
      newFolder = createFileObject(containingDir, MessageFormat.format(
          folder, new Object[] { new Integer(i) }));
      i++;
    }
    if( !newFolder.exists()){   
      newFolder.mkdirs();
    }
    return newFolder;
  }
  public void newFolder( File file, String f)  throws Exception {
    this.folder = f;
    createNewFolder( file);
  }
  public String getFile( String nFolder, String nFile) throws Exception{        
    String path = getFolder( nFolder)+ nFile;
    File file = new File( path);
    if( !file.exists()) file.createNewFile();
    return path;                    
  }
  public String getFolder( String f) throws Exception { 
    URL url = getClass().getResource("/");
    String path = url.getFile();
    path = path.replaceAll("\\%20"," ");  
    return this.getFolder( path, f);
  }
  public String getFolder(String path, String f) throws Exception {
    File file;       
    String [] split = f.split("\\.");  
    for( String ele : split){
      ele = ele.trim();      
      if( !(new NameChecker()).isName( ele))        
        throw new Exception("Name folder is incorrect !"+ele);      
      path += File.separator + ele ;
      file = new File( path);
      if( !file.exists()) createNewFolder( file);  
    }          
    return path + File.separator;        
  }
  public void deleteFolder(String path){
    File file = new File( path);
    File[] list = file.listFiles();
    if( list == null || list.length < 1){      
      file.delete(); 
      return;
    }
    for( File ele : list){
      if( ele.isDirectory())
        deleteFolder( ele.getAbsolutePath());
      else
        ele.delete();
    }
    file.delete();    
  }
  public File[] list( String f, FileFilter filter){
    File file =  new File ( f);
    return list( file, filter);
  }
  
  public File[] list( File file, FileFilter filter){    
    File [] files = null;
    if( filter != null) 
      files = file.listFiles( filter);
    else 
      files = file.listFiles();
    //if( files == null) return null;
    Arrays.sort( files, new Comparator<File>() {
      public int compare(File a, File b) {                     
        if( a.lastModified() < b.lastModified()) return 1;
        if( a.lastModified() == b.lastModified()) return 0;
        return -1;                
      }
    }
    );
    return files;
  }    
}
