package org.vietspider.veis.impl.core.io.local;

import java.io.File;
import java.util.ArrayList;

import org.vietspider.veis.api.core.agent.Agent;
import org.vietspider.veis.api.io.AgentCollection;
import org.vietspider.veis.impl.core.io.base.UtilFile;

public class ConfigCollection extends AgentProperties implements AgentCollection {
  
  public Agent getAgent( String name) throws Exception {
    String split[] = name.split("\\.");
    if( split.length > 1)
      return this.getAgent( split[0], split[1]);
    return null;
  }
  
  public Agent getAgent( String domain, String name) throws Exception {
    UtilFile utils = new UtilFile();	
    String path = utils.getFile("data.config."+domain, domain+"."+name);
    return super.get( path);
  }
  
  public String[] getAllAgent(String domain) throws Exception{
    UtilFile utils = new UtilFile();  
    String path = utils.getFolder("data.config."+domain);
    File file = new File( path);    
    String[] name = file.list();
    ArrayList<String> array = new ArrayList<String>();
    String[] split;
    for( int i=0; i< name.length; i++){
      split = name[i].split("\\.");
      if( split.length > 1) array.add( split[1]);
    } 
    name = new String[ array.size()];
    for( int i=0; i<name.length; i++)
      name[i] = array.get(i);
    return name;
  }
  
  public void setAgent(Agent agent) throws Exception {
    UtilFile utils = new UtilFile();  
    String path = utils.getFile("data.config."+agent.getDomain(),
        agent.getDomain()+"."+agent.getName());   
    super.set( agent, path);
  }
  
  public void setAgent( String domain) throws Exception{
    throw new Exception("Non-support this object implement !");
  }
  
  public void setAgent( String domain, String name) throws Exception {
    throw new Exception("Non-support this object implement !");
  }
  
  public void delAgent( String domain, String name) throws Exception {
    UtilFile utils = new UtilFile();	
    String path = utils.getFile("data.config."+domain, domain+"."+name);		
    super.delete( path);
  }
  
  public void delAgent( String domain) throws Exception {
    UtilFile utils = new UtilFile();    
    String path = utils.getFolder("data.config."+domain);
    utils.deleteFolder( path);
  }  
}
