/***************************************************************************
 * Copyright 2004-2006 The VietSpider Studio All rights reserved.  * 
 **************************************************************************/
package org.vietspider.veis.impl.core.io.local;

import java.io.File;
import java.io.FileInputStream;
import java.io.RandomAccessFile;
import java.nio.ByteBuffer;
import java.nio.CharBuffer;
import java.nio.channels.FileChannel;
import java.nio.charset.Charset;
import java.util.Calendar;
import java.util.Locale;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

//import org.vietspider.veis.impl.core.io.base.DataBuffer;
import org.vietspider.veis.impl.core.io.base.LoadedConvert;
import org.vietspider.veis.impl.core.io.base.UtilFile;

/**
 * @by thuannd (nhudinhthuan@yahoo.com)
 * Jun 10, 2005
 */
public class LoadedData {
  
  protected String path ;
  protected LoadedConvert convert ; 
  
  public LoadedData( String domain) throws Exception {    
    UtilFile utils = new UtilFile();   
    path = utils.getFolder("data."+domain);     
    
    File [] files = utils.list( path, null);  
    for( int i=5; i< files.length; i++)
      files[i].delete();
    
    Calendar cal=Calendar.getInstance(Locale.FRANCE);
    path = path + File.separator + String.valueOf(cal.get(Calendar.YEAR))+"_"
    + String.valueOf(cal.get(Calendar.MONTH)+1)+"_"+ String.valueOf(cal.get(Calendar.DATE));   
    File file = new File( path);         
    if( !file.exists()) file.createNewFile();   
    
    convert = new LoadedConvert();
  }
  
  public synchronized void save( String text) throws Exception {      
    RandomAccessFile current = new RandomAccessFile( path, "rw");
    current.seek( current.length());
    current.write( ("\n"+text).getBytes("utf-8"));
    current.close();
  }
  
  public synchronized boolean find( String text, boolean save) throws Exception {     
    File file = new File( path);  
    text = convert.enURL( text);
    boolean result = find( text, file);  
    if( save && !result) this.save( text);
    if( !result){       
      UtilFile utils = new UtilFile();
      File [] files = utils.list( file.getParent(), null);  
      if( files == null || files.length <= 1) return false;      
      for( int i=1; i<files.length; i++){
        if( find( text, files[i])){              
          this.save( text);
          return true; 
        }
      }
      return false;
    }    
    return result;
  }
  
  public boolean find( String text, File file) throws Exception {    
    if( text == null || text.equals("")) return true;
    Charset charset = Charset.forName("utf-8");
    Pattern pattern = Pattern.compile( text, Pattern.CASE_INSENSITIVE); 
    FileInputStream stream = new FileInputStream(file);
    FileChannel f = stream.getChannel();
    ByteBuffer bytes = f.map(FileChannel.MapMode.READ_ONLY, 0, f.size( ));
    CharBuffer chars = charset.decode(bytes);   
    Matcher matcher = pattern.matcher(chars);
    boolean result = matcher.find(); 
    chars.clear();
    bytes.clear();  
    f.close();
    stream.close();
    return result;
  } 
}
