/***************************************************************************
 * Copyright 2001-2005 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.vietspider.veis.impl.core.io.net.server;

import java.io.PrintWriter;
import java.net.ServerSocket;
import java.net.Socket;

public class BaseNetworkServer {
  
  private int port, maxConnections;  
  public static boolean exit = true; 
  
  private ServerSocket listener;
  private Socket server;
  
  public BaseNetworkServer(int port, int maxConnections) {
    setPort(port);
    setMaxConnections(maxConnections);
  }
  
  public void listen() throws Exception  {
    int i=0;      
    listener = new ServerSocket(port);    
    while((i++ < maxConnections) || (maxConnections == 0)) {
      server = listener.accept();
      handleConnection(server);        
    }
  }
  
  protected void handleConnection(Socket server) throws Exception{
    PrintWriter out = SocketUtil.getWriter(server);  
    out.println("Generic Network Server");
    server.close();
  }
  
  public int getMaxConnections() {
    return(maxConnections);
  }  
  
  public void setMaxConnections(int maxConnections) {
    this.maxConnections = maxConnections;
  }
  
  
  public int getPort() {
    return(port);
  }
  
  protected void setPort(int port) {
    this.port = port;
  }
}
