/**
 * RSS framework and reader
 * Copyright (C) 2004 Christian Robert
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package org.vietspider.veis.impl.core.rss.dom;

import java.io.Serializable;

/**
 * Implementation of the <tt>guid</tt> element with an <tt>item</tt> element
 * 
 * @author Christian Robert
 */

public class RssGuid implements Serializable {
  
  private static final long serialVersionUID = 1;

  private String myGuid               = "";
  private boolean stateIsPermaLink    = true;
  
  
  // --------------------------------------------------------------------------
  // --  Property access methods  ---------------------------------------------
  // --------------------------------------------------------------------------
  
  public String getGuid() {
    return this.myGuid;
  }

  public void setGuid(String guid) {
    this.myGuid = guid;
  }

  public boolean isIsPermaLink() {
    return this.stateIsPermaLink;
  }

  public void setIsPermaLink(boolean stateIsPermaLink) {
    this.stateIsPermaLink = stateIsPermaLink;
  }

}