package org.vietspider.veis.impl.core.text.codec;

import java.nio.ByteBuffer;
import java.nio.CharBuffer;
import java.nio.charset.Charset;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

public class CharsetFinder {
	public String getCharset( byte[] data) {
		String [] nCharsets = { "iso-8859-1" , "iso-8859-13" , "iso-8859-15" ,
					 		"iso-8859-2" , "iso-8859-3" , "iso-8859-4" ,
					 		"iso-8859-5" , "iso-8859-6" , "iso-8859-7" ,
					 		"iso-8859-8" , "iso-8859-9",
							"windows-1250" , "windows-1251" , "windows-1252" , "windows-1253" ,
							"windows-1254" , "windows-1255" , "windows-1256" , "windows-1257" ,
							"windows-1258",
							"us-ascii" , "utf-16" , "utf-8"	 };

		Charset charset = Charset.forName("utf-8");
		CharBuffer chars = charset.decode( ByteBuffer.wrap(data));
		Pattern pattern = Pattern.compile( "charset", Pattern.CASE_INSENSITIVE);
		Matcher matcher = pattern.matcher(chars);
		int end = -1;
		if(matcher.find()) {
			end = matcher.end();
		}else{
			return "utf-8";
		}
		chars = (CharBuffer)chars.subSequence( end, Math.min(end+200, chars.length()));
		String string = (new String( chars.array())).toLowerCase();
		for(String ele : nCharsets){
			if( string.indexOf( ele) > -1) return ele;
		}
		return "utf-8";
	}	
}
