/***************************************************************************
 * Copyright 2004-2006 The VietSpider Studio All rights reserved.  * 
 **************************************************************************/
package org.vietspider.veis.impl.core.text.html;

import java.util.ArrayList;
import java.util.List;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import org.vietspider.veis.impl.core.text.codec.CharsetFinder;

/**
 * @by thuannd (nhudinhthuan@yahoo.com)
 * Jun 20, 2005
 */
class DocumentParser {
  
  protected List<Tag> getTag(byte[] data, String charset) throws Exception { 
    
    if( charset == null || charset.trim().equals(""))
      charset = (new CharsetFinder()).getCharset(data);    
    return this.getTag( new String( data, charset));   
  }
  
  protected List<Tag> getTag( String html){ 
    Pattern pattern = Pattern.compile( "[<>]", Pattern.CASE_INSENSITIVE);
    Matcher matcher = pattern.matcher(html);
  
    List<Tag> tag = new ArrayList<Tag>();
    
    if( !matcher.find()) return tag;
    
    int end = matcher.start(); 
    int start = 0;
    
    while( end <= html.length()){       
        if( html.charAt( end) == '<'){
          try{
            tag.add( new Tag( html.substring( start, end).trim() ));
          }catch( Exception exp){}
          start = end;
        }else if( html.charAt( end) == '>'){          
          try{
            tag.add( new Tag( html.substring( start, end+1).trim() ));
          }catch( Exception exp){}
          start = end+1;
        }
        if( start+1>= html.length()) break;
        if( matcher.find( start+1)) 
          end = matcher.start();
        else
          break;     
    }   
    if( end < html.length()){      
      try{
        tag.add( new Tag( html.substring( end+1, html.length()).trim() ));
      }catch( Exception exp){}
    }
    return tag;
  }
  
}
