/***************************************************************************
 * Copyright 2004-2006 The VietSpider Studio All rights reserved.  * 
 **************************************************************************/
package org.vietspider.veis.impl.core.text.html;

import java.util.ArrayList;
import java.util.List;

/**
 * @by thuannd (nhudinhthuan@yahoo.com)
 * Jun 17, 2005
 */
public class Node {
  
  private Node parent;  
  private int name = -1;
  private List<Node> children;
  
  private int start = -1;
  private int end = -1;

  public Node(Node parent, int name) {
    this.parent = parent;
    if( parent != null && parent != this){      
        this.parent.addChild( this);       
    }
    this.name = name;
    children = new ArrayList<Node>();
  }
  
  public Node getParent( ){
    return this.parent;
  }
  public int getName(){
    return this.name;
  }
  public void addChild( Node n){    
    children.add( n);
  }
  public int getNumberOfChildren(){
    return this.children.size();
  }
  public Node getChild( int i){
    return this.children.get( i);
  }
    
  public int getSize(){
    return this.end - this.start;
  }
  
  public void setStart( int i){
    this.start = i;
  }
  public int getStart(){
    return this.start;
  }
  
  public void setEnd( int i){
    this.end = i;
  }
  public int getEnd(){
    return this.end;
  }
}
