/***************************************************************************
 * Copyright 2004-2006 The VietSpider Studio All rights reserved.  * 
 **************************************************************************/
package org.vietspider.veis.impl.core.text.html;

import java.util.ArrayList;
import java.util.List;

/**
 * @by thuannd (nhudinhthuan@yahoo.com)
 * Jun 18, 2005
 */
public class NodeProcessor { 
  
  public List<Tag> getTag( List<Tag> tag, Node node){
    List<Tag> list = new ArrayList<Tag>();    
    if( node == null) return list;
    for( int i = node.getStart() ; i<= Math.min( tag.size()-1, node.getEnd()); i++){
      list.add( tag.get(i));
    }
    return list;
  }  
  public List<Tag> getTag( List<Tag> tag, Node node, String config){    
    return this.getTag( tag, this.getChild( node, config));
  }
  
  public StringBuilder getText( List<Tag> tag){
    StringBuilder builder = new StringBuilder("");
    if( tag.size() < 1) return builder;
    if( tag.get(0).isOpen() && tag.get(0).isTag( 71)) {// tag is td
      builder.append( "<table><tr>");
      for( Tag ele : tag){
        if( ele != null) builder.append( ele.getValue()+"\n");
      }
      builder.append("</tr></table>");
    }else if( tag.get(0).isOpen() && ( tag.get(0).isTag( 77) || tag.get(0).isTag( 74))) {// tag is tr or th
      builder.append( "<table>");
      for( Tag ele : tag){
        if( ele != null) builder.append( ele.getValue()+"\n");
      }
      builder.append("</table>");
    }else{
      for( Tag ele : tag){
        if( ele != null) builder.append( ele.getValue()+"\n");
      }
    }
      
    return builder;
  }
  
  public Document getDocument( Document doc, String[] add) throws Exception {
    List<Tag> newTag = new ArrayList<Tag>();    
    for( String ele : add){
      if( ele != null) newTag.addAll( this.getTag( doc.getTag(), doc.getNode(), ele));     
    }
    return new Document( newTag);    
  }  
  
  public List<Tag> removeNode(List<Tag> tag, Node node){
    for( int i = node.getStart() ; i<= Math.min( tag.size()-1, node.getEnd()); i++)
      tag.set( i, null); 
    for( int i=0; i<tag.size(); i++)
      if( tag.get(i) == null){
        tag.remove( i);
        i = 0;
    }
    return tag;
  }
  
  public List<Tag> removeNode(List<Tag> tag, Node node, String config){    
    if( config.indexOf("<") > -1){      
      try{
        return this.removeNode( tag, this.getChildByValue( node , tag, config));
      }catch( Exception exp){
        return tag;
      }
    }
    return this.removeNode( tag, this.getChild( node , config));
  }
  
  public Node getChild( Node node , String config){
    if( config.trim().equals("")) return node;
    String [] split = config.split("\\.");    
    int index = -1;    
    for( String ele : split){
      try{      
        index = Integer.parseInt( ele);
        if( index >= node.getNumberOfChildren())return null;
        if( index < 0) return null;
        node = node.getChild( index);
      }catch( Exception exp){
        exp.printStackTrace();
        return null;
      }
    }    
    return node;
  }
  
  public Node getChildByValue( Node node , List<Tag> tag, String value) throws Exception {
    if( value.trim().equals("")) return node;
    value = value.trim();
    int start = -1;
    for( int i=0; i<tag.size(); i++){
      if( tag.get(i).getValue().trim().equalsIgnoreCase( value)){
        start = i;
        break;
      }
    }    
    return this.getChildByStart( node, start);
  }
  
  private Node getChildByStart( Node node ,int start){
    Node result = null;    
    if( node.getStart() != start){
      for(int i=0; i< node.getNumberOfChildren(); i++){
         result = this.getChildByStart( node.getChild( i), start);
         if( result != null) return result;
      }   
      return null;
    }      
    return node;
    
  }
  
  
}
