package org.vietspider.veis.impl.core.text.html;

import java.util.regex.Matcher;
import java.util.regex.Pattern;

class TagProcessor {
	 //find open tag
	 protected boolean close = false;
	 
	 protected String getName( String tag) throws Exception{
		 tag = getTextTag( tag);
		 if( tag == null) return null;
     if( tag.indexOf(" ") > -1)
       return tag.substring(0, tag.indexOf(" ")).toLowerCase();
     return tag.toLowerCase();	
	 }
	 private String getTextTag( String tag){
		 this.close = false;
		 if( !(tag.startsWith("<") && tag.endsWith(">"))) return null;
		 tag = tag.substring( 1, tag.length()-1).trim();
		 if( tag.startsWith("/")){
			 close= true;
			 tag = tag.substring( 1, tag.length()).trim();
		 }
		 return tag;
	 }
	 protected String getAttr( String tag) throws Exception {
		 tag = getTextTag( tag);
		 if( tag == null) return null;
		 Pattern pattern = Pattern.compile("\\p{Space}+", Pattern.CASE_INSENSITIVE);
		 String [] split = pattern.split( tag, 2);
		 if( split.length < 2) return null;		 
		 return split[1];
	 }
	 //get value attribute
	 protected String getAttr(String tag, String attr) throws Exception {
		 int i = findAttr( tag, attr);
		 if( i < 0) return null;
		 tag = tag.substring( i);
		 if( tag.startsWith("\"")) return cleanSign( tag, "\"");
		 if( tag.startsWith("\'")) return cleanSign( tag, "\'");
		 String[] split = tag.split(" ");
	     if( split.length > 0) return split[0];
		 return tag;
	 }
	 //find order attribute
	 protected int findAttr(String tag, String attr) throws Exception {
		 attr = attr.toLowerCase().trim();
		 int i = -1;
		 Pattern pattern = Pattern.compile(
				 "\\b"+attr+"\\p{Space}*=\\p{Space}*", Pattern.CASE_INSENSITIVE);
		 Matcher matcher = pattern.matcher( tag);
		 while( matcher.find()){
			 i = matcher.end(0);
		 }
		 return i;
	 }
	 //clean value attribute
	 private String cleanSign( String line, String sign){
		 if( !line.startsWith(sign))  {
			 String [] split = line.split(" ");
			 if( split.length > 0) return split[0];
			 return line;
		 }
		 if(line.indexOf( sign, 1) > -1)
			 return line.substring( 1, line.indexOf( sign, 1));
	     String [] split = line.substring( 1, line.length()).trim().split(" ");
	     if( split.length > 0) return split[0];
		 return line;
	 }
}
