package org.vietspider.veis.impl.ui.config;


import java.util.ArrayList;
import java.util.Vector;

import org.eclipse.swt.SWT;
import org.eclipse.swt.browser.Browser;
import org.eclipse.swt.browser.ProgressAdapter;
import org.eclipse.swt.browser.ProgressEvent;
import org.eclipse.swt.custom.SashForm;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Menu;
import org.eclipse.swt.widgets.ProgressBar;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;
import org.eclipse.swt.widgets.Tree;
import org.eclipse.swt.widgets.TreeItem;
import org.vietspider.veis.impl.ui.config.action.AgentAddEvent;
import org.vietspider.veis.impl.ui.config.action.AgentAddListener;
import org.vietspider.veis.impl.ui.widget.ApplicationFactory;

public class AgentAddBlockViewer extends AgentBlock {
  
  private Shell shell;
  protected Tree tree;
  protected Text txtAdd, txtAddress;	
  private ProgressBar progressBar ;
 // private Button butGo, butSelect;
  protected Browser browser;
  
  private boolean busy;
  protected int index;		
  private Vector<AgentAddListener> listeners;
  
  protected ArrayList<String> add;

  protected String charset;
  
  public AgentAddBlockViewer( Shell parent){   
    shell = new Shell( parent,  SWT.MAX | SWT.MIN | SWT.RESIZE);  
    shell.setImage( parent.getImage());
    shell.setLocation( parent.getLocation().x+20, parent.getLocation().y+10);
    shell.setLayout( new FillLayout());
    ApplicationFactory factory = new ApplicationFactory( shell, this.getClass().getName());
    
    listeners = new Vector<AgentAddListener>(); 
    add = new ArrayList<String>();
    
    SashForm sash0 = new SashForm( shell, SWT.HORIZONTAL);
    
    Composite comMain = new Composite( sash0, SWT.NONE);		
    GridLayout gridLayout = new GridLayout();
    gridLayout.numColumns = 1;
    comMain.setLayout( gridLayout);
    
    Composite comAddress = new Composite( comMain, SWT.NONE);
    GridData gridData = new GridData( GridData.FILL_HORIZONTAL);
    comAddress.setLayoutData( gridData);
    gridLayout = new GridLayout();
    gridLayout.numColumns = 4;
    comAddress.setLayout( gridLayout);
    
    factory.setComposite( comAddress);
    
    factory.createLabel( "lblAddress");   
    
    txtAddress = factory.createText();
    gridData = new GridData( GridData.FILL_HORIZONTAL);
    txtAddress.setLayoutData( gridData);       
    
    
    factory.createButton( "butGo", new SelectionAdapter(){
      public void widgetSelected(SelectionEvent evt) {
        goAddress();
      }   
    });
    
    factory.createButton( "butSelect", new SelectionAdapter(){
      public void widgetSelected(SelectionEvent evt) {
        selectAddress();
      }   
    });
    
    browser = new Browser( comMain, SWT.BORDER);	    
    gridData = new GridData( GridData.FILL_BOTH);
    browser.setLayoutData(gridData);
    browser.addProgressListener(new ProgressAdapter(){		
      public void changed(ProgressEvent event){		 		
        if(event.total == 0) return;				
        int ratio = event.current * 100 / event.total;
        progressBar.setSelection(ratio);
        busy = event.current != event.total;
        if(!busy) index = 0;				
      }
      public void completed(ProgressEvent event){		
        progressBar.setSelection(0);
        busy = false;
        index = 0;	
        return;	
      }
    });		
    
    factory.setComposite( comMain);
    
    txtAdd = factory.createText();
    txtAdd.setEditable( false);
    gridData = new GridData( GridData.FILL_HORIZONTAL);
    txtAdd.setLayoutData(gridData);    
    
    Composite comBottom = new Composite( comMain, SWT.NONE);
    gridData = new GridData( GridData.FILL_HORIZONTAL);
    comBottom.setLayoutData( gridData);
    gridLayout = new GridLayout();
    gridLayout.numColumns = 4;
    comBottom.setLayout( gridLayout);
    
    factory.setComposite( comBottom);
    
    progressBar =  new ProgressBar( comBottom, SWT.NONE);
    gridData = new GridData( GridData.FILL_HORIZONTAL);
    progressBar.setLayoutData(gridData);    
    
    factory.createButton( "butClose", new SelectionAdapter(){
      public void widgetSelected(SelectionEvent evt) {
        shell.dispose();
      }   
    });
    
    factory.createButton( "butOk", new SelectionAdapter(){
      public void widgetSelected(SelectionEvent evt) {
        try{
          clickOk();
        }catch( Exception exp){
          exp.printStackTrace();
        }
      }   
    });
    
    factory.createButton( "butAdd", new SelectionAdapter(){
      public void widgetSelected(SelectionEvent evt) {
        addItem();
      }   
    });    
        
    tree = new Tree( sash0, SWT.SINGLE | SWT.BORDER);
    tree.addSelectionListener(new SelectionAdapter(){
      public void widgetSelected(SelectionEvent evt) {
        try{
          selectTree();
        }catch( Exception exp){
          exp.printStackTrace();
        }
      }		
    });
    Menu mbar = new Menu( shell, SWT.POP_UP);		
    factory.createMenuItem( mbar, "itemExpand", new SelectionAdapter(){
      public void widgetSelected(SelectionEvent evt) {
        expandItem( null, 0);
      }		
    });   
    
    factory.createMenuItem( mbar, "itemAdd", new SelectionAdapter(){
      public void widgetSelected(SelectionEvent evt) {
        addItem();
      }   
    });  
    
    factory.createMenuItem( mbar, "itemRemove", new SelectionAdapter(){
      public void widgetSelected(SelectionEvent evt) {
        removeItem();
      }   
    });   
        
    tree.setMenu( mbar);	
    
    sash0.setWeights( new int[]{ 500, 90}); 	
    
    shell.setSize( 800,550);
    shell.open();	   
  }
  protected void selectTree() throws Exception {		
  }
  protected void goAddress() {		
  }
  protected void selectAddress(){		
  }
  protected void expandItem(TreeItem item, int depth){		
  }
  protected void addItem(){		
  }
  protected void removeItem(){		
  }
  public void fireEvent( AgentAddEvent e) {
    synchronized(listeners)  {			
      for(int i = 0; i < listeners.size(); i++){
        try{
          AgentAddListener listener = listeners.get(i);
          listener.selected(e);		        
          break;
        }catch(Exception exp){               	  
        }       
      }
    }
  }
  public void addListener( AgentAddListener listener) {    	
    synchronized(listeners) {			
      listeners.remove(listener);
      listeners.add(listener);
    }
  }
  public void removeListener( AgentAddListener listener) {
    synchronized(listeners) {
      listeners.remove(listener);
    }
  }
  public void selected( AgentAddEvent ev) {
    if(ev.getAdd() == null || ev.getAdd().size() < 1) return;
    if(ev.getUrl() == null || ev.getUrl().equals("")) return;			 
    fireEvent(ev);	   
  }	
  public void clickOk() throws Exception{
    AgentAddEvent event = new AgentAddEvent( this.add,  this.txtAddress.getText(),  doc);
    fireEvent(event);
    shell.dispose();
  }
  
}
