package org.vietspider.veis.impl.ui.config;

import org.eclipse.swt.SWT;
import org.eclipse.swt.custom.SashForm;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Menu;
import org.eclipse.swt.widgets.Shell;
import org.vietspider.veis.api.core.agent.Agent;
import org.vietspider.veis.impl.ui.config.action.AgentListEvent;
import org.vietspider.veis.impl.ui.config.action.AgentListListener;
import org.vietspider.veis.impl.ui.config.action.DomainListEvent;
import org.vietspider.veis.impl.ui.config.action.DomainListListener;
import org.vietspider.veis.impl.ui.config.action.NewAgentEvent;
import org.vietspider.veis.impl.ui.config.action.NewAgentListener;
import org.vietspider.veis.impl.ui.config.action.NewDomainEvent;
import org.vietspider.veis.impl.ui.config.action.NewDomainListener;
import org.vietspider.veis.impl.ui.widget.ApplicationFactory;

public class AgentConfigViewer {
  
  protected AgentList list;
  private AgentData data;
  
  public Shell shell;
  
  public AgentConfigViewer(){
    Display display = Display.getDefault();    
    ApplicationFactory factory = new ApplicationFactory( display, this.getClass(), 750, 520);
    shell = (Shell)factory.getComposite(); 
    shell.setLayout( new FillLayout());  
    
    SashForm sash0 = new SashForm( shell, SWT.HORIZONTAL);
    list = new AgentList(factory, sash0, SWT.NONE, SWT.VERTICAL, new int[]{ 150, 320});
    list.addDomainListener( new DomainListListener(){
      public void selectedDomain( DomainListEvent evt){
        setDomain( evt.getDomain());
      }
    });
    list.addListListener( new AgentListListener(){
      public void selected( AgentListEvent evt){
        try{
          setAgent( evt.getAgent());
        }catch(Exception exp){
          exp.printStackTrace();
        }
      }
    });
    data = new AgentData( sash0, factory, SWT.NONE);
    data.addDomainListener( new NewDomainListener(){
      public void created( NewDomainEvent evt){
        loadDomain();
      }
    });
    data.addAgentListener( new NewAgentListener(){
      public void created( NewAgentEvent evt){
        loadAgent( evt.getDomain());
      }
    });
    data.setDomain( list.getDomain());
    
    sash0.setWeights( new int[]{ 150, 520});		
    
    //create menu
    Menu mbar = new Menu( shell, SWT.BAR); 
    shell.setMenuBar( mbar);   
    Menu mSub = factory.createMenu( mbar, "menuAgent");
    
    factory.createMenuItem( mSub, "itemExportCategory",new SelectionAdapter(){
      public void widgetSelected(SelectionEvent evt) {
       exportDomain();
      }      
    });
    
    factory.createMenuItem( mSub, "itemExportSelected",new SelectionAdapter(){
      public void widgetSelected(SelectionEvent evt) {
        exportAgent();
      }      
    });
    
    factory.createMenuItem( mSub, "itemImport",new SelectionAdapter(){
      public void widgetSelected(SelectionEvent evt) {
        importDomain();
      }      
    });
    
    shell.open();	    	 
  }	
  private void setDomain(String domain){
    data.setDomain( domain);
  }
  private void setAgent(Agent agent) {		
    data.setAgent( agent);
  }
  private void loadDomain(){		
    list.loadDomain();
  }
  private void loadAgent(String d){
    list.loadAgent( d);
  }
  protected void exportDomain(){    
  }
  protected void importDomain(){    
  }
  protected void exportAgent(){    
  }
  
}
