package org.vietspider.veis.impl.ui.config;

import java.io.File;
import java.net.URL;
import java.nio.charset.Charset;
import java.util.ArrayList;

import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.MessageBox;
import org.vietspider.veis.api.core.agent.Agent;
import org.vietspider.veis.impl.core.agent.AgentImpl;
import org.vietspider.veis.impl.core.io.local.ConfigCollection;
import org.vietspider.veis.impl.core.io.local.ConfigFolder;
import org.vietspider.veis.impl.core.io.net.HttpClientImpl;
import org.vietspider.veis.impl.core.text.check.NameChecker;
import org.vietspider.veis.impl.core.text.codec.UtilConvert;
import org.vietspider.veis.impl.core.text.html.Document;
import org.vietspider.veis.impl.core.text.html.DocumentRemover;
import org.vietspider.veis.impl.core.text.html.NodeProcessor;
import org.vietspider.veis.impl.ui.config.action.AgentAddEvent;
import org.vietspider.veis.impl.ui.config.action.AgentAddListener;
import org.vietspider.veis.impl.ui.resources.ResourceManager;
import org.vietspider.veis.impl.ui.widget.ApplicationFactory;
import org.vietspider.veis.impl.ui.widget.HtmlViewer;
import org.vietspider.veis.impl.ui.widget.action.DialogInputEvent;
import org.vietspider.veis.impl.ui.widget.action.DialogInputListener;

public class AgentData extends AgentDataViewer{
  
  private Document doc;
  private String pattern = null;
  
  public AgentData(Composite parent ,ApplicationFactory factory, int style) {
    super(parent, factory, style);
  }
  protected void domain(){
    DomainInputViewer input = new DomainInputViewer( this.getShell());
    input.addListener( new DialogInputListener(){
      public void entered( DialogInputEvent evt){        
        createDomain(evt.getText());
      }
    });
  }
  private void createDomain( String domain){
    try{     
      (new ConfigFolder()).setDomain( ( new UtilConvert()).enUnicode( domain));     
      super.createdDomain( domain);			
    }catch(Exception exp){
      exp.printStackTrace();
    }
  }	
  protected void test(){
    try{			
      if( !check()) return;      
      String [] arrayAdd = this.lstAdd.getItems();
      String address = this.txtPattern.getText();			
      String charset = null;
      if( !this.txtCharset.getText().trim().equals("")) charset = this.txtCharset.getText().trim();
      Document d ;
      File file = new File( address);		
      DocumentRemover remover = null ;
      if( file.exists())
        d  = new Document( file, charset);
      else if (address.startsWith("file")){
        URL url  = new URL( address);
        file = new File( url.toURI());			
        d  = new Document( file, charset);
      }
      else{   
        URL url = new URL( address);
        HttpClientImpl httpClient = new HttpClientImpl( url.getProtocol(), url.getHost(), url.getPort());       
        byte[] obj = httpClient.loadContent( address);
        if( obj == null || obj.length<1) return;
        d  = new Document( obj, charset);        
       
        String [] arrayRemove = this.lstRemove.getItems();
       //System.out.println("remove co : "+ arrayRemove[1]);
        if( this.pattern == null ) this.pattern = this.txtPattern.getText();
        remover = new DocumentRemover( httpClient, this.pattern, arrayAdd, arrayRemove);
      }
      NodeProcessor nodeProcessor = new NodeProcessor();
      d = nodeProcessor.getDocument( d, arrayAdd);//, arrayRemove);
      if( remover != null)
        d = remover.remove( d); 
      (new HtmlViewer( this.getShell())).setText(
          nodeProcessor.getText( nodeProcessor.getTag( d.getTag(), d.getNode())).toString());
    }catch( Exception exp){
      exp.printStackTrace();
    }
  }
  protected void add(){
    String [] split = this.lstAdd.getItems();
    
    AgentAddBlock add = new AgentAddBlock( this.getShell());		
    add.setUrl( this.txtPattern.getText());    
    add.selectAddress();
    for( String ele : split) add.setConfig( ele);
    
    add.addListener( new AgentAddListener(){
      public void selected( AgentAddEvent evt){
        add( evt.getAdd(), evt.getUrl(), evt.getDocument());
      }
    });
  }
  private void add( ArrayList<String> array, String url, Document d){
    String [] block = new String[ array.size()];
    for( int i=0; i<block.length; i++)
      block[i] = array.get(i);
     
    this.lstAdd.setItems( block);
    this.txtPattern.setText( url);
    try{
      this.doc =  d;
    }catch( Exception exp){
      exp.printStackTrace();
    }
  }
  protected void remove(){    
    try{    
      String [] arrayAdd = this.lstAdd.getItems();
      NodeProcessor nodeProcessor = new NodeProcessor(); 
      
      String [] split = this.lstRemove.getItems();
      
      if( arrayAdd == null) System.out.println("ngu xi");
      AgentRemoveBlock remove = 
        new AgentRemoveBlock( this.getShell(), nodeProcessor.getDocument( this.doc, arrayAdd));
      for( String ele : split) remove.setConfig( ele);
      
      remove.addListener( new AgentAddListener(){
        public void selected( AgentAddEvent evt){
          remove( evt.getAdd());
        }
      });
    }catch( Exception exp){
      exp.printStackTrace();
    }
  }
  public void reset(){   	   
    txtHome.setText("");
    txtPattern.setText("");
    txtName.setText("");
    txtDepth.setText("1");    
    txtCharset.setText("");
    lstAdd.setItems(new String[]{});
    lstRemove.setItems(new String[]{});
    this.pattern = null;
  }
  protected void save(){
    try{		  
      if( !this.check()) return ;
      AgentImpl agent = new AgentImpl();
      UtilConvert convert = new UtilConvert();
      agent.setName( convert.enUnicode( this.txtName.getText()));
      agent.setDomain( convert.enUnicode( this.lblDomain.getText()));      
      agent.setHome( this.txtHome.getText());      
      this.pattern =  txtPattern.getText();
      URL url = new URL ( txtPattern.getText());      
      agent.setPattern( url.getFile());
      agent.setDepth( Integer.parseInt( this.txtDepth.getText().trim()));	     
      if( !this.txtCharset.getText().trim().equals("")) 
        agent.setCharset( txtCharset.getText().trim());   
    
      String [] split = this.lstAdd.getItems();	
      ArrayList<String> array = new ArrayList<String>(); 
      for( String ele : split)
        if( !ele.trim().equals("")) 
          array.add( ele);
      split = new String[ array.size()];
      for( int i=0; i<split.length; i++)
        split[i] = array.get(i);
      agent.setAdd( split);
  
      split = this.lstRemove.getItems();
      array = new ArrayList<String>(); 
      for( String ele : split)
        if( !ele.trim().equals("")) 
          array.add( ele);
      split = new String[ array.size()];
      for( int i=0; i<split.length; i++)
        split[i] = array.get(i);
      agent.setRemove( split);
      ( new ConfigCollection()).setAgent( agent);
      this.createdAgent( agent.getDomain(), agent.getName());	
    }catch( Exception exp){
      exp.printStackTrace();
    }
  }
  public void setAgent(Agent agent) {	
    if( agent == null) return;
    txtHome.setText( agent.getHome());
    try{
      URL url =  new URL(agent.getHome());
      String pattern = url.getProtocol()+"://"+url.getHost();
      if( url.getPort() > 0)
        pattern += String.valueOf(url.getPort());
      pattern += agent.getPattern();
      txtPattern.setText( pattern);
    }catch( Exception exp){          
    }   
    txtName.setText( ( new UtilConvert()).deUnicode(agent.getName()));
    txtDepth.setText( String.valueOf(agent.getDepth()));    
    String [] split = agent.getAdd();   
    this.lstAdd.setItems( split);
    
    split = agent.getRemove();
    
    this.lstRemove.setItems( split);
    
    if( agent.getCharset() == null || agent.getCharset().trim().equals("")) 
      txtCharset.setText( "");      
    else
      txtCharset.setText( agent.getCharset());
  }
  private void remove( ArrayList<String> array){
    String [] block = new String[ array.size()];
    for( int i=0; i<block.length; i++)
      block[i] = array.get(i);
    this.lstRemove.setItems( block);
  }
  public void setDomain( String d){
    this.lblDomain.setText( d);
  }
  public boolean check(){
    MessageBox message = new MessageBox( this.getShell(), SWT.YES );
    ResourceManager resource = new ResourceManager( "veis");
    String text = this.txtName.getText().trim();
    
    if( text.equals("")){
      message.setMessage(resource.getLabel( this.getClass().getName()+".msgErrorEmptyName"));
      message.open();
      return false;
    }
    
    if( !(new NameChecker()).isName( text) ){
      message.setMessage(resource.getLabel( this.getClass().getName()+".msgErrorName"));
      message.open();
      return false;
    }
    
    if( this.lblDomain.getText().trim().equals("")){
      message.setMessage(resource.getLabel( this.getClass().getName()+".msgErrorEmptyCategory"));
      message.open();
      return false;
    }
    
    if( this.txtHome.getText().trim().equals("")){
      message.setMessage(resource.getLabel( this.getClass().getName()+".msgErrorEmptyHome"));
      message.open();
      return false;
    }
    
    if( this.txtPattern.getText().trim().equals("")){
      message.setMessage(resource.getLabel( this.getClass().getName()+".msgErrorEmptyPattern"));
      message.open();
      return false;
    }
    
    if( !this.txtCharset.getText().trim().equals("") ){
      try{
        Charset.forName( this.txtCharset.getText().trim());
        
      }catch( Exception exp){
        message.setMessage(resource.getLabel( this.getClass().getName()+".msgErrorEncoding"));
        message.open();
        return false;
      }
    }
    
    try{
      Integer.parseInt(this.txtDepth.getText().trim());      
    }catch(Exception exp){
      message.setMessage(resource.getLabel( this.getClass().getName()+".msgErrorDepth"));
      message.open();
      exp.printStackTrace();
      return false;
    } 	 	
    return true;
  } 
  
}
