package org.vietspider.veis.impl.ui.config;

import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.MessageBox;
import org.vietspider.veis.impl.core.io.local.ConfigCollection;
import org.vietspider.veis.impl.core.io.local.ConfigFolder;
import org.vietspider.veis.impl.core.text.codec.UtilConvert;
import org.vietspider.veis.impl.ui.resources.ResourceManager;
import org.vietspider.veis.impl.ui.widget.ApplicationFactory;

public class AgentList extends AgentListViewer {
	
	public AgentList(ApplicationFactory factory, Composite parent, int style, int sashStyle, int[] sashSplit) {
		super(factory, parent, style, sashStyle, sashSplit);
		loadDomain();		
	}
	public void loadDomain(){		
		try{
       setDomain( ( new ConfigFolder()).getDomain());					   
			 loadAgent();
		}catch(Exception exp){
			 exp.printStackTrace();
		}
	}	
	public void setDomain( String [] domain) {		
		 UtilConvert convert = new UtilConvert();
		 for( int i=0; i<domain.length; i++)
			 domain[i] = convert.deUnicode( domain[i]);			
		 this.cbo.setItems( domain);
		 int iselect = this.cbo.getSelectionIndex();
		 if(iselect >= domain.length || iselect<0) iselect = 0;
		 this.cbo.select( iselect);
	}
	protected void removeAgent(){
		MessageBox msg = new MessageBox ( this.getShell(), SWT.APPLICATION_MODAL | SWT.YES | SWT.NO);
    ResourceManager resource = new ResourceManager( "veis");
		msg.setMessage ( resource.getLabel( this.getClass().getName()+".msgAlertDeleteAgent"));
    //"Bạn có muốn xóa luồng này không?");
		if(msg.open() == SWT.YES){		   
			ConfigCollection config = new ConfigCollection();
			try{
				UtilConvert convert = new UtilConvert();
				config.delAgent( convert.enUnicode(getDomain()), convert.enUnicode(getNameAgent()));
				loadAgent();
			}catch(Exception exp){
				exp.printStackTrace();
			}
		}
	}
	protected void removeDomain(){
		MessageBox msg = new MessageBox ( this.getShell(), SWT.APPLICATION_MODAL | SWT.YES | SWT.NO);
    ResourceManager resource = new ResourceManager( "veis");
    msg.setMessage ( resource.getLabel( this.getClass().getName()+".msgAlertDeleteCategory"));
//		msg.setMessage ("Bạn có muốn xóa toàn bộ luồng và chuyên mục này không?");
		if(msg.open() == SWT.YES){		
			try{
				UtilConvert convert = new UtilConvert();
				( new ConfigFolder()).delDomain( convert.enUnicode(getDomain()));
				loadDomain();
			}catch(Exception exp){
				exp.printStackTrace();
			}
		}
	}
	public void setAgent( String [] agent) {		
		 UtilConvert convert = new UtilConvert();
		 for( int i=0; i<agent.length; i++)
			 agent[i] = convert.deUnicode( agent[i]);			
		 this.list.setItems( agent);		
	}
	protected void loadAgent(String d){
		try{
			this.setAgent( (new ConfigCollection()).getAllAgent( d));
		}catch( Exception exp){
			exp.printStackTrace();
		}
	}
	protected void loadAgent(){
		 if(this.cbo.getSelectionIndex() > -1)
		     this.loadAgent( (new UtilConvert()).enUnicode(
		    		 this.cbo.getItem(this.cbo.getSelectionIndex())));
		 return ;
		
	}	

}
