package org.vietspider.veis.impl.ui.config;

import java.util.Vector;

import org.eclipse.swt.SWT;
import org.eclipse.swt.custom.SashForm;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.List;
import org.eclipse.swt.widgets.Menu;
import org.vietspider.veis.impl.ui.config.action.AgentListEvent;
import org.vietspider.veis.impl.ui.config.action.AgentListListener;
import org.vietspider.veis.impl.ui.config.action.DomainListEvent;
import org.vietspider.veis.impl.ui.config.action.DomainListListener;
import org.vietspider.veis.impl.ui.widget.ApplicationFactory;

public class AgentListViewer extends Composite {
  
  protected List list;
  protected List cbo;
  
  private Vector<AgentListListener> listeners;	
  private Vector<DomainListListener> listeners2;
  
  public AgentListViewer(ApplicationFactory factory, Composite parent, int style, int sashStyle, int[] sashSplit) {
    super(parent, style);
    parent = factory.getComposite();
    String parentName = factory.getClassName();
    
    factory.setClassName( this.getClass().getName());
    
    listeners = new Vector<AgentListListener>();
    listeners2 = new Vector<DomainListListener>();
    
    this.setLayout( new FillLayout());    
    SashForm sash = new SashForm( this, sashStyle);
    factory.setComposite( sash);
  
    factory.setComposite( factory.createGroup( "groupCategory", null, new FillLayout()));   
    cbo = factory.createList( new String[]{}, new SelectionAdapter(){
      public void widgetSelected(SelectionEvent evt) {
        loadAgent();
        elementSelectedDomain();
      }      
    });
    
    factory.setComposite( sash);
    
    factory.setComposite( factory.createGroup( "groupAgent", null, new FillLayout()));
    list = factory.createList(
        SWT.MULTI | SWT.BORDER | SWT.V_SCROLL | SWT.H_SCROLL, new String[]{},
        new SelectionAdapter(){
          public void widgetSelected(SelectionEvent evt) {
            elementSelected();
          }
        }
    );
//    list = new List( grpAgent, 
//        SWT.MULTI | SWT.BORDER | SWT.V_SCROLL | SWT.H_SCROLL);
//    list.addSelectionListener(new SelectionAdapter(){
//      public void widgetSelected(SelectionEvent evt) {
//        elementSelected();
//      }
//    });
//    list.setFont(new Font( parent.getDisplay(),"Tahoma", 10, SWT.NORMAL));
    
    Menu menu = new Menu( this.getShell(), SWT.POP_UP);	   
    factory.createMenuItem( menu, "itemDeleteAgent", new SelectionAdapter(){
          public void widgetSelected(SelectionEvent evt) {
            removeAgent();
          }
        }
    );
    this.list.setMenu( menu);
    
    menu = new Menu( this.getShell(), SWT.POP_UP); 
    factory.createMenuItem( menu, "itemDeleteCategory", new SelectionAdapter(){
        public void widgetSelected(SelectionEvent evt) {
          removeDomain();
        }
      }
    );
    this.cbo.setMenu( menu);
    
    sash.setWeights( sashSplit);
    
    factory.setComposite( parent);
    factory.setClassName( parentName);
  }
  public String getNameAgent(){
    if( this.list.getSelection() != null 
        && this.list.getSelection().length > 0)
      return this.list.getSelection()[0];
    return  "";		 
  }
  public String[] getAllNameAgent(){
    return this.list.getSelection();
  }
  public String getDomain(){
    if(this.cbo.getSelectionIndex() > -1)
      return this.cbo.getItem(this.cbo.getSelectionIndex());
    return "";
  }
  protected void loadAgent(){}
  protected void removeAgent(){}
  protected void removeDomain(){}
  
//event
  public void fireEvent( AgentListEvent e) {
    synchronized(listeners)  {
      for(int i = 0; i < listeners.size(); i++){
        try{
          AgentListListener listener = listeners.get(i);
          listener.selected(e);
          break;
        }catch(Exception exp){               	  
        }       
      }
    }
  }
  public void addListListener( AgentListListener listener) {    	
    synchronized(listeners) {
      listeners.remove(listener);
      listeners.add(listener);
    }
  }
  public void removeListListener( AgentListListener listener) {
    synchronized(listeners) {
      listeners.remove(listener);
    }
  }
  public void selected( AgentListEvent ev) {
    if(ev.getDomain() == null || ev.getDomain().equals("")) return;
    if(ev.getName() == null || ev.getName().equals("")) return;			 
    fireEvent(ev);	   
  }	
  public void elementSelected()  {
    AgentListEvent e = new AgentListEvent( this.getDomain(), this.getNameAgent());
    fireEvent(e);
  }	
  
//event
  public void fireEvent2( DomainListEvent e) {
    synchronized(listeners2)  {
      for(int i = 0; i < listeners2.size(); i++){
        try{
          DomainListListener listener = listeners2.get(i);
          listener.selectedDomain(e);
          break;
        }catch(Exception exp){               	  
        }       
      }
    }
  }
  public void addDomainListener( DomainListListener listener) {    	
    synchronized(listeners2) {
      listeners2.remove(listener);
      listeners2.add(listener);
    }
  }
  public void removeDomainListener( DomainListListener listener) {
    synchronized(listeners2) {
      listeners2.remove(listener);
    }
  }
  public void selectedDomain( DomainListEvent ev) {
    if(ev.getDomain() == null || ev.getDomain().equals("")) return;	   		 
    fireEvent2(ev);	   
  }	
  public void elementSelectedDomain()  {
    DomainListEvent e = new DomainListEvent( this.getDomain());
    fireEvent2(e);
  }	
}
