package org.vietspider.veis.impl.ui.config;

import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.TreeItem;
import org.vietspider.veis.impl.core.text.html.Document;
import org.vietspider.veis.impl.core.text.html.DocumentProcessor;
import org.vietspider.veis.impl.core.text.html.NodeProcessor;

public class AgentRemoveBlock extends AgentRemoveBlockViewer {  
  
  public AgentRemoveBlock( Shell parent, Document d){
    super( parent);
    this.doc = d;
    init();
  }	
  
  protected void init(){
    try{		
      if( doc == null) return;
      this.tree.removeAll();
      this.createTreeItem( this.tree);
      NodeProcessor nodeProcessor = new NodeProcessor();
      this.browser.setText( 
          nodeProcessor.getText( nodeProcessor.getTag( doc.getTag(), doc.getNode())).toString());
    }catch( Exception exp){
      exp.printStackTrace();
    }
  }
  protected void selectTree() throws Exception {
    //get config indentified block
    TreeItem[] items = tree.getSelection();
    if( items == null || items.length  < 1) return;
    TreeItem item = items[0];
    String txt = this.getConfig( item);
    this.txtAdd.setText( txt);
    
    NodeProcessor nodeProcessor = new NodeProcessor();
    DocumentProcessor docProcessor = new DocumentProcessor();
    
    String content = nodeProcessor.getText(
        nodeProcessor.getTag( doc.getTag(), nodeProcessor.getChild( doc.getNode(), txt))).toString();
    content = docProcessor.removeScript( content);
    this.browser.setText( "<html><body>"+content+"</body></html>");    
    //expand tree with children		 
    this.expandTreeItem( items[0], txt);
  }	
  private void expandTreeItem( TreeItem item, String config) throws Exception {
    if( item.getItemCount() > 0) return;
    this.createTreeItem( item , config);
    item.setExpanded( true);
  }
  
  protected void expandItem( TreeItem item, int depth){
    TreeItem[] items;
    int d = depth+1;
    if( item == null){
      items = tree.getSelection();
      if( items == null || items.length  < 1) return;
      item = items[0];
    }
    String config = this.getConfig( item);
    try{
      if( item.getItemCount() < 1)
        this.createTreeItem( item, config);      
      items = item.getItems();
      for( TreeItem ele : items)
        if(depth <= 3) expandItem( ele, d);
      item.setExpanded( true);
    }catch( Exception exp){
      exp.printStackTrace();
    }
  }  
  protected void addItem(){
    TreeItem[] items = tree.getSelection();
    if( items == null || items.length  < 1) return;
    TreeItem item = items[0];		
    this.remove.add( this.getConfig( item));
    item.setBackground( new Color( item.getDisplay(), 230, 230, 230));
  }

  protected void removeItem(){
    TreeItem[] items = tree.getSelection();
    if( items == null || items.length  < 1) return;
    TreeItem item = items[0];	
    String c = this.getConfig( item);
    for( int i=0; i< remove.size(); i++){
      if( remove.get(i).equals( c)){
        remove.remove( i);
        break;
      }
    }		
    item.setBackground( new Color( item.getDisplay(), 255, 255, 255));
  }	
  
  public void setConfig( String c){
    if( c.trim().equals("")) return;
    String [] split = c.split("\\.");
    if( split.length < 1) return;		
    try{			
      TreeItem item = this.tree.getItem( Integer.parseInt( split[0]) );
      this.tree.setSelection( new TreeItem[] {item});
      selectTree();
      for( int i=1; i<split.length; i++){			
        item = item.getItem( Integer.parseInt( split[i]) );
        this.tree.setSelection( new TreeItem[] {item});
        selectTree();
      }
      item.setBackground( new Color( item.getDisplay(), 230, 230, 230));
      this.remove.add( c);
    }catch( Exception exp){
      exp.printStackTrace();
    }
  } 
}
