/***************************************************************************
 * Copyright 2004-2006 The VietSpider Studio All rights reserved.  * 
 **************************************************************************/
package org.vietspider.veis.impl.ui.publisher;

import java.io.File;
import java.util.Properties;

import org.eclipse.swt.SWT;
import org.eclipse.swt.browser.Browser;
import org.eclipse.swt.browser.ProgressAdapter;
import org.eclipse.swt.browser.ProgressEvent;
import org.eclipse.swt.custom.CLabel;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.Font;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Menu;
import org.eclipse.swt.widgets.MenuItem;
import org.eclipse.swt.widgets.ProgressBar;
import org.eclipse.swt.widgets.ToolBar;
import org.eclipse.swt.widgets.ToolItem;
import org.eclipse.ui.forms.events.HyperlinkAdapter;
import org.eclipse.ui.forms.events.HyperlinkEvent;
import org.vietspider.veis.impl.core.io.base.UtilFile;
import org.vietspider.veis.impl.core.io.local.SystemProperties;
import org.vietspider.veis.impl.ui.config.AgentConfig;
import org.vietspider.veis.impl.ui.widget.ApplicationFactory;

/**
 * @by thuannd (nhudinhthuan@yahoo.com)
 * Jun 19, 2005
 */
public class ContentViewer extends Composite{
  
  protected Browser browser;
  protected Combo cboPage;
  protected ProgressBar progressBar ;
  protected CLabel lblSource;
  
  protected String path = "";
  protected int level = 1; 
  
  private  boolean busy;
  protected int index;
  
  public ContentViewer( ApplicationFactory factory, Composite parent, int style) {
    super( parent, style); 
    
    factory.setComposite( this);
    factory.setClassName( this.getClass().getName());
    
    GridLayout gridLayout = new GridLayout();
    this.setLayout( gridLayout);
    
    final ToolBar bar = new ToolBar( this, SWT.HORIZONTAL);
    
    Menu menuStation =  factory.createToolItem( bar, "station.gif");
    
    factory.createMenuItem( menuStation, "itemSpider", "download.gif", new SelectionAdapter(){
      public void widgetSelected(SelectionEvent evt) {
        runProgram( "spider.exe");
      }      
    });
    
    boolean startSpider =  true;
    try{
      SystemProperties properties = new SystemProperties();
      Properties p = properties.get();   
      if( p.getProperty("START_SPIDER") == null || p.getProperty("START_SPIDER").trim().equals("")) 
        startSpider = false;
    }catch( Exception exp){}
    factory.createMenuItem( menuStation, SWT.CHECK,"itemStartSpider", new SelectionAdapter(){
      public void widgetSelected(SelectionEvent evt) {
        SystemProperties properties = new SystemProperties();
        try{
          Properties p = properties.get();   
          if( p.getProperty("START_SPIDER") == null || p.getProperty("START_SPIDER").trim().equals("")){
            properties.set( "START_SPIDER", "true");
          }else{
            properties.set( "START_SPIDER", "");
          }
        }catch( Exception exp){}
      }      
    }).setSelection( startSpider); 
    if( startSpider) runProgram( "spider.exe");
    
    factory.createMenuItem( menuStation, "itemConfig", "config.gif", new SelectionAdapter(){
      public void widgetSelected(SelectionEvent evt) {
        new AgentConfig();  
      }      
    }); 
    
    factory.createMenuItem( menuStation, "itemLanguage", "language.gif", new SelectionAdapter(){
      public void widgetSelected(SelectionEvent evt) {
        selectLanguage();
      }      
    }); 
    
    new MenuItem(menuStation, SWT.SEPARATOR);  
    
    factory.createMenuItem( menuStation, "itemExit", "exit.gif", new SelectionAdapter(){
      public void widgetSelected(SelectionEvent evt) {
        System.exit( -1); 
      }      
    });  
    
    new ToolItem(bar, SWT.SEPARATOR);
    new ToolItem(bar, SWT.SEPARATOR);   
   
    Menu menuData =  factory.createToolItem( bar, "data.gif");
    
    factory.createMenuItem( menuData, "itemSaveContent", "savecontent.gif", new SelectionAdapter(){
      public void widgetSelected(SelectionEvent evt) {
        saveContent();
      }      
    });  
    
    factory.createMenuItem( menuData, "itemSaveImage", "saveimage.gif", new SelectionAdapter(){
      public void widgetSelected(SelectionEvent evt) {
        saveImage();
      }      
    });  
   
    factory.createMenuItem( menuData, "itemSaveStore", "store.gif", new SelectionAdapter(){
      public void widgetSelected(SelectionEvent evt) {
        saveStore();
      }      
    });  
    
    new MenuItem(menuData, SWT.SEPARATOR);
    
    factory.createMenuItem( menuData, "itemEditContent", "edit.gif", new SelectionAdapter(){
      public void widgetSelected(SelectionEvent evt) {
        editContent();
      }      
    });  
    
    factory.createMenuItem( menuData, "itemDeleteContent", "delete.gif", new SelectionAdapter(){
      public void widgetSelected(SelectionEvent evt) {
        deleteContent();
      }      
    });     
    
    new MenuItem(menuData, SWT.SEPARATOR);
    
    factory.createMenuItem( menuData, "itemViewSource", "websource.gif", new SelectionAdapter(){
      public void widgetSelected(SelectionEvent evt) {
        viewSource();
      }      
    }); 
    
    factory.createMenuItem( menuData, "itemLoadAgain", "download.gif", new SelectionAdapter(){
      public void widgetSelected(SelectionEvent evt) {
        loadAgaint();
      }      
    }); 
   
    new ToolItem(bar, SWT.SEPARATOR);
    new ToolItem(bar, SWT.SEPARATOR);    
 
    Menu menuHelp = factory.createToolItem( bar, "help.gif");
    
    factory.createMenuItem( menuHelp, "itemHelp", "smallhelp.gif", new SelectionAdapter(){
      public void widgetSelected(SelectionEvent evt) {        
      }      
    }); 
    
    factory.createMenuItem( menuHelp, "itemAbout", "about.gif", new SelectionAdapter(){
      public void widgetSelected(SelectionEvent evt) {        
      }      
    }); 
    
    browser  = new Browser( this, SWT.NONE);   
    browser.addProgressListener(new ProgressAdapter(){   
      public void changed(ProgressEvent event){
        progressBar.setVisible( true);
        if(event.total == 0) return;        
        int ratio = event.current * 100 / event.total;
        progressBar.setSelection(ratio);
        busy = event.current != event.total;
        if(!busy) index = 0;        
      }
      public void completed(ProgressEvent event){     
        progressBar.setSelection(0);
        busy = false;
        index = 0; 
      }
    });  
    GridData gridData = new GridData(GridData.FILL_BOTH);
    browser.setLayoutData(gridData);
    try{
      UtilFile util = new UtilFile();
      File file = new File(util.getFile("data.temp", "about.htm"));
      browser.setUrl( file.toURL().toString());      
    }catch( Exception exp){}
   
    Composite top = new Composite( this, SWT.NONE); 
    gridData = new GridData(GridData.FILL_HORIZONTAL); 
    gridData.heightHint = 30;
    top.setLayoutData(gridData);    
    gridLayout = new GridLayout();   
    gridLayout.numColumns = 10;
    top.setLayout( gridLayout);
    
    lblSource = new CLabel( top , SWT.LEFT | SWT.SHADOW_ETCHED_OUT);  
    lblSource.setBackground( new Color( this.getDisplay(), 255, 255, 255));
    lblSource.setForeground( new Color( this.getDisplay(), 0, 80, 189));
    lblSource.setBackground(new Color[]{ new Color( this.getDisplay(), 255, 255, 255),
        top.getBackground()}, new int[] { 100}, false);// 
    lblSource.setFont(new Font( this.getDisplay(), "Times New Roman", 12, SWT.BOLD | SWT.ITALIC));    
    lblSource.setText( ""); 
    gridData = new GridData(GridData.FILL_BOTH);      
    lblSource.setLayoutData(gridData);
    
    factory.setComposite( top);
    
    factory.createIcon( "butPrevious", new HyperlinkAdapter(){     
      public void linkActivated(HyperlinkEvent e){
        previousPage();
      }
    });
    
    factory.createLabel( SWT.RIGHT).setText( "      ");
    factory.createLabel( "lblPage");    
    factory.createLabel( SWT.RIGHT).setText( "  ");
    
    cboPage = factory.createCombo(  new SelectionAdapter(){
      public void widgetSelected(SelectionEvent evt) { 
        selectedPage();
      }      
    }); 
    gridData = new GridData();
    gridData.widthHint = 40;
    cboPage.setLayoutData(gridData);    
    factory.createLabel( SWT.RIGHT).setText( "      ");
    
    factory.createIcon( "butNext", new HyperlinkAdapter(){     
      public void linkActivated(HyperlinkEvent e){
       nextPage();
      }
    });    
    factory.createLabel( SWT.RIGHT).setText( "      ");
    
    factory.createIcon( "butView", new HyperlinkAdapter(){     
      public void linkActivated(HyperlinkEvent e){
        selectedPage();
      }
    });  
    factory.createLabel( SWT.RIGHT).setText( "      ");   
    
    Composite bottom = new Composite(this, SWT.NONE);
    gridData = new GridData(GridData.FILL_HORIZONTAL); 
    gridData.heightHint = 40;
    bottom.setLayoutData(gridData);    
    gridLayout = new GridLayout();
    gridLayout.numColumns = 5;
    bottom.setLayout( gridLayout);
    
    factory.setComposite( bottom);
    
    gridData = new GridData( GridData.FILL_HORIZONTAL);
    progressBar =  factory.createProgress( gridData); 
    
    factory.createIcon( "butUpdate", new HyperlinkAdapter(){     
      public void linkActivated(HyperlinkEvent e){
        updatePage();
      }
    });  

    factory.createIcon( "butStop", new HyperlinkAdapter(){     
      public void linkActivated(HyperlinkEvent e){
        stopPage();
      }
    });  
    
    factory.createIcon( "butBack", new HyperlinkAdapter(){     
      public void linkActivated(HyperlinkEvent e){
        backPage();
      }
    });  
    
    factory.createIcon( "butForward", new HyperlinkAdapter(){     
      public void linkActivated(HyperlinkEvent e){
        forwardPage();
      }
    });       
    
  }
  protected void selectLanguage(){}
  protected void selectedPage(){}
  protected void nextPage(){}
  protected void previousPage(){}
  protected void stopPage(){}
  protected void updatePage(){}
  protected void backPage(){}
  protected void forwardPage(){}  
  public void update(){}
  protected void saveImage(){}
  protected void saveContent(){}
  protected void saveStore(){}
  protected void editContent(){}
  protected void deleteContent(){}
  protected void viewSource(){}
  protected void loadAgaint(){}
  protected void runProgram( String name){}
  
}
