/***************************************************************************
 * Copyright 2004-2006 The VietSpider Studio All rights reserved.  * 
 **************************************************************************/
package org.vietspider.veis.impl.ui.publisher;

import java.io.File;
import java.util.ArrayList;
import java.util.List;

import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Font;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.TreeItem;
import org.vietspider.veis.impl.core.io.base.UtilFile;
import org.vietspider.veis.impl.core.text.codec.UtilConvert;
import org.vietspider.veis.impl.ui.resources.ResourceManager;
import org.vietspider.veis.impl.ui.widget.ApplicationFactory;
import org.vietspider.veis.impl.ui.widget.ImageLoader;

/**
 * @by thuannd (nhudinhthuan@yahoo.com)
 * Jun 19, 2005
 */
public class Menu extends MenuAction {
  
  public Menu(ApplicationFactory factory, Composite parent, int style) {
    super(factory, parent, style);
    refresh();    
  }  
  
  protected void refresh(){
    loadDate();
    selectedDate();    
  }
  
  protected void selectedDate(){
    try{      
      loadDomain( new File( this.getDateSelected()));
      ResourceManager resource = new ResourceManager( "veis");    
      sectionDate.setText( resource.getLabel( 
          this.getClass().getName()+".sectionDate")+" "+ this.lstDate.getSelection()[0].trim());
      sectionDate.setExpanded( false);    
    }catch( Exception exp){
      exp.printStackTrace();
    }
  }
  
  protected void loadDate(){
    try{     
      UtilFile util = new UtilFile();         
      File [] list = util.list( util.getFolder("data.web"), null);
      if( list == null || list.length == 0) return;
      List<String> array = new ArrayList<String>();
      for( int i = 0; i< Math.min( 5, list.length); i++)
        if( list[i].isDirectory())  array.add( list[i].getName());       
      
      for( int i = 5; i< list.length; i++)
        util.deleteFolder( list[i].getAbsolutePath());
      
      String split[];
      String[] data = new String[ array.size()];
      for( int i= 0; i< array.size() ; i++){        
        split =  array.get(i).split("_");
        if( split != null && split.length > 2)         
          data[i] =  "             "+split[2]+"/"+split[1]+"/"+split[0];          
      }           
      this.lstDate.setItems( data);
      this.lstDate.setSelection( 0);      
    }catch(Exception exp){
      exp.printStackTrace();
    }
  }
  protected void loadDomain( File file){
    treeDomain.removeAll();     
    File [] lstFile = file.listFiles();
    UtilConvert convert = new UtilConvert();
    
    Image image = (new ImageLoader()).load( this.getDisplay(), "domain.gif");  
    if( lstFile == null) return;
    for( int i=0; i< lstFile.length; i++){ 
      TreeItem item  = new TreeItem( treeDomain, SWT.NONE);
      if( image != null) item.setImage( image);
      item.setFont(new Font( this.getDisplay(), "Times New Roman", 12, SWT.NORMAL));
      item.setText( convert.deUnicode( lstFile[i].getName()));                
      createSource( lstFile[i], item);     
    }    
  }
  public void createSource(  File file, TreeItem parent){   
    String[] lstName = file.list();
    UtilConvert convert = new UtilConvert();
    if( lstName == null || lstName.length < 1)  return ;   
    
    Image image = (new ImageLoader()).load( this.getDisplay(), "source.gif");  
    
    for( int i=0; i< lstName.length; i++){
      TreeItem item  = new TreeItem( parent, SWT.NONE); 
      if( image != null) item.setImage( image);
      item.setText( convert.deUnicode( lstName[i]).trim());
      item.setFont(new Font( this.getDisplay(), "Times New Roman", 11, SWT.NORMAL));
    }       
  }
  
  
  
}
