/***************************************************************************
 * Copyright 2004-2006 The VietSpider Studio All rights reserved.  * 
 **************************************************************************/
package org.vietspider.veis.impl.ui.publisher;

import java.io.File;
import java.util.List;
import java.util.prefs.Preferences;

import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.FileDialog;
import org.vietspider.veis.api.io.ProgressDialog;
import org.vietspider.veis.impl.core.io.base.DataBuffer;
import org.vietspider.veis.impl.core.io.base.UtilFile;
import org.vietspider.veis.impl.core.io.base.ZipFolderImpl;
import org.vietspider.veis.impl.ui.publisher.business.AccessHtmlFile;
import org.vietspider.veis.impl.ui.publisher.business.CollectionPageCreation;
import org.vietspider.veis.impl.ui.publisher.business.SearchPageCreation;
import org.vietspider.veis.impl.ui.resources.ResourceManager;
import org.vietspider.veis.impl.ui.widget.ProgressDialogImpl;
import org.vietspider.veis.impl.ui.widget.action.DialogInputEvent;
import org.vietspider.veis.impl.ui.widget.action.DialogInputListener;

/**
 * @by thuannd (nhudinhthuan@yahoo.com)
 * Jun 19, 2005
 */
public class PublisherImpl extends PublisherRun {

  public PublisherImpl() {
    super(); 
  }
  
  public void selectedPath( String path, int level){    
    this.content.setPath( path, level);
  }
  
  public void selectedStore( String path){    
    this.content.setStore( path);
  }
  
  public void menuUpdate(){
    this.menu.loadDate();
  }
  
  protected void import_(){
    Preferences prefs = Preferences.userNodeForPackage( getClass());     
    String p = prefs.get("path", "");
    FileDialog dialog = new FileDialog( shell, SWT.OPEN);
    if( p != null) dialog.setFilterPath( p);
    p = dialog.open();
    if( p != null) prefs.put("path", p);
    if( p == null || p.trim().equals("") || !p.trim().endsWith("wde")) return;    
    ZipFolderImpl zip = new ZipFolderImpl();
    try{    
      File input = new File( p);
      ResourceManager resource = new ResourceManager( "veis"); 
      ProgressDialog progress = new ProgressDialogImpl( shell, resource.getLabel( 
          this.getClass().getName()+".progressImport")); 
      zip.extractToFiles( input, null, progress);
      this.menu.loadDate();
    }catch( Exception exp){
      exp.printStackTrace();
    }   
  }
  public void export_(){
    this.export_( content.getPath(), content.getLevel());
  }
  public void export_( String path, int level){
    Preferences prefs = Preferences.userNodeForPackage( getClass());     
    String p = prefs.get("path", "");
    FileDialog dialog = new FileDialog( shell, SWT.SAVE);
    if( p != null) dialog.setFilterPath( p);
    p = dialog.open();
    if( p != null) prefs.put("path", p);
    if( p == null || p.trim().equals("")) return;
    AccessHtmlFile access = new AccessHtmlFile();
    DataBuffer buffer = new DataBuffer();
    ResourceManager resource = new ResourceManager( "veis"); 
    ProgressDialog progress = new ProgressDialogImpl( shell, resource.getLabel( 
        this.getClass().getName()+".progressExport")); 
    File input = new File( path);
    File output = new File( p);
    List<File> list = access.loadFolder( input, level);
    access.copyFile( list, output, buffer, progress);     
    ZipFolderImpl zip = new ZipFolderImpl();
    try{    
      input = output;
      output = new File( p+".wde");
      zip.addToArchive( input, output, progress);
      UtilFile util = new UtilFile();
      util.deleteFolder( input.getAbsolutePath());
    }catch( Exception exp){
      exp.printStackTrace();
    }   
  }
  
  public void search( ){           
    SearchInputViewer input = new SearchInputViewer( this.shell);   
    input.addListener( new DialogInputListener(){
      public void entered( DialogInputEvent evt){
        search( evt.getText());
      }
    });
    
  }
  private void search( String text){
    ResourceManager resource = new ResourceManager( "veis"); 
    ProgressDialog progress = new ProgressDialogImpl( this.shell,resource.getLabel( 
        this.getClass().getName()+".progressSearch")); 
    try{      
      String temp = (new SearchPageCreation()).loadData(
          progress, this.content.getPath(), this.content.getLevel(), text);
      this.content.browser.setUrl( (new File(temp)).toURL().toString());
    }catch( Exception exp){
      exp.printStackTrace();
    }
    progress.dispose();    
  }
  
  public void creationCollection(){
    String path =  content.getPath();
    int level = content.getLevel();
    Preferences prefs = Preferences.userNodeForPackage( getClass());     
    String p = prefs.get("path", "");
    FileDialog dialog = new FileDialog( shell, SWT.SAVE);
    if( p != null) dialog.setFilterPath( p);
    p = dialog.open();
    if( p != null) prefs.put("path", p);
    if( p == null || p.trim().equals("")) return;
    
    CollectionPageCreation access = new CollectionPageCreation();
    DataBuffer buffer = new DataBuffer();
    ResourceManager resource = new ResourceManager( "veis");    
    ProgressDialog progress = new ProgressDialogImpl( shell, resource.getLabel( 
                                  this.getClass().getName()+".progressExportDocument")); 
    File input = new File( path);
    File output = new File( p);
    List<File> list = access.loadFolder( input, level);
    access.copyFile( list, output, buffer, progress);
    try{     
      access.loadData( progress, p);
    }catch( Exception exp){
      exp.printStackTrace();
    }   
    progress.dispose();
  }
  
  protected void selectedRSS( String path){
    rss.setState( 0);
    ResourceManager resource = new ResourceManager( "veis");   
    content.setTitle(  resource.getLabel( "run") +"  "+rss.getTitle()+"..."); 
  }
  

}
