/***************************************************************************
 * Copyright 2001-2005 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.vietspider.veis.impl.ui.publisher;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.Font;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Menu;
import org.eclipse.swt.widgets.MenuItem;
import org.eclipse.swt.widgets.Tree;
import org.eclipse.ui.forms.widgets.FormToolkit;
import org.eclipse.ui.forms.widgets.Section;
import org.vietspider.veis.impl.core.rss.dom.RssChannel;
import org.vietspider.veis.impl.ui.widget.ApplicationFactory;

/**
 * @by thuannd (nhudinhthuan@yahoo.com)
 * @since Jul 26, 2005
 */
public class RSSViewer extends Composite {
  
  protected Tree treeRSS;
  protected Section  sectionRSS; 
  
  protected List<RssChannel> listChannel;

  public RSSViewer(ApplicationFactory factory, Composite parent, int style) {
    super( parent, style);
    
    factory.setClassName( this.getClass().getName());
    
    GridLayout gridLayout = new GridLayout();
    gridLayout.numColumns = 1;   
    this.setLayout( gridLayout);
    
    sectionRSS = new Section( this, Section.TWISTIE | Section.TITLE_BAR );    
    GridData gridData = new GridData(GridData.FILL_HORIZONTAL);        
    gridData.horizontalSpan = 1;    
    sectionRSS.setLayoutData(gridData);  
    sectionRSS.setLayout( new FillLayout());
    sectionRSS.setText( factory.getLabel( "sectionRSS"));
    sectionRSS.setFont(new Font( this.getDisplay(), "Tahoma", 11, SWT.NORMAL));
    sectionRSS.setForeground( new Color( this.getDisplay(), 26, 140, 255));    
    
    sectionRSS.setTitleBarForeground(  new Color( this.getDisplay(), 26, 140, 255));
    sectionRSS.setTitleBarGradientBackground( new Color( this.getDisplay(), 255, 255, 255));
    sectionRSS.setTitleBarBackground( new Color( this.getDisplay(), 200, 200, 200));
       
    Composite composite = new Composite ( sectionRSS, SWT.NONE);    
    composite.setLayout( new FillLayout());
    FormToolkit toolkit = new FormToolkit( this.getDisplay());
    treeRSS = toolkit.createTree( composite, SWT.SINGLE);    
    treeRSS.setForeground( new Color( this.getDisplay(), 0, 64, 64));   
    treeRSS.setFont(new Font( this.getDisplay(), "Times New Roman", 13, SWT.NORMAL));
    treeRSS.addListener(SWT.Selection, new Listener() {
      public void handleEvent(Event e) {    
        elementDomainSelected();
      }          
    });   
    sectionRSS.setClient( composite); 
    
    final Menu menu = new Menu ( this.getShell(), SWT.POP_UP);
    factory.createMenuItem( menu, "itemUpdate", "update.gif", new SelectionAdapter(){
      public void widgetSelected(SelectionEvent evt) {        
      }      
    });   
    
    new MenuItem (menu, SWT.SEPARATOR);
    
    factory.createMenuItem( menu, "itemNew", "add.gif", new SelectionAdapter(){
      public void widgetSelected(SelectionEvent evt) {   
        newRSS();
      }      
    });   
    
    factory.createMenuItem( menu, "itemView", "info.gif", new SelectionAdapter(){
      public void widgetSelected(SelectionEvent evt) {    
        viewRSS();
      }      
    });   
    
    factory.createMenuItem( menu, "itemDelete", "delete.gif", new SelectionAdapter(){
      public void widgetSelected(SelectionEvent evt) {   
        deleteRSS();
      }      
    });      
    this.sectionRSS.setMenu( menu);
    this.treeRSS.setMenu( menu);
    
    listChannel = new ArrayList<RssChannel>();
  }
  
  protected void load() throws Exception{}
  protected void newRSS(){}
  protected void viewRSS(){}
  protected void deleteRSS(){}
  protected void elementDomainSelected(){};

}
