/***************************************************************************
 * Copyright 2001-2005 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.vietspider.veis.impl.ui.publisher;

import java.util.Vector;

import org.eclipse.swt.widgets.Composite;
import org.vietspider.veis.impl.ui.publisher.action.StoreEvent;
import org.vietspider.veis.impl.ui.publisher.action.StoreListener;
import org.vietspider.veis.impl.ui.widget.ApplicationFactory;

/**
 * @by thuannd (nhudinhthuan@yahoo.com)
 * @since Jul 26, 2005
 */
public class StoreAction extends StoreViewer {
  
  protected Vector<StoreListener> lStore;  

  public StoreAction(ApplicationFactory factory, Composite parent, int style) {
    super(factory, parent, style);  
    
    lStore = new Vector<StoreListener>();   
  }
  
//implement listener for store event 
  
  public void fireStoreEvent( StoreEvent e) {
    synchronized(lStore)  {      
      for(int i = 0; i < lStore.size(); i++){
        try{
          StoreListener listener = lStore.get(i);
          listener.store(e);           
          break;
        }catch(Exception exp){                  
        }       
      }
    }
  }
  public void addStoreListener( StoreListener listener) {     
    synchronized(lStore) {     
      lStore.remove(listener);
      lStore.add(listener);
    }
  }
  public void removeStoreListener( StoreListener listener) {
    synchronized(lStore) {
      lStore.remove(listener);
    }
  }
  public void storeData( StoreEvent ev) {  
    fireStoreEvent(ev);     
  } 
  
  public void storeData(){
    StoreEvent event = new StoreEvent( this.getStoreSelected());
    fireStoreEvent(event);  
  }

}
