/***************************************************************************
 * Copyright 2004-2006 The VietSpider Studio All rights reserved.  * 
 **************************************************************************/
package org.vietspider.veis.impl.ui.publisher.business;

import java.io.File;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.List;

import org.vietspider.veis.api.io.ProgressDialog;
import org.vietspider.veis.impl.core.io.base.DataBuffer;
import org.vietspider.veis.impl.core.io.base.UtilFile;
import org.vietspider.veis.impl.core.io.filter.HtmlFilter;
import org.vietspider.veis.impl.core.io.net.HttpConnectionImpl;
import org.vietspider.veis.impl.core.text.check.TagChecker;
import org.vietspider.veis.impl.core.text.html.Document;
import org.vietspider.veis.impl.core.text.html.NodeProcessor;
import org.vietspider.veis.impl.core.text.html.Tag;

/**
 * @by thuannd (nhudinhthuan@yahoo.com)
 * Jun 25, 2005
 */
public class AccessHtmlFile {
  
  protected UtilFile util  = new UtilFile(); 
  
  public List<File> loadFolder( File folder, int level){
    List<File> list = new ArrayList<File>();  
    if( folder.isDirectory() && level == 3){
      File[] listHtml = folder.listFiles( new HtmlFilter());        
      for( File ele : listHtml){
        list.add( ele);       
      }     
    }else{     
      File[] listFolder = folder.listFiles();     
      for( File ele : listFolder){      
        if( ele.isDirectory() && level == 0)
          list.addAll( loadFolder( ele, 1));
        if( ele.isDirectory() && level == 1)
          list.addAll( loadFolder( ele, 2));
        if( ele.isDirectory() && level == 2)
          list.addAll( loadFolder( ele, 3));      
      }
    }
    Collections.sort( list, new Comparator<File>() {
      public int compare(File a, File b) {                     
        if( a.lastModified() < b.lastModified()) return 1;
        if( a.lastModified() == b.lastModified()) return 0;
        return -1;                
      }
    });
    return list;
  }  
  
  public void copyFile( List<File> list, File output, DataBuffer buffer, ProgressDialog dialog){
    dialog.setMax( list.size());
    for( File ele : list){
      try{
        this.copyToFolder( ele, output, buffer);
        if( dialog != null) dialog.count();
      }catch ( Exception exp){
        exp.printStackTrace();
      }
    }
  }
  
  public void copyToFolder( File input, File output, DataBuffer buffer) throws Exception{
    File temp = input.getParentFile();
    String name = "";
    while( !temp.getName().equals("data")){
      name = "."+temp.getName()+name;
      temp = temp.getParentFile();
    }   
    String folder = util.getFolder( output.getParent(), output.getName()+name);
    temp = new File( folder+File.separator+input.getName());
    this.copyFile( input, temp, buffer);
    
    name = input.getName();
    name = name.substring( 0, name.indexOf(".htm"));
    folder = folder.substring(0, folder.length()-1);
    File [] lst = (new File(input.getParent()+File.separator+name)).listFiles();
    if( lst != null){    
      util.createNewFolder(  new File(folder + File.separator + name));
      for( File ele :lst)     
        copyFile( ele, new File( folder + File.separator + name + File.separator + ele.getName()), buffer);      
    }        
  }
  public void copyFile( File input , File output, DataBuffer buffer) throws Exception {
    buffer.saveByte( output, buffer.loadByte( input));  
  }
  public void copyImage( 
      File input , String output, String folder, DataBuffer buffer, int l) throws Exception {
    String name = input.getName();
    name = name.substring( 0, name.indexOf(".htm"));    
    File [] lst = (new File(input.getParent()+File.separator+name)).listFiles();
    if( folder == null) folder = name;
    util.createNewFolder( new File( output + File.separator + folder));
    if( lst == null || lst.length < 1){      
      if( l > 1) return;      
      Document doc = new Document( input, null);
      loadImageAgaint( doc.getTag(), input.getParent()+File.separator+name);
      NodeProcessor node = new NodeProcessor();
      String content = node.getText( doc.getTag()).toString();
      buffer.saveByte( input, content.getBytes( "utf-8"));      
      copyImage( input, output, folder, buffer, 2);
      return ;
    }
    for( File ele :lst)     
      copyFile( ele, new File( output+File.separator+folder+File.separator+ele.getName()), buffer);        
  }
  
  public void loadImageAgaint( List<Tag> tag, String folder) throws Exception {
    
    TagChecker checker = new TagChecker();  
    String addressImg;
    HttpConnectionImpl connection = new HttpConnectionImpl();
    int index = 0;
    util.createNewFolder( new File( folder));
    
    for( int i = 0 ;i<tag.size() ;i++){     
      if(  (tag.get(i).isOpen() || tag.get(i).isSingle())
           && checker.isImage( tag.get(i).getValue().toLowerCase())){ 
        addressImg = tag.get(i).getAttribute("src");
        if( addressImg != null && !addressImg.trim().equals("")){          
          tag.get(i).replaceAttribute("src", 
              (new File( folder)).getName()+"\\"+String.valueOf( index)+".jpg");
          String path =  folder+File.separator+String.valueOf(index)+".jpg";        
          connection.loadResource( addressImg, path);          
          index++;
        }                 
      }
    }
  }
  
}
