/***************************************************************************
 * Copyright 2004-2006 The VietSpider Studio All rights reserved.  * 
 **************************************************************************/
package org.vietspider.veis.impl.ui.publisher.business;

import java.io.File;
import java.util.List;

import org.vietspider.veis.impl.core.text.html.Document;

/**
 * @by thuannd (nhudinhthuan@yahoo.com)
 * Jun 21, 2005
 */

public class TempPageCreation extends PageCreation implements Runnable{ 
  
  private int state = -1;  
  private Thread t;  

  private String folder;
  private int level;
  private int total = 0;
  
  public TempPageCreation(){
    t = new Thread( this);
    t.start();
  }
  
  public void start( String f, int l){
    this.folder = f;
    this.level = l;
    state = 0;
    total = 0;
  }
  
  public void run(){    
    while( true){
      try{
        if( state == 0){          
          loadData();
          state = 2;
        }
        Thread.sleep( 1000);
      }catch( Exception exp){
        exp.printStackTrace();
      }
    }
  }
  
  public void loadData( ){ 
    try{
      util.deleteFolder( util.getFolder("data.temp.web"));
    }catch( Exception exp){
      exp.printStackTrace();
    } 
    String title;
    int i = 0;
    List<File> list = loadFolder( new File(folder), level);  
    
    StringBuilder html = new StringBuilder();
    html.append( head);   
    for( ; i< list.size(); i++){
      if( i>0 && i%10 == 0){
        html.append( "\n</table></div></html>");        
        try{
          String path = util.getFile( "data.temp.web", String.valueOf( i/10)+".htm");
          buffer.saveByte( path, html.toString().getBytes("utf-8"));
        }catch( Exception exp){
          exp.printStackTrace();
        }
        html = new StringBuilder();
        html.append( head);
      }
      
      try{
        Document doc = new Document( list.get(i), null);
        title =  processor.getTitle( doc.getTag());        
        html.append( createDescription( list.get(i).getAbsolutePath(), title
            , processor.getDescription( doc.getTag(), title),  processor.getImage( doc.getTag()), true));        
      }catch( Exception exp){
        exp.printStackTrace();
      }
      total++;
      if( state != 1) state = 1;
    }
    int pageCount = i/10;
    if(i>0 && i%10 != 0) pageCount = i/10 +1;
    html.append( "\n</table></div></html>");        
    try{
      String path = util.getFile( "data.temp.web", String.valueOf( pageCount)+".htm");
      buffer.saveByte( path, html.toString().getBytes("utf-8"));
    }catch( Exception exp){
      exp.printStackTrace();
    } 
    this.total = pageCount;
  }
  
  public int getTotal(){
    return this.total;
  }
  
  public int getState(){
    return this.state;
  }
  
  public void setState( int i){
    this.state = i;
  }
}
