package org.vietspider.veis.impl.ui.spider;

import java.util.Vector;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Shell;
import org.vietspider.veis.impl.core.io.local.LoadCollection;
import org.vietspider.veis.impl.core.text.codec.UtilConvert;
import org.vietspider.veis.impl.ui.config.AgentList;
import org.vietspider.veis.impl.ui.spider.action.AgentAddEvent;
import org.vietspider.veis.impl.ui.spider.action.AgentAddListener;
import org.vietspider.veis.impl.ui.widget.ApplicationFactory;

public class AgentAddViewer {
  
  private Shell shell;
  private AgentList list;
  private Vector<AgentAddListener> listeners;
  
  public AgentAddViewer(Shell parent){		
    shell = new org.eclipse.swt.widgets.Shell( parent);
    shell.setLocation( parent.getLocation().x+150, parent.getLocation().y+50);   
    GridLayout gridLayout = new GridLayout();
    gridLayout.numColumns = 2;		
    shell.setLayout( gridLayout);
    
    ApplicationFactory factory = new ApplicationFactory( shell, this.getClass().getName());
    
    listeners = new Vector<AgentAddListener>();
    
    list = new AgentList( factory, shell, SWT.NONE, SWT.HORIZONTAL, new int[]{ 250, 250});
    GridData gridData = new GridData(GridData.FILL_BOTH);
    gridData.horizontalSpan = 2;
    list.setLayoutData(gridData);
    
    gridData = new GridData(GridData.FILL_HORIZONTAL);  
    factory.createButton( "butAddAll", new SelectionAdapter(){
      public void widgetSelected(SelectionEvent evt) {
        addAllAgent();
        createdAction();
      }   
    }).setLayoutData( gridData);    
   
    factory.createButton( "butAdd", new SelectionAdapter(){
      public void widgetSelected(SelectionEvent evt) {
        addAgent();
        createdAction();
      }   
    }).setLayoutData( gridData);   
       
    shell.setSize( 450, 400);		
    shell.open();
  }
  private void addAgent(){
    try{
      UtilConvert convert = new UtilConvert();
      (new LoadCollection()).setAgent( 
          convert.enUnicode(list.getDomain()), convert.enUnicode(list.getNameAgent()));
    }catch( Exception exp){
      exp.printStackTrace();
    }
  }
  private void addAllAgent(){
    try{
      UtilConvert convert = new UtilConvert();
      (new LoadCollection()).setAgent( convert.enUnicode(list.getDomain()));
    }catch( Exception exp){
      exp.printStackTrace();
    }
  }
  //new domain
  public void fireAddEvent( AgentAddEvent e) {
    synchronized(listeners)  {
      for(int i = 0; i < listeners.size(); i++){
        try{
          AgentAddListener listener = listeners.get(i);
          listener.add(e);
          break;
        }catch(Exception exp){               	  
        }       
      }
    }
  }
  public void addAddListener(  AgentAddListener listener) {    	
    synchronized(listeners) {
      listeners.remove(listener);
      listeners.add(listener);
    }
  }
  public void removeAddListener(  AgentAddListener listener) {
    synchronized(listeners) {
      listeners.remove(listener);
    }
  }
  public void add (AgentAddEvent ev) {	    		 
    fireAddEvent(ev);	   
  }	
  public void createdAction()  {
    AgentAddEvent e = new  AgentAddEvent( );
    fireAddEvent(e);
  }	
}
