/***************************************************************************
 * Copyright 2004-2006 The VietSpider Studio All rights reserved.  * 
 **************************************************************************/
package org.vietspider.veis.impl.ui.spider;

/**
 * @by thuannd (nhudinhthuan@yahoo.com)
 * Jun 26, 2005
 */
import java.util.Properties;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;
import org.vietspider.veis.impl.core.io.local.ProxyProperties;
import org.vietspider.veis.impl.core.text.codec.CharacterEncoder;
import org.vietspider.veis.impl.ui.resources.ResourceManager;
import org.vietspider.veis.impl.ui.widget.ApplicationFactory;
/**
 * @author thuannd
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class ProxyViewer {
  
  private org.eclipse.swt.widgets.Shell shell = null;
  private Text txtHost, txtPort, txtDomain, txtUser, txtPass;
  private Label lbl;
  
  public ProxyViewer(Shell parent) {    
    shell = new org.eclipse.swt.widgets.Shell( parent);    
    shell.setLayout( null);
    shell.setLocation( parent.getLocation().x+250, parent.getLocation().y+120);
        
    ApplicationFactory factory = new ApplicationFactory( shell, this.getClass().getName());
    
    factory.createLabel( "lblHost").setBounds( 5, 10, 70, 20);    
    txtHost = factory.createText();
    txtHost.setBounds( 90, 10, 200, 20);
  
    factory.createLabel( "lblPort").setBounds( 5, 40, 70, 20);     
    txtPort = factory.createText();
    txtPort.setBounds( 90, 40, 50, 20);
    
    factory.createLabel( "lblDomain").setBounds(  5, 70, 70, 20);  
    txtDomain = factory.createText();
    txtDomain.setBounds( 90, 70, 150, 20);
    
    factory.createLabel( "lblUser").setBounds(  5, 100, 70, 20);  
    txtUser = factory.createText();
    txtUser.setBounds( 90, 100, 150, 20);
        
    factory.createLabel( "lblPass").setBounds( 5, 130, 70, 20);     
    txtPass = factory.createText();   
    txtPass.setEchoChar('x'); 
    txtPass.setBounds( 90, 130, 150, 20);
    
    factory.createButton( "butOk", new SelectionAdapter(){
      public void widgetSelected(SelectionEvent evt) {
        enter();   
      }   
    }).setBounds( 50, 170, 100, 20); 
    
    factory.createButton( "butCancel", new SelectionAdapter(){
      public void widgetSelected(SelectionEvent evt) {
        cancel();  
      }   
    }).setBounds( 160, 170, 100, 20);   
   
    
    lbl = factory.createLabel( SWT.CENTER);
    lbl.setBounds( 0, 210, shell.getSize().x, 20); 
    
    load();
    
    shell.setSize( 300, 250);      
    shell.open();    
  } 
  public boolean check(){
    if( this.txtPort.getText().trim().equals( ""))
      this.txtPort.setText( "80");
    try{
      Integer.parseInt(this.txtPort.getText().trim());
      return true;
    }catch(Exception exp){     
      ResourceManager resource = new ResourceManager("veis");      
      lbl.setText( resource.getLabel(this.getClass().getName()+".msgErrorPort"));
      return false;
    }
  }
  public void enter(){
    try{
      if( !check()) return;
      String pass = this.txtPass.getText();
      pass = (new CharacterEncoder()).encodeBuffer(pass.getBytes());
      ProxyProperties  io = new ProxyProperties();
      io.set( this.txtHost.getText(), this.txtPort.getText(), this.txtDomain.getText(), 
          this.txtUser.getText(), pass);
      shell.dispose();
    }catch(Exception exp){
      //exp.printStackTrace();
    }
  }
  public void cancel(){   
    this.txtHost.setText("");
    this.txtPort.setText("80");
    this.txtDomain.setText("");
    this.txtUser.setText("");
    this.txtPass.setText("");
  }
  public void load(){
    ProxyProperties  io = new ProxyProperties();
    try{
      Properties pro = io.get();       
      this.txtHost.setText( pro.getProperty("ProxyHost"));
      this.txtPort.setText( pro.getProperty("ProxyPort"));
      this.txtDomain.setText( pro.getProperty("ProxyDomain"));
      this.txtUser.setText( pro.getProperty("ProxyLogin"));
      this.txtPass.setText( pro.getProperty("ProxyPass"));
    }catch(Exception exp){
      exp.printStackTrace();
    }
  }    
  
}
