package org.vietspider.veis.impl.ui.spider;

import java.io.File;

import org.eclipse.swt.SWT;
import org.eclipse.swt.browser.Browser;
import org.eclipse.swt.custom.SashForm;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.ShellAdapter;
import org.eclipse.swt.events.ShellEvent;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.layout.RowLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Menu;
import org.eclipse.swt.widgets.MenuItem;
import org.eclipse.swt.widgets.MessageBox;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Table;
import org.vietspider.veis.impl.core.crawler.AgentConfig;
import org.vietspider.veis.impl.core.io.base.UtilFile;
import org.vietspider.veis.impl.ui.resources.ResourceManager;
import org.vietspider.veis.impl.ui.widget.ApplicationFactory;
import org.vietspider.veis.impl.ui.widget.ShellSetter;

public class SpiderViewer {  
  protected Browser browser;
  protected Table table;
  protected Label [] lbl;
  protected final Shell shell;
  
  public SpiderViewer( Display display){      
    ApplicationFactory factory = new ApplicationFactory( display, this.getClass(), 750, 520);    
    shell = (Shell) factory.getComposite();    
    GridLayout gridLayout = new GridLayout();
    gridLayout.numColumns = 1;		
    shell.setLayout( gridLayout);      
    
    SashForm sashMain = new SashForm( shell, SWT.HORIZONTAL);
    GridData gridData = new GridData(GridData.FILL_BOTH);	   
    gridData.grabExcessHorizontalSpace = true;
    sashMain.setLayoutData(gridData);
    
    factory .setComposite( sashMain);
    
    Group groupAgent =  factory.createGroup( "groupAgent", null, new FillLayout());
    factory.setComposite( groupAgent);
    
    table = factory.createTable( "table", new SelectionAdapter(){
      public void widgetSelected(SelectionEvent evt){
        showData();
      }      
    });  
    table.setLinesVisible(true);
    table.setHeaderVisible(true);  
    
    factory.setComposite( sashMain);
    Group groupData = factory.createGroup( "groupData", null, new FillLayout());
    
    UtilFile util = new UtilFile();
    browser = new Browser( groupData, SWT.BORDER);
    try{
      File file = new File(util.getFile("data.temp", "about.htm"));
      browser.setUrl( file.toURL().toString());      
    }catch( Exception exp){}
    
    sashMain.setWeights( new int[]{ 350, 520});
    
    Composite butCom = new Composite( shell, SWT.NONE);
    gridData = new GridData(GridData.FILL_HORIZONTAL);		
    butCom.setLayoutData(gridData);
    RowLayout rowLayout = new RowLayout();
    butCom.setLayout( rowLayout);
    rowLayout.justify = true;
    
    factory.setComposite( butCom);
    factory.createButton( "butSelect", new SelectionAdapter(){
      public void widgetSelected(SelectionEvent evt) {
        changeThread(); 
      }   
    });    
    factory.createButton( "butAdd", new SelectionAdapter(){
      public void widgetSelected(SelectionEvent evt) {
        addAgent();
      }   
    });    
    factory.createButton( "butRemove", new SelectionAdapter(){
      public void widgetSelected(SelectionEvent evt) {
        removeAgent();
      }   
    });    
    factory.createButton( "butClear", new SelectionAdapter(){
      public void widgetSelected(SelectionEvent evt) {
        removeAll();
      }   
    });    
    factory.createButton( "butFav", new SelectionAdapter(){
      public void widgetSelected(SelectionEvent evt) {
        favorite();
      }   
    });
    
    factory.setComposite( shell);     
    
    gridData = new GridData(GridData.FILL_HORIZONTAL);	   
    gridData.grabExcessHorizontalSpace = true;    
    FillLayout fill = new FillLayout();
    fill.type = SWT.VERTICAL;    
    Group group = factory.createGroup( "groupStatus", gridData, fill);   
    
    factory.setComposite( group);    
    lbl = new Label[ AgentConfig.TOTAL_THREAD];//eisSpiderStatus.total()];
    for( int i=0 ; i<lbl.length; i++){
      lbl[i] = factory.createLabel( SWT.BORDER);      
      lbl[i].setText("");
    }		   
    
    //create menu
    Menu mbar = new Menu( shell, SWT.BAR);      
    Menu mSub = factory.createMenu( mbar, "menu");       
    
    factory.createMenuItem( mSub, SWT.CASCADE | SWT.CHECK,
        "itemLoadImage",new SelectionAdapter(){
      public void widgetSelected(SelectionEvent evt) {
        configLoadResource();
      }      
    }).setSelection( AgentConfig.LOAD_RESOURCES);
    
    factory.createMenuItem( mSub, SWT.CASCADE | SWT.CHECK,
        "itemRemoveScript",new SelectionAdapter(){
      public void widgetSelected(SelectionEvent evt) {
        configRemoveScript();
      }      
    }).setSelection( AgentConfig.REMOVE_SCRIPT);    
    
    factory.createMenuItem( mSub, SWT.CASCADE | SWT.CHECK,
        "itemSaveOrder",new SelectionAdapter(){
      public void widgetSelected(SelectionEvent evt) {
        configSaveThread();
      }      
    }).setSelection( AgentConfig.SAVE_ORDER);    
    
    factory.createMenuItem( mSub, "itemSetSpeed",new SelectionAdapter(){
      public void widgetSelected(SelectionEvent evt) {
        setSpeed();
      }      
    });  
    
    new MenuItem( mSub, SWT.SEPARATOR);
    
    factory.createMenuItem( mSub, "itemSetProxy",new SelectionAdapter(){
      public void widgetSelected(SelectionEvent evt) {
        setProxy();
      }      
    });      
    shell.setMenuBar( mbar);   
    
    shell.addShellListener( new ShellAdapter(){		 	  
      public void shellClosed(ShellEvent e){
       exit();
      }
      
    });
    shell.open();	
    loadAgent();        
  }
  protected void loadAgent(){}
  protected void addAgent(){}
  protected void removeAgent(){}
  protected void removeAll(){}
  protected void favorite(){}
  protected void showData(){}
  protected void changeThread(){}  
  protected void configLoadResource(){}
  protected void configRemoveScript(){}
  protected void configSaveThread(){}
  protected void setProxy(){}
  protected void setSpeed(){}
  protected void exit(){
    MessageBox message = new MessageBox( shell, SWT.YES  | SWT.NO);      
    ResourceManager resource = new ResourceManager( "veis");        
    message.setMessage ( resource.getLabel( this.getClass().getName()+".msgAlertExit"));       
    if(   message.open() == SWT.YES){
      new ShellSetter( this.getClass(), shell); 
      System.exit( -1);            
    }else
      shell.setMinimized( true);        
    new ShellSetter( this.getClass(), shell); 
  }
  
}
