/***************************************************************************
 * Copyright 2004-2006 The VietSpider Studio All rights reserved.  * 
 **************************************************************************/
package org.vietspider.veis.impl.ui.widget;

import org.eclipse.swt.SWT;
import org.eclipse.swt.custom.CLabel;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.Font;
import org.eclipse.swt.widgets.ProgressBar;
import org.eclipse.swt.widgets.Shell;
import org.vietspider.veis.api.io.ProgressDialog;

/**
 * @by thuannd (nhudinhthuan@yahoo.com)
 * Jun 22, 2005
 */
public class ProgressDialogImpl implements ProgressDialog { 
  
  private ProgressBar progressBar;
  private Shell sShell;
  private CLabel lbl;
  
  public ProgressDialogImpl( Shell parent, String name){    
    sShell = new Shell( parent, SWT.BORDER);
    sShell.setSize(new org.eclipse.swt.graphics.Point(553, 120));  
    sShell.setLocation( parent.getLocation().x+250, parent.getLocation().y+300);
    progressBar = new ProgressBar(sShell, SWT.NONE);
    sShell.setText("");
    sShell.setLayout(null);
    lbl = new CLabel( sShell , SWT.LEFT | SWT.SHADOW_ETCHED_OUT);  
    lbl.setBackground( new Color( sShell.getDisplay(), 255, 255, 255));
    lbl.setForeground( new Color( sShell.getDisplay(), 0, 80, 189));
    lbl.setBackground(new Color[]{ new Color( sShell.getDisplay(), 255, 255, 255),
        sShell.getBackground()}, new int[] { 100}, false);// 
    lbl.setFont(new Font( sShell.getDisplay(), "Times New Roman", 12, SWT.BOLD )); 
    lbl.setBounds( 0, 0, sShell.getSize().x, 30);
    lbl.setText( name);
    progressBar.setBounds(new org.eclipse.swt.graphics.Rectangle(20, 60,500,20));
    progressBar.setBackground( new Color( sShell.getDisplay(), 255, 255, 255));
    progressBar.setForeground( new Color( sShell.getDisplay(), 128, 128, 255));    
    sShell.open();    
  }
  public void setName( String name){
    lbl.setText( name);
  }
  public void setMax( int max){
    progressBar.setMaximum( max);
  }  
  public void setValue( int v){
    progressBar.setSelection( v);
  }
  public int getValue( ){
    return progressBar.getSelection( );
  }
  public void count(){
    this.setValue( this.getValue()+1);
  }
  public void dispose(){
    this.sShell.setMinimized( true);
    this.sShell.dispose();
  }
}
