/***************************************************************************
 * Copyright 2001-2005 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.vietspider.veis.impl.ui.widget;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Layout;
import org.eclipse.swt.widgets.List;
import org.eclipse.swt.widgets.Menu;
import org.eclipse.swt.widgets.MenuItem;
import org.eclipse.swt.widgets.ProgressBar;
import org.eclipse.swt.widgets.Table;
import org.eclipse.swt.widgets.Text;
import org.eclipse.ui.forms.events.IHyperlinkListener;
import org.eclipse.ui.forms.widgets.ImageHyperlink;

/**
 * @by thuannd (nhudinhthuan@yahoo.com)
 * @since Jul 12, 2005
 */
public class UIFactory extends WidgetFactory {
 
  protected Composite composite;
  
  public UIFactory( Composite composite) {
    this.composite = composite;
  }
  
  public Button createButton(  int style){
    return super.createButton( this.composite, style);
  }
  
  public Button createButton( int style, String text){
    return super.createButton( this.composite, style, text);   
  }
  
  public Button createButton( String text){
    return super.createButton( this.composite, SWT.PUSH, text);   
  } 
  
  public Button createButton( String text,SelectionListener listener){
    return super.createButton( this.composite, SWT.PUSH, text, listener);   
  } 
  
  public Button createButton( String text, String tip,SelectionListener listener){
    return super.createButton( this.composite, SWT.PUSH, text, tip, listener);   
  } 
  
  public ImageHyperlink createIcon( int style, 
      Image img, Image img1, String tip, IHyperlinkListener listener) {
    return super.createIcon( this.composite, style, img, img1, tip, listener);   
  } 
  
  public Button createButton( Image icon, String tip,SelectionListener listener){
    return super.createButton( this.composite, icon, tip, listener);   
  } 
  
  public Label createLabel( int style){
    return super.createLabel( this.composite, style);
  }
  
  public Label createLabel( int style, String text){
    return super.createLabel( this.composite, style, text);  
  }
  
  public Label createLabel( String text){
    return super.createLabel( this.composite, SWT.NONE, text);  
  }  
  
  public Text createText(int style){
    return super.createText( this.composite, style);
  }
  
  public Text createText(String text){
    return super.createText( this.composite, SWT.BORDER | SWT.SINGLE, text);  
  }
  
  public Text createText(){
    return super.createText( this.composite, SWT.BORDER | SWT.SINGLE);  
  }
  
  public Group createGroup( String text){
    return super.createGroup( this.composite, SWT.NONE, text);
  } 
  
  public Group createGroup( String text, Object layoutData){
    return super.createGroup( this.composite, SWT.NONE, text, layoutData);
  } 
  
  public Group createGroup( String text, Object layoutData, Layout layout){
    return super.createGroup( this.composite, SWT.NONE, text, layoutData, layout);
  } 
  
  public Combo createCombo(int style){
    return super.createCombo( this.composite, style);
  }
  
  public Combo createCombo( int style, String[] txt){
    return super.createCombo( this.composite, style, txt);   
  }
  
  public Combo createCombo( String[] txt){
    return super.createCombo( this.composite, SWT.BORDER | SWT.READ_ONLY , txt);   
  }
  
  public List createList( int style, String[] text){
    return super.createList( this.composite, style, text);   
  }
 
  public List createList( int style, String[] text, SelectionListener listener){
    return super.createList( this.composite, style, text, listener);   
  }
  
  public List createList( String[] text, SelectionListener listener){
    return super.createList( this.composite, 
        SWT.SINGLE | SWT.BORDER | SWT.V_SCROLL | SWT.H_SCROLL, text, listener);   
  }
  
  public Table createTable( int style, String [] cols, int [] w, SelectionListener listener){
    return super.createTable( this.composite, style, cols, w, listener);   
  }
  
  public Table createTable( String [] cols, int [] w, SelectionListener listener){
    return super.createTable( this.composite, 
        SWT.BORDER | SWT.FULL_SELECTION | SWT.SINGLE, cols, w, listener);   
  }
 
  public MenuItem createMenuItem( Menu menu, String text){
    return super.createMenuItem( menu, SWT.CASCADE, text);    
  }
  
  public MenuItem createMenuItem( Menu menu, String text, SelectionListener listener){
    return super.createMenuItem( menu, SWT.CASCADE, text, listener);   
  }
  
  public ProgressBar createProgress( GridData gridData){
    return super.createProgress( this.composite, gridData);
  }
  
  public Composite getComposite(){
    return this.composite;
  }
  
  public void setComposite( Composite composite){
    this.composite = composite;
  } 

}
