package org.exoplatform.connectors.jcr;

import java.net.MalformedURLException;
import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NameAlreadyBoundException;
import javax.resource.ResourceException;
import javax.resource.spi.ActivationSpec;
import javax.resource.spi.BootstrapContext;
import javax.resource.spi.ResourceAdapterInternalException;
import javax.resource.spi.endpoint.MessageEndpointFactory;
import javax.transaction.xa.XAResource;

import org.exoplatform.services.jcr.impl.StandaloneContainer;
import org.exoplatform.services.jcr.impl.jndi.BindableRepositoryImpl;

public class JcrResourceAdapter implements javax.resource.spi.ResourceAdapter
{
  String repositoryConfig;
  String containerConfig;
  String bindName;
 
  public synchronized void start(BootstrapContext ctx) throws ResourceAdapterInternalException {
System.out.println("repositoryConfig: " + repositoryConfig);
System.out.println("containerConfig: " + containerConfig);
System.out.println("bindName: " + bindName);
    try {
      StandaloneContainer.setConfigurationURL(containerConfig);
    } catch(MalformedURLException e) {
System.out.println("!!! malformed url in repositoryConfig, didn't set");
    }
    try {
      InitialContext jndiContext = new InitialContext();
      jndiContext.bind(bindName, new BindableRepositoryImpl(StandaloneContainer.getInstance(), repositoryConfig));
    } catch (Exception e) {
System.out.println("!!! BINDING ERROR: " + e);
e.printStackTrace();
    }
  }
 
  public void stop() {
    try {
      InitialContext jndiContext = new InitialContext();
      jndiContext.unbind(bindName);
    } catch (Exception e) {
    }
  }

  public void setRepositoryConfig(String prop) {
    this.repositoryConfig = prop;
  }
 
  public void setContainerConfig(String prop) {
    this.containerConfig = prop;
  }
 
  public void setBindName(String prop) {
    this.bindName = prop;
  }
 
  void bind(String name, Object obj) {
    try {
      Context ctx = new InitialContext();
      ctx.rebind(name, obj);
    } catch (Exception e) {
    }
  }

  public XAResource[] getXAResources(ActivationSpec[] specs) throws ResourceException {
    return null;
  }

  public void endpointActivation(MessageEndpointFactory endpointFactory, ActivationSpec spec) throws ResourceException {
  }

  public void endpointDeactivation(MessageEndpointFactory endpointFactory, ActivationSpec spec) {
  }

}
