/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/

package org.exoplatform.services.jcr.datamodel;

/**
 * Created by The eXo Platform SARL        .
 *
 * @author <a href="mailto:geaz@users.sourceforge.net">Gennady Azarenkov</a>
 * @version $Id: InternalQName.java 3510 2005-12-29 17:32:57Z geaz $
 */

public class InternalQName  {
  
	protected final String namespace;
    protected final String name;

    public InternalQName(String namespace, String name) {
        if(namespace == null)
        	namespace = "";
        if(name == null)
        	name = "";
        	//throw new RepositoryException("Invalid name '"+name+"'");
        this.namespace = namespace;
        this.name = name;
    }

    public String getNamespace() {
        return namespace;
    }

    public String getName(){
        return name;
    }

    public String getAsString() {
        return "["+namespace+"]"+name;
    }
    
    public boolean equals(Object o) {
    	if(!(o instanceof InternalQName))
    		return false;
    	else
    		return getAsString().equals(((InternalQName)o).getAsString());
    }
    

    public static InternalQName parse(String qName) throws IllegalNameException {
    	
    	if(!qName.startsWith("["))
    		throw new IllegalNameException("Invalid Internal QName '"+qName+"' Should start of '['");
    	int uriStart = 0;
        int uriFinish = qName.indexOf("]", uriStart);
    	if(uriFinish == -1)
    		throw new IllegalNameException("Invalid Internal QName '"+qName+"' No closed ']'");
        String uri = qName.substring(uriStart+1, uriFinish);

        String localName = qName.substring(uriFinish+1, qName.length());

        return new InternalQName(uri, localName);

    }

    
}
