/**
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 */

package org.exoplatform.services.jcr.impl.core;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import org.exoplatform.services.jcr.impl.storage.cache.WorkspaceCache;
import org.exoplatform.services.jcr.storage.WorkspaceDataContainer;
import org.exoplatform.services.log.LogService;

/**
 * Created by The eXo Platform SARL        .
 * @author <a href="mailto:gennady.azarenkov@exoplatform.com">Gennady Azarenkov</a>
 * @version $Id: BatcheableWorkspaceDataManager.java 3510 2005-12-29 17:32:57Z geaz $
 */

public class BatcheableWorkspaceDataManager extends VersionableWorkspaceDataManager {
  
  public BatcheableWorkspaceDataManager(WorkspaceDataContainer dataContainer,
      WorkspaceCache cache, LogService logService) {
    super(dataContainer, cache, logService);
  }
  
  public synchronized void beginSessionBatch(SessionImpl session) {
    savedItems.put(session, new ArrayList());
  }
  
  public synchronized void endSessionBatch(SessionImpl session) {
    if(savedItems.containsKey(session)) {
      List itemStates = (List)savedItems.get(session);
      for(Iterator i=listeners.iterator(); i.hasNext();) {
        ItemsPersistenceListener listener = (ItemsPersistenceListener) i.next();
        listener.onBatchSaveItems(itemStates, session);
      }
      savedItems.remove(session);
    }
  }
}
