/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/

package org.exoplatform.services.jcr.impl.core.nodetype.nt;


import javax.jcr.nodetype.PropertyDefinition;
import javax.jcr.PropertyType;


import javax.jcr.nodetype.NodeDefinition;
import javax.jcr.Value;
import javax.jcr.nodetype.NodeType;
import javax.jcr.version.OnParentVersionAction;

import org.exoplatform.services.jcr.impl.core.nodetype.NodeTypeImpl;
import org.exoplatform.services.jcr.impl.core.nodetype.PropertyDefinitionImpl;
import org.exoplatform.services.jcr.impl.core.value.StringValue;

import javax.jcr.nodetype.NodeTypeManager;

/**
 * Created by The eXo Platform SARL        .
 *
 * @author <a href="mailto:geaz@users.sourceforge.net">Gennady Azarenkov</a>
 * @version $Id: BaseType.java 3510 2005-12-29 17:32:57Z geaz $
 */

public class BaseType extends NodeTypeImpl {

  public BaseType(NodeTypeManager manager) {
    super(manager);
    this.name = "nt:base";
    this.mixin = false;
    this.orderableChild = false;
    this.primaryItemName = null;
    this.declaredSupertypes = new NodeType[0];
    this.declaredChildNodeDefinitions = null; //new NodeDef[0];
    this.declaredPropertyDefinitions = new PropertyDefinition[2];
    this.declaredPropertyDefinitions[0] = new PropertyDefinitionImpl(
        "jcr:primaryType",               //name
        this,                            //declaringNodeType
        PropertyType.NAME,             //requiredType
        EMPTY_CONSTRAINTS,                            //valueConstraints
        null,                            //defaultValues
        true,                            //autoCreate
        true,                            //mandatory
        OnParentVersionAction.COMPUTE,   //onVersion
        true,                            //readOnly
        false                            //multiple
        );

    this.declaredPropertyDefinitions[1] = new PropertyDefinitionImpl(
        "jcr:mixinTypes",                //name
        this,                           //declaringNodeType
        PropertyType.NAME,            //requiredType     
        EMPTY_CONSTRAINTS,                           //valueConstraints 
        null,                           //defaultValues    
        false,                          //autoCreate       
        false,                          //mandatory        
        OnParentVersionAction.COMPUTE,  //onVersion        
        true,                           //readOnly         
        true                            //multiple         
        );

  }

}
