/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/

package org.exoplatform.services.jcr.impl.core.nodetype.nt;

import javax.jcr.PropertyType;
import javax.jcr.RepositoryException;
import javax.jcr.nodetype.NoSuchNodeTypeException;
import javax.jcr.nodetype.NodeType;
import javax.jcr.nodetype.NodeTypeManager;
import javax.jcr.nodetype.PropertyDefinition;
import javax.jcr.version.OnParentVersionAction;

import org.exoplatform.services.jcr.impl.core.nodetype.NodeTypeImpl;
import org.exoplatform.services.jcr.impl.core.nodetype.PropertyDefinitionImpl;

/**
 * Created by The eXo Platform SARL .
 * 
 * @author <a href="mailto:geaz@users.sourceforge.net">Gennady Azarenkov</a>
 * @version $Id: HierarchyNodeType.java 3510 2005-12-29 17:32:57Z geaz $
 */
public class HierarchyNodeType extends NodeTypeImpl {

  public HierarchyNodeType(NodeTypeManager manager)
      throws NoSuchNodeTypeException, RepositoryException {
    super(manager);
    this.name = "nt:hierarchyNode";
    this.mixin = false;
    this.orderableChild = false;
    this.primaryItemName = null;
    this.declaredSupertypes = new NodeType[1];
    this.declaredSupertypes[0] = manager.getNodeType("nt:base");

    this.declaredPropertyDefinitions = new PropertyDefinition[1];
    this.declaredPropertyDefinitions[0] = new PropertyDefinitionImpl(
        "jcr:created",        // name
        this,                 // declaringNodeType
        PropertyType.DATE,    // requiredType
        EMPTY_CONSTRAINTS,    // valueConstraints
        null,                 // defaultValues
        true,                 // autoCreate
        true,                 // mandatory
        OnParentVersionAction.INITIALIZE, // onVersion
        true,                 // readOnly
        false                 // multiple
    );
  }

}
