/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/

package org.exoplatform.services.jcr.impl.core.nodetype.nt;


import javax.jcr.PropertyType;
import javax.jcr.RepositoryException;
import javax.jcr.nodetype.NoSuchNodeTypeException;
import javax.jcr.nodetype.NodeDefinition;
import javax.jcr.nodetype.NodeType;
import javax.jcr.nodetype.NodeTypeManager;
import javax.jcr.nodetype.PropertyDefinition;
import javax.jcr.version.OnParentVersionAction;

import org.exoplatform.services.jcr.impl.core.nodetype.ItemDefinitionImpl;
import org.exoplatform.services.jcr.impl.core.nodetype.NodeDefinitionImpl;
import org.exoplatform.services.jcr.impl.core.nodetype.NodeTypeImpl;
import org.exoplatform.services.jcr.impl.core.nodetype.PropertyDefinitionImpl;

/**
 * Created by The eXo Platform SARL        .
 *
 * @author <a href="mailto:geaz@users.sourceforge.net">Gennady Azarenkov</a>
 * @version $Id: UnstructuredType.java 3510 2005-12-29 17:32:57Z geaz $
 */

public class UnstructuredType extends NodeTypeImpl {

  public UnstructuredType(NodeTypeManager manager) throws NoSuchNodeTypeException,RepositoryException {
    super(manager);
    this.name = "nt:unstructured";
    this.mixin = false;
    this.orderableChild = true;
    this.primaryItemName = null;
    this.declaredSupertypes = new NodeType[1];
    this.declaredSupertypes[0] = manager.getNodeType("nt:base");
    this.declaredPropertyDefinitions = new PropertyDefinition[2];

    this.declaredPropertyDefinitions[0] = new PropertyDefinitionImpl(
        ItemDefinitionImpl.RESIDUAL_SET,     //name
        this,                         //declaringNodeType
        PropertyType.UNDEFINED,       //requiredType     
        EMPTY_CONSTRAINTS,            //valueConstraints 
        null,                         //defaultValues
        false,                        //autoCreate       
        false,                        //mandatory        
        OnParentVersionAction.COPY,   //onVersion        
        false,                        //protected
        true                          //multiple         
        );

    this.declaredPropertyDefinitions[1] = new PropertyDefinitionImpl(
            ItemDefinitionImpl.RESIDUAL_SET,     //name
            this,                         //declaringNodeType
            PropertyType.UNDEFINED,       //requiredType     
            EMPTY_CONSTRAINTS,            //valueConstraints 
            null,                         //defaultValues
            false,                        //autoCreate       
            false,                        //mandatory        
            OnParentVersionAction.COPY,   //onVersion        
            false,                        //protected
            false                          //multiple         
            );
    
    this.declaredChildNodeDefinitions = new NodeDefinition[1];
    NodeType[] types = {manager.getNodeType("nt:base")};
    this.declaredChildNodeDefinitions[0] = new NodeDefinitionImpl(
        ItemDefinitionImpl.RESIDUAL_SET,        // name
        this,                            // declaringNodeType
        types,                           // requiredNodeTypes
        this,                            // defaultNodeType
        false,                           // autoCreate       
        false,                           // mandatory        
        OnParentVersionAction.VERSION,   // onVersion        
        false,                           // protected        
        true                             // same-name sibling
        );

  }

}
