package org.exoplatform.services.webdav;

import org.apache.jackrabbit.webdav.DavLocatorFactory;
import org.apache.jackrabbit.webdav.DavResourceFactory;
import org.apache.jackrabbit.webdav.DavSessionProvider;

public interface WebdavService {

  /**
   * Returns the <code>DavLocatorFactory</code>. 
   * @return the locator factory
   */
  public DavLocatorFactory getLocatorFactory(String resourcePathPrefix);

  /**
   * Returns the <code>DavResourceFactory</code>.
   * 
   * @return the resource factory
   */
  public DavResourceFactory getResourceFactory();
  
  /**
   * Returns the <code>DavSessionProvider</code>. 
   * 
   * @return the session provider
   */
  public DavSessionProvider getDavSessionProvider();
  
}
