/**
 **************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 */

package org.exoplatform.portlet.cocoon;


import javax.portlet.*;
import javax.servlet.RequestDispatcher;

import javax.servlet.ServletContext;
import javax.servlet.*;

import javax.servlet.http.*;
import javax.servlet.http.HttpServletRequestWrapper;
import org.exoplatform.portlet.commons.servlet.BufferedServletResponse;
import org.exoplatform.services.portletcontainer.ExoPortletContext;
import org.exoplatform.services.portletcontainer.impl.portletAPIImp.*;
import org.exoplatform.services.portletcontainer.impl.portletAPIImp.helpers.CustomRequestWrapper;
import org.exoplatform.services.portletcontainer.impl.portletAPIImp.helpers.CustomResponseWrapper;
import java.io.IOException;
import java.io.Writer;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.util.ArrayList;
import org.apache.commons.logging.Log;
import org.exoplatform.container.PortalContainer;
import org.exoplatform.container.SessionContainer;
import org.exoplatform.services.log.LogService;
import org.exoplatform.portal.session.RequestInfo;
import org.exoplatform.Constants;
import java.io.PrintWriter;
import java.io.CharArrayWriter;
//import javax.servlet.ServletOutputStream;

/**
 * Created by The eXo Platform SARL        .
 *
 * @author Gennady Azarenkov
 * @version $Id: CocoonPortlet.java 808 2005-02-28 19:09:15Z kravchuk $
 */

public class CocoonPortlet extends GenericPortlet {
  private String servletName;
  private static Log log;
  private String contextPath_;
  public void init(PortletConfig config) throws PortletException {
      super.init(config);
      PortalContainer manager = PortalContainer.getInstance();

      contextPath_ = "/" + config.getPortletContext().getPortletContextName() ;
      LogService logService =
              (LogService) manager.getComponentInstanceOfType(LogService.class);
      try {
          log = logService.getLog("org.exoplatform.portlet.cocoon");

          logService.setLogLevel("org.apache.struts",
                                 LogService.DEBUG, true);
          logService.setLogLevel("org.exoplatform.portlet.cocoon",
                       LogService.DEBUG, true);

      } catch (Exception ex) {

      }
      log = logService.getLog(this.getClass());

      servletName = config.getInitParameter("servlet-name");
      if (servletName == null)
          servletName = config.getPortletName();

      log.debug("servletName [" + servletName + "]");
      log.debug("contextPath_["+contextPath_+"]");

  }

  public void render(RenderRequest request, RenderResponse response) throws PortletException, java.io.IOException {
    doView(request, response);
  }

  public void doView(RenderRequest request, RenderResponse response) throws PortletException, IOException {
    log.debug("request class "+request.getClass().getName());
    log.debug("response class "+response.getClass().getName());
    log.debug("response is commited "+response.isCommitted());

      String path = "/" ;
    CustomRequestWrapper requestWrapper = null;

    ExoPortletContext context = (ExoPortletContext) request.getPortletSession().getPortletContext();
    boolean isSharedSessionEnable = context.isSessionShared();
    log.debug("Session is shared "+isSharedSessionEnable);

    //wrap request
    requestWrapper = (CustomRequestWrapper)
                     ((HttpServletRequestWrapper)request).getRequest();
//    CustomResponseWrapper responseWrapper =
//            (CustomResponseWrapper) ((HttpServletResponseWrapper)response).getResponse();

    CustomResponseWrapper responseWrapper =
            new MyResponseWrapper(

                    (HttpServletResponse )
                    ((HttpServletResponseWrapper)
                     ((HttpServletResponseWrapper)response).getResponse()).getResponse()


            );

    responseWrapper.fillResponseWrapper((HttpServletResponseWrapper)response);
    responseWrapper.setBufferSize(10*1024);
    log.debug("responseWrapper.getBufferSize()="+responseWrapper.getBufferSize());
    log.debug("responseWrapper.getResponse()="+
              responseWrapper.getResponse().getClass().getName());
    log.debug("response.getResponse()="+
              ((HttpServletResponseWrapper)response).getResponse().getClass().getName());
    log.debug("response.getResponse().getResponse()="+
              ((HttpServletResponseWrapper)
              ((HttpServletResponseWrapper)response).getResponse()).getResponse().getClass().getName());
   log.debug("response.getResponse().getResponse().getResponse()="+
             ((HttpServletResponseWrapper)
             ((HttpServletResponseWrapper)
             ((HttpServletResponseWrapper)response).
                 getResponse()).
                 getResponse()).
                 getResponse().getClass().getName());


//            (CustomResponseWrapper) ((HttpServletResponseWrapper)response).getResponse();

//    BufferedServletResponse responseWrapper =
//            new BufferedServletResponse((RenderResponseImp) response);
    try {
      PortletContextImpl portletContext = (PortletContextImpl) getPortletContext() ;
      ServletContext scontext = portletContext.getWrappedServletContext() ;
      RequestDispatcher dispatcher = null;

      String requestUri = requestWrapper.getParameter("url") ;
      if (requestWrapper.getParameter("error") != null) {
          try{
              throw new Exception("test error");
          }
          catch (Exception ex){
              log.error("exeption",ex);
          }
      }


      if (requestUri == null)
          requestUri = "/index.jsp";

      log.debug("URI requested : " + requestUri);
//      log.debug("org.apache.struts.action.SERVLET_MAPPING : " +
//                scontext.
//                getAttribute("org.apache.struts.action.SERVLET_MAPPING").
//                toString());

      log.debug("request javax.servlet.include.path_info"+
                requestWrapper.getAttribute("javax.servlet.include.path_info"));
      log.debug("request javax.servlet.include.servlet_path"+
                requestWrapper.getAttribute("javax.servlet.include.servlet_path"));

      log.debug("------------ begin request info --------------");
      log.debug("request.getPathInfo() "+
                requestWrapper.getPathInfo());
      log.debug("request.getServletPath() "+
                requestWrapper.getServletPath());
      log.debug("request.getQueryString() "+
                requestWrapper.getQueryString());
      log.debug("request.getContextPath() "+
          requestWrapper.getContextPath());
      log.debug("------------ end request info --------------");


//      ServletContext portalContext = PortalContainer.getInstance().getPortalServletContext();//
//      ServletContext portletContext = portalContext.getContext(contextPath_);//
//      dispatcher = portletContext.getRequestDispatcher(requestUri);//
dispatcher = scontext.getRequestDispatcher(requestUri) ;



//      dispatcher = scontext.getNamedDispatcher("action");
//      if(requestUri == null) {
//          dispatcher = scontext.getRequestDispatcher("/index.html") ;
//
//      dispatcher = scontext.getRequestDispatcher(requestUri) ;
//
//      } else {
////        requestUri = requestUri.substring(contextPath_.length() , requestUri.length()) ;
//        if (requestUri.endsWith(".do")) {
//          dispatcher = scontext.getRequestDispatcher(path) ;
//          requestWrapper.setAttribute("exo.forward", requestUri) ;
//        } else {
//          dispatcher = scontext.getRequestDispatcher(requestUri) ;
//        }
//      }

//      responseWrapper.flushBuffer();


      requestWrapper.setRedirected(true);
      requestWrapper.setRedirectedPath(path);

//      URLEncoder urlencoder =
//        new StrutsURLEncoder(contextPath_, response.createRenderURL().toString()) ;
//      responseWrapper.setURLEncoder(urlencoder) ;
      if(isSharedSessionEnable){
        PortletSessionImp pS = (PortletSessionImp)request.getPortletSession();
        requestWrapper.setSharedSession(pS.getSession());
        requestWrapper.setContextPath(request.getContextPath());
      }
//      log.debug("before include responseWrapper.isCommited() "+responseWrapper.isCommitted());
//      log.debug("before include responseWrapper.getBufferSize() "+responseWrapper.getBufferSize());

//      String attr = (String)requestWrapper.getAttribute("javax.servlet.include.servlet_path") ;





//      requestWrapper.setAttribute("javax.servlet.include.path_info","/editRegistration") ;
//      requestWrapper.setAttribute("javax.servlet.include.request_uri","struts_1_1/editRegistration.do");
//      requestWrapper.setAttribute("javax.servlet.include.context_path","/struts_1_1");
//      requestWrapper.setAttribute("javax.servlet.include.servlet_path","/editRegistration.do");

//      log.debug("javax.servlet.include.servlet_path "+attr);
//
      dispatcher.include(requestWrapper, responseWrapper);
//      dispatcher.forward (requestWrapper, responseWrapper);
//      log.debug("before include responseWrapper.isCommited() "+responseWrapper.isCommitted());
//      log.debug("before include responseWrapper.getBufferSize() "+responseWrapper.getBufferSize());
      responseWrapper.flushBuffer();
      responseWrapper.getResponse().flushBuffer();


      log.debug("responseWrapper.toByteArray().length "+responseWrapper.toByteArray().length);
      log.debug("responseWrapper.getPortletContent().length "+responseWrapper.getPortletContent().length);
      Writer writer = response.getWriter();
      writer.write(new String(responseWrapper.getPortletContent()));
      responseWrapper.getWriter().close();
      response.flushBuffer();
//      log.debug("after include response is commited - "+response.isCommited());
    } catch (Exception e) {
      throw new PortletException("Problems occur when using PortletDispatcher", e);
    } finally {
      if(requestWrapper != null)
        requestWrapper.setRedirected(false);
      if(isSharedSessionEnable){
        requestWrapper.setSharedSession(null);
      }
//      responseWrapper.setURLEncoder(null) ;
    }
    log.debug( "$$$ end dispatch to struts controller $$$$$$$$$$$$$$$$$$$$$$$$" );



  }

  //URI (path + query string) of current string
  private String getBaseURI(){
      RequestInfo rinfo =
            (RequestInfo)SessionContainer.getComponent(RequestInfo.class);
      String path = rinfo.getOwnerURI();


      ArrayList paramsArray = new ArrayList();

      //query string
      if (rinfo.getTargetComponentId() != null){
          paramsArray.add(
            Constants.COMPONENT_PARAMETER + "="+rinfo.getTargetComponentId());
      }

      if (rinfo.getPortletWindowState() != null){
          paramsArray.add(
            Constants.WINDOW_STATE_PARAMETER+"="+rinfo.getPortletWindowState());
      }

      if (rinfo.getPortletMode() != null){
          paramsArray.add(
            Constants.PORTLET_MODE_PARAMETER+"="+rinfo.getPortletMode());
      }

      //add query to path
      if (! paramsArray.isEmpty()){
          path += "?" + paramsArray.get(0);
          for (int i = 1; i < paramsArray.size(); i++){
              path += "&" + paramsArray.get(i);
          }
      }

      return path;
  }


  private static class CharArrayWriterWrapper extends CharArrayWriter {
      public void write(char c[], int off, int len) {
          log.debug("CharArrayWriterWrapper.write()#1");
          super.write(c, off, len);
      }

      public void write(int c) {
          log.debug("CharArrayWriterWrapper.write()#2");
          super.write(c);
      }

      public void write(String str, int off, int len) {
          log.debug("CharArrayWriterWrapper.write()#3");
          super.write(str, off, len);

      }

      /**
       * stub for close method
       */
      public void close() {
          log.debug("CharArrayWriterWrapper.close()");
      }

      public void realClose() {
          log.debug("CharArrayWriterWrapper.realClose()");
          super.close();
      }
  }

  private static class MyResponseWrapper extends CustomResponseWrapper {
      private PrintWriter tmpWriter;
      private CharArrayWriterWrapper charArrayWriter;

      public void fillResponseWrapper(HttpServletResponse httpServletResponse) {
          super.fillResponseWrapper(httpServletResponse);
          charArrayWriter = new CharArrayWriterWrapper();
          tmpWriter = new PrintWriter(charArrayWriter);
      }

      public void finalize() throws Throwable {
          super.finalize();
          charArrayWriter.realClose();
      }



      public MyResponseWrapper(HttpServletResponse httpServletResponse) {
          super(httpServletResponse);
      }

      public boolean isCommitted() {
          boolean isCommited = super.isCommitted();
          log.debug("MyResponseWrapper.isCommitted() "+isCommited);
          return false;
//          return isCommited;
      }

      public void flushBuffer() throws IOException {
          log.debug("MyResponseWrapper.flushBuffer()");
          super.flushBuffer();
          tmpWriter.flush();
      }

      public char[] getPortletContent() {
          return charArrayWriter.toCharArray();
      }


      public void reset() {
          log.debug("MyResponseWrapper.reset()");
          super.reset();
      }

      public void close() {
          log.debug("MyResponseWrapper.close()");
          super.reset();
      }

      public PrintWriter getWriter() throws IOException {
          log.debug("MyResponseWrapper.getWriter()");
//          return super.getWriter();
          return tmpWriter;
      }

      public ServletOutputStream getOutputStream() throws IOException {
          log.debug("MyResponseWrapper.getOutputStream()");
          return super.getOutputStream();

      }

      public int getBufferSize(){
          log.debug("MyResponseWrapper.getBufferSize()");
          return  getResponse().getBufferSize();
      }

  }




}


//
//
//
//
//    WindowState state = request.getWindowState();
//
//    String path = "/";
//
//    CustomRequestWrapper requestWrapper = null;
//    ExoPortletContext context = (ExoPortletContext) request.getPortletSession().getPortletContext();
//    boolean isSharedSessionEnable = context.isSessionShared();
//    try {
//      requestWrapper = ((CustomRequestWrapper) ((HttpServletRequestWrapper) request).getRequest());
//      BufferedServletResponse responseWrapper = new BufferedServletResponse((RenderResponseImp) response);
//      PortletContextImpl portletContext = (PortletContextImpl) getPortletContext();
//      ServletContext scontext = portletContext.getWrappedServletContext();
//      RequestDispatcher dispatcher = null;
//      String requestUrl = requestWrapper.getParameter("url");
//      System.out.println("Portlet RequestURI: " + requestUrl);
//      log.debug("Portlet RequestURI: " + requestUrl);
//      log.debug("servletname: " + servletName);
//      dispatcher = scontext.getNamedDispatcher(servletName);
//      if (requestUrl != null)
//        path += requestUrl;
//      // System.out.println("Real Path: " + scontext.getRealPath(path));
//      log.debug("Real Path: " + scontext.getRealPath(path));
//      log.debug("path: " + path);
//      log.debug("isSharedSessionEnable: " + isSharedSessionEnable);
//
//
//      responseWrapper.flushBuffer();
//      requestWrapper.setRedirected(true);
//      requestWrapper.setRedirectedPath(path);
//      if (isSharedSessionEnable) {
//        PortletSessionImp pS = (PortletSessionImp) request.getPortletSession();
//        requestWrapper.setSharedSession(pS.getSession());
//        requestWrapper.setContextPath(request.getContextPath());
//      }
//
//      log.debug("dispatcher class name "+dispatcher.getClass().getName());
//      log.debug("requestWrapper.getRequestURI() "+requestWrapper.getRequestURI());
//      log.debug("requestWrapper.getRequestURL() "+requestWrapper.getRequestURL());
//      log.debug("requestWrapper.getContextPath() "+requestWrapper.getContextPath());
//
//
//      requestWrapper.setAttribute("javax.servlet.include.servlet_path", path) ;
//      log.debug("include.servlet_path ["+requestWrapper.getAttribute("javax.servlet.include.servlet_path")+"]");
//      log.debug("requestWrapper.getContextPath() "+requestWrapper.getContextPath());
//
//      dispatcher.include(requestWrapper, responseWrapper);
//      response.setContentType("text/html");
//
//
//      ByteArrayOutputStream  byteOutput = new ByteArrayOutputStream();
//      new URLRewriter().rewrite(
//
//                new ByteArrayInputStream(responseWrapper.toByteArray()),
//                //response.getPortletOutputStream(),
//                byteOutput,
//                getBaseURI(),requestUrl);
//      Writer writer = response.getWriter();
//      writer.write(byteOutput.toString());
//
//    } catch (Exception e) {
//      e.printStackTrace();
//      throw new PortletException("Problems occur when using PortletDispatcher", e);
//    } finally {
//      if (requestWrapper != null)
//        requestWrapper.setRedirected(false);
//      if (isSharedSessionEnable) {
//        requestWrapper.setSharedSession(null);
//      }
//    }
