package org.exoplatform.faces.core.component.model;

import java.io.IOException;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.ResourceBundle;

import javax.faces.context.ResponseWriter;

import org.exoplatform.commons.utils.ExpressionUtil;
import org.exoplatform.faces.core.component.UIExoComponent;

public class PopupMenuButton extends Button{ 
  private static final String ENCODER = "_block";
  private List menuButtons_ = new ArrayList();
  private String menuName_;
  
  public PopupMenuButton(String name, String menuName) {
    super(name, (String)null);
    menuName_ = menuName;
    parameters_ = "showhide('" + menuName + ENCODER + "'); return false;" ;    
  }
  
  public void addMenuButton(Button button){
    menuButtons_.add(button);
  }
  
  public void render(ResponseWriter w, ResourceBundle res, 
                     UIExoComponent uiParent, String objectId) throws IOException {
    if(!isVisible()) return;
    w.write("<div id=\"" + menuName_ + "\">");
    w.write("<div id=\"menubutton\">");
    w.write("<a");
    w.write(" href=\"\""); 
    w.write(" onclick=\""); w.write(parameters_); w.write("\">");
    w.write(ExpressionUtil.getExpressionValue(res,label_));
    w.write("</a>");
    w.write("</div>");
    generateDiv(w, res, uiParent);
    w.write("</div>");
  }

  private void generateDiv(ResponseWriter w, ResourceBundle res, 
      UIExoComponent uiParent ) throws IOException {
    w.write("<div id=\"" + menuName_ + ENCODER + "\">");
    for (Iterator iter = menuButtons_.iterator(); iter.hasNext();) {
      Button button = (Button) iter.next();
      w.write("<div class=\"menuitem\">");
      button.render(w, res, uiParent, null);
      w.write("</div>");
    }
    w.write("</div>");
  }    

}
