/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.faces.core.validator;

import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.validator.Validator;
import javax.faces.validator.ValidatorException;
import org.exoplatform.container.PortalContainer;
import org.exoplatform.faces.application.ExoFacesMessage;
import org.exoplatform.faces.core.component.UIInput;
import org.exoplatform.services.organization.Group;
import org.exoplatform.services.organization.OrganizationService;
import org.exoplatform.services.organization.MembershipType;
/**
 * @author Nguyen Hung (nguyenkequanghung@yahoo.com)
 * @since Dec 16, 2005
 * @version $Id: PermissionValidator.java,v 1.4 2005/12/16 14:53:44  Exp $
 */
public class PermissionValidator implements Validator {
  public void validate(FacesContext context, 
                       UIComponent component, 
                       Object value) throws ValidatorException{
    String s = (String) value ;
    String membership ; 
    String groupId ;
    MembershipType membershipType = null;
    Group group = null;
    OrganizationService service = (OrganizationService) PortalContainer.getComponent(OrganizationService.class);
    if(s!=null && s.length() > 0){
      UIInput uiInput = (UIInput) component ;
      Object[] args = {uiInput.getName()} ;
      String[] tmp = s.split(":", 2) ;
      if(tmp.length != 2) {
        throw new ValidatorException(new ExoFacesMessage("#{PermissionValidator.msg.invalid-permission-input}", args));  
      }
      membership = tmp[0] ;
      groupId = tmp[1] ;
      try{
        membershipType = service.getMembershipTypeHandler().findMembershipType(membership) ;
        group = service.getGroupHandler().findGroupById(groupId);
      }catch(Exception e){
        e.printStackTrace();
      }
      if(!membership.equals("*")){
        if(membershipType == null || group == null){
          throw new ValidatorException(new ExoFacesMessage("#{PermissionValidator.msg.membership-group-not-found}", args));
        }
      }else{
        if(group == null){
          throw new ValidatorException(new ExoFacesMessage("#{PermissionValidator.msg.membership-group-not-found}", args));
        }
      }
            
    }    
  }
}	