/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.faces.search.component;

import java.util.*;

import javax.faces.component.UIComponent;

import org.exoplatform.faces.core.component.*;
import org.exoplatform.faces.core.component.model.*;
import org.exoplatform.faces.core.event.ExoActionEvent;
import org.exoplatform.faces.core.event.ExoActionListener;
import org.exoplatform.services.indexing.*;
/**
 * @author Tuan Nguyen (tuan08@users.sourceforge.net)
 * @since Aug 27, 2004
 * @version $Id: UIAdvancedSearch.java,v 1.1 2004/10/25 03:34:07 tuan08 Exp $
 */
public class UIAdvancedSearch extends  UISimpleForm {
  static public String SEARCH_ACTION = "search"  ;
  
  UIStringInput documentInput_ ;
  UIStringInput titleInput_ ;
  UIStringInput descriptionInput_ ;
  UIStringInput authorInput_ ;
  UIListStringInput uiModulesInput_ ;
  List listInput ;
  
  public UIAdvancedSearch(IndexingService iservice) throws Exception {
    super("aSearchForm", "post", null) ;
  	setId("UIAdvancedSearch") ;
    setClazz("UIAdvancedSearch");
    setRendererType("SimpleFormVelocityRenderer") ;
    titleInput_ = new UIStringInput("title", "") ;
    authorInput_ = new UIStringInput("author", "") ;
    descriptionInput_ = new UIStringInput("description", "") ;
    documentInput_ = new UIStringInput("document", "") ;
    
    add(titleInput_) ;
    add(authorInput_) ;
    add(descriptionInput_) ;
    add(documentInput_) ;
    listInput = new ArrayList() ;
    Iterator i = iservice.getIndexerPlugins().iterator();
    while(i.hasNext()) {
      IndexerPlugin plugin =(IndexerPlugin) i.next() ;
      UICheckBox uiModule = new UICheckBox(plugin.getPluginIdentifier(), "true");
      uiModule.setId(plugin.getPluginIdentifier());
      uiModule.setSelect(true) ;
      listInput.add(uiModule) ;
      add(uiModule);
    }
    uiModulesInput_ = new UIListStringInput("list",listInput) ;
    add(uiModulesInput_) ;
    addActionListener(SearchActionListener.class, SEARCH_ACTION) ;
  }
  
  public String getSearchAction(){ return SEARCH_ACTION ; }
  public String getLabel(ResourceBundle res , UIComponent component) { 
    return res.getString("UIAdvancedSearch." + component.getId() + ".module") ;            
  }
  public List getOptions() {  return listInput ; }
  
  static public class SearchActionListener extends ExoActionListener {
    public void execute(ExoActionEvent event) throws Exception {
      UIAdvancedSearch uiForm =  (UIAdvancedSearch) event.getSource();
      List selectModules = new ArrayList() ;
      for(int i = 0; i < uiForm.listInput.size(); i++) {
        UICheckBox uiBox = (UICheckBox) uiForm.listInput.get(i) ;
        if(uiBox.getSelect()) {
          selectModules.add(uiBox.getName()) ;
        }
      }
      
      List inputs = new ArrayList() ;
      String value = uiForm.titleInput_.getValue() ;
      if(value.length() > 0) {
        inputs.add(new SingleFieldSearchInput(IndexingService.TITLE_FIELD, value)) ;
      }
      value = uiForm.authorInput_.getValue() ;
      if(value.length() > 0) {
        inputs.add(new SingleFieldSearchInput(IndexingService.AUTHOR_FIELD, value)) ;
      }
      value = uiForm.documentInput_.getValue() ;
      if(value.length() > 0) {
        inputs.add(new SingleFieldSearchInput(IndexingService.DOCUMENT_FIELD, value)) ;
      }
      UISearcher uiSearcher = (UISearcher) uiForm.getParent() ;
      uiSearcher.advancedSearch(inputs, selectModules) ;
    }
  }
}