/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portlets.backup.component;

import java.util.* ;
import org.exoplatform.faces.core.component.UICommandNode;
import org.exoplatform.faces.core.component.model.Parameter;
import org.exoplatform.faces.core.event.*;
import org.exoplatform.services.backup.ImportExportService ;
/**
 * @email:   tuan08@users.sourceforge.net
 * @version: $Id: UIExportData.java,v 1.4 2004/09/21 00:16:11 tuan08 Exp $
 */
public class UIExportData extends UICommandNode {
  static String EXPORT = "exportData" ;
  static String EXPORT_ALL = "exportAllData" ;
  static String TRANSFORM_ALL_DATA = "transformAllData" ;
  
  static Parameter[] EXPORT_PARAMS = { new Parameter(ACTION , EXPORT )} ;
  static Parameter[] EXPORT_ALL_PARAMS  =   { new Parameter(ACTION , EXPORT_ALL) } ;
  static Parameter[] TRANSFORM_ALL_PARAMS  =   { new Parameter(ACTION , TRANSFORM_ALL_DATA) } ;
  
  ImportExportService service_ ;
  Collection plugins_ ;
  boolean adminRole_ ;

  public UIExportData(ImportExportService service) {
  	setId("UIExportData") ;
  	setRendererType("VelocityRenderer") ;
  	service_ = service ;
  	plugins_ = service_.getPlugins() ;
    addActionListener(ExportDataActionListener.class , EXPORT) ;
    addActionListener(ExportAllActionListener.class, EXPORT_ALL) ;
    addActionListener(TransformAllActionListener.class, TRANSFORM_ALL_DATA) ;
    adminRole_ = hasRole("admin") ;
  }
  
  public Parameter[] getExportParams() { return EXPORT_PARAMS ; }
  public Parameter[] getExportAllParams() { return EXPORT_ALL_PARAMS ; }
  public Parameter[] getTransformAllParams() { return TRANSFORM_ALL_PARAMS ; }
  
  public boolean hasAdminRole() { return adminRole_ ; }
  
  public Collection getImportExportPlugins() { return plugins_ ; }
  
  static public class ExportAllActionListener extends ExoActionListener  {
    public ExportAllActionListener() {
      addInterceptor(new CheckRoleInterceptor("admin")) ;  
    }
    
  	public void execute(ExoActionEvent event) throws Exception {
      UIExportData uiComp = (UIExportData) event.getSource() ;
  		uiComp.service_.exportUserData() ;
  		uiComp.service_.exportServiceData() ;
    }
  }
  
  static public class ExportDataActionListener extends ExoActionListener  {
    public ExportDataActionListener() {
      addInterceptor(new CheckRoleInterceptor("admin")) ;  
    }
    
  	public void execute(ExoActionEvent event) throws Exception {
      UIExportData uiComp = (UIExportData) event.getSource() ;
  		String name = event.getParameter(OBJECTID) ;
  		uiComp.service_.exportServiceData(name) ;
    }
  }
  
  static public class TransformAllActionListener extends ExoActionListener  {
    public TransformAllActionListener() {
      addInterceptor(new CheckRoleInterceptor("admin")) ;  
    }
    
    public void execute(ExoActionEvent event) throws Exception {
      UIExportData uiComp = (UIExportData) event.getSource() ;
      uiComp.service_.transformServiceData();
      uiComp.service_.transformUserData();
    }
  }
}