/***************************************************************************
 * Copyright 2001-2003 The VietSpider Studio        All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portlets.backup.component;

import java.io.File;
import java.util.ArrayList;
import java.util.List;

import org.exoplatform.commons.utils.PageList;
import org.exoplatform.portlets.backup.component.model.ImportData;

/**
 * Created by VietSpider Studio
 * Author : Nhu Dinh Thuan
 *          nhudinhthuan@yahoo.com
 * Dec 23, 2005
 */
public class ZipFilePageList extends PageList {
  
  private String directory_;
  
  public ZipFilePageList(String directory, int pageSize) {
    super( pageSize);
    this.directory_ = directory;
    File dir = new File(directory_) ;
    File[] files = dir.listFiles(new ZipFileFilter()) ;
    this.setAvailablePage( files.length);      
  }
  
  protected void populateCurrentPage(int page) throws Exception {    
    File dir = new File(directory_) ;   
    File[] files = dir.listFiles(new ZipFileFilter()) ;
    List<ImportData> importDatas_ = new ArrayList<ImportData>(files.length) ;
    int start = (page-1)*this.getPageSize();
    int end = Math.min(start+getPageSize(), files.length);   
    for(int i = start; i < end; i++) {
      importDatas_.add(new ImportData(files[i])) ;
    }
    this.currentListPage_ = importDatas_;
  }  
  
  public List getAll() throws Exception {    
    return null;
  }

}
