/**
 * Copyright 2001-2004 The eXo platform SARL All rights reserved.
 * Please look at license.txt in info directory for more license detail.
 **/
package org.exoplatform.portlets.content;

import java.util.HashMap;
import java.util.Iterator;
import java.util.Locale;
import java.util.Map;
import java.util.Set;

import javax.faces.context.FacesContext;
import javax.portlet.PortletPreferences;

import org.apache.commons.lang.StringUtils;
import org.exoplatform.container.PortalContainer;
import org.exoplatform.container.SessionContainer;
import org.exoplatform.faces.core.component.UIInput;
import org.exoplatform.faces.core.component.UIUploadInput;
import org.exoplatform.portal.session.ExoPortal;
import org.exoplatform.portal.session.PortalResources;
import org.exoplatform.portlets.content.display.model.ContentConfig;
import org.exoplatform.services.organization.Group;
import org.exoplatform.services.organization.OrganizationService;
import org.exoplatform.services.portal.community.CommunityConfigService;
import org.exoplatform.services.portal.community.CommunityNavigation;
import org.exoplatform.services.portletcontainer.ExoPortletRequest;

/**
 * @author Ove Ranheim (oranheim@yahoo.no)
 * @since Jul 5, 2004 1:35:46 PM
 */
public class ContentUtil {

  public static final String EDIT_STATE = "ACTION_EDIT";
  public static final String MODIFY_STATE = "ACTION_MODIFY";

  public static void saveContentConfig(ContentConfig config) throws Exception {
    FacesContext context = FacesContext.getCurrentInstance();
    ExoPortletRequest request = (ExoPortletRequest) context
        .getExternalContext().getRequest();
    PortletPreferences prefs = request.getPreferences();

    String uri = config.getUri();
    if (uri == null) {
      uri = "";
      config.setUri(uri);
    }

    String name = config.getName();
    String[] tmp = new String[4];
    tmp[0] = "title=" + config.getTitle();
    tmp[1] = "uri=" + uri;
    tmp[2] = "encoding=" + config.getEncoding();
    tmp[3] = "documentType=" + config.getDocumentType();

    prefs.setValues(name, tmp);
    prefs.store();
  }
}
