/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.services.portal.log;

import org.exoplatform.commons.utils.PageList;
import org.exoplatform.services.portal.log.Query ;
import java.util.List;

/**
 * @author Tuan Nguyen (tuan08@users.sourceforge.net)
 * @since Dec 2, 2004
 * @version $Id$
 */
public interface PortalActivitiesLogService {
  
  public  void logPortletRender(String portletId, String portletAppId, 
                                long exeTime, boolean error, String eventType) ;
  public  void logPortletAction(String portletId, String portletAppId, long exeTime, boolean error, 
                                String eventType) ;
  public  void logPageAccess(String pageId, String pageOwner, long exeTime, boolean error) ;
  public  void logPortalAccess(String portalId, String portalOwner, 
                               long exeTime, boolean error, boolean illegalAccess) ;
  
  public PageList        getPortletLogDatas(Query queryData) throws Exception ;
  public List            getPortletLogChartDatas(Query queryData) throws Exception ;
  public void savePortletLogData(PortletLogData data) throws Exception ;
  
  public PageList        getPageLogDatas(Query queryData) throws Exception ;
  public List            getPageLogChartDatas(Query queryData) throws Exception ;
  public void  savePageLogData(PageLogData data) throws Exception ;
  
  public PageList        getPortalLogDatas(Query queryData) throws Exception ;
  public List            getPortalLogChartDatas(Query queryData) throws Exception ;
  public void  savePortalLogData(PortalLogData data) throws Exception ;
}