/***************************************************************************
 * Copyright 2001-2005 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package suites.ecm.user;

import condition.* ;
import suites.share.* ;
import org.exoplatform.test.web.*;
import org.exoplatform.test.web.unit.*;
import org.exoplatform.test.web.validator.*;

/**
 *  Add a new /test-folder directory
 *     1) Go to Production workspace
 *     2) Delete test-folder if does exist
 *     3) Add /test-folder directory
 *     4) Return to workspaces selection page
 *
 * Created by The eXo Platform SARL
 * Author : Dung Hoang
 *          dunghoang@exoplatform.com, jobdung@yahoo.com
 * Dec 27, 2005
 */
public class GotoFolderSuite extends WebUnitSuite {
  static String DESC = "Go to test-folder" ;
  static String NAME = "GotoFolderSuite" ;
  
  public GotoFolderSuite() {    
    super(NAME, DESC) ;    
    goToPage("/Site Map/cms") ;    
    //Go to production workspace
    /*
    addWebUnit(
      new ClickURLLinkUnit("SelectECMFileExplorer", "Select ECM File Explorer tab").
      setURL("componentId=ECMPage&portal:action=changeTab&objectId=jcr").                  
      addValidator(new ExpectTextValidator("Workspaces"))      
    ) ;
    */        
    addWebUnit(
      new ClickURLLinkUnit("ClickOnProduction", "click on Production button").
      setURL("&uicomponent=UIWorkspaceBrowser&op=selectWorkspace&objectId=production").                  
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=MainToolbar&op=selectWorkspace"))      
    ) ;         
    //Go to the test-folder
    addWebUnit(
      new ClickURLLinkUnit("GotoTest-folder", "click on test-folder").
      setURL("&uicomponent=UIDocumentInfo&op=changeNode&objectId=/test-folder").         
      addValidator(new ExpectTextValidator(">")).
      addValidator(new ExpectTextValidator("test-folder"))
    ) ;  
  }                 
  public java.util.List getRequiredSuites() { 
    String[] roles = ["user"] ;
    return [new NewAccountSuite(), new UserLoginSuite("#{client.name}", "#{client.name}", roles)] ;
  }  
}