/***************************************************************************
 * Copyright 2001-2005 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package suites.ecm.user;

import condition.* ;
import suites.share.* ;
import org.exoplatform.test.web.*;
import org.exoplatform.test.web.unit.*;
import org.exoplatform.test.web.validator.*;
/**
 * Created by The eXo Platform SARL
 * Author : Dung Hoang
 *          dunghoang@exoplatform.com, jobdung@yahoo.com
 * Dec 27, 2005
 */
public class UserManageVersionsSuite extends WebUnitSuite {
  static String DESC = "Go to Ecm Portlet Admin page, click on Manage Versions button and test all basic actions" ;
  static String NAME = "UserManageVersionsSuite" ;
  
  public UserManageVersionsSuite() {    
    super(NAME, DESC) ;
    addWebSuite(new UserAddFolderSuite());
    addWebSuite(new GotoFolderSuite());     
    //-----Select Admin tab
    addWebUnit(
      new ClickURLLinkUnit("SelectAdminTab", "click on Admin tab").
      setURL("&uicomponent=UIViewController&op=selectNode&objectId=UIAdminAction").             
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIToolbar&op=manageVersions")).      
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIToolbar&op=manageCategories")).
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIToolbar&op=manageActions")).      
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIToolbar&op=exportNode")).
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIToolbar&op=importNode"))
    ) ;
    //-----Manage Versions (test-folder's version)
    addWebUnit(
      new ClickURLLinkUnit("ClickOnManageVersions", "click on Manage Versions button").
      setURL("&uicomponent=UIToolbar&op=manageVersions").           
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIVersionInfo&op=enableVersion"))      
    ) ;         
    //----------Enable Versioning
    addWebUnit(
      new ClickURLLinkUnit("ClickOnEnableVersioning", "select Enable Versioning link").
      setURL("&uicomponent=UIVersionInfo&op=enableVersion").                  
      addValidator(new ExpectTextValidator("You need to save the node to be able to access the version tree."))      
    ) ;    
    addWebUnit(
      new ClickURLLinkUnit("SaveSession", "Click on save session button").
      setURL("&uicomponent=MainToolbar&op=saveSession").       
      addValidator(new ExpectTextValidator("jcr:rootVersion"))      
    ) ;       
    //Saved Session
    addWebUnit(
      new ClickURLLinkUnit("SavedSession", "click on save Session button").
      setURL("&uicomponent=MainToolbar&op=saveSession").        
      addValidator(new ExpectTextValidator("All the changes have been saved"))      
    ) ;
    
    //Need to play with versionning more
    // 1) once a node has been versionned, go to its parent node and ensure the "check in" icon appear
    // 2) Check in and check out several time, modyfing the text by editing it each time
    // 3) Go back to the node and view version, you should see a tree of versions
    // 4) Compare text diff version
    // 5) Test add and remove labels for versions 
    // 6) Restore an older version
    // 7) Go back to parent node and check in/out some more time
    // 8) Verify the branch has been created
    // 9) Test merge of 2 branches (need UI from HUNG see just after)
    
    // HUNG will have to fix the css and HTML there (using groovy instead of velocity for nested macros)
    // HUNG will have to also add icons for jcr:rootVersion
    // HUNG will have to add UI to allow version merge
    
    
    //Select Workspace
    addWebUnit(
      new ClickURLLinkUnit("SelectWorkspace", "select Workspace button").
      setURL("&uicomponent=MainToolbar&op=selectWorkspace").                  
      addValidator(new ExpectTextValidator("Workspaces "))      
    ) ;    
  }                 
  public java.util.List getRequiredSuites() { 
    String[] roles = ["user"] ;
    return [new NewAccountSuite(), new UserLoginSuite("#{client.name}", "#{client.name}", roles)] ;
  }  
}