/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package suites.share ;

import condition.* ;
import org.exoplatform.test.web.*;
import org.exoplatform.test.web.unit.*;
import org.exoplatform.test.web.validator.*;
/**
 * Created by The eXo Platform SARL
 * Author : Hoa  Pham
 *          hoapham@exoplatform.com,phamvuxuanhoa@yahoo.com
 * Nov 8, 2005
 */
public class AddPortletSuite extends WebUnitSuite {
  public AddPortletSuite(String category,String portletname) {
    super("AddPortletSuite", "Add a portlet into page") ;      
    //-----Expand content category---------    
    addWebUnit(
      new ClickURLLinkUnit("ClickOn'${category}'category", "Expand ${category} category").
      setURL("uicomponent=UIPortletSelecttor&op=selecCategory&objectId=${category}").      
      addCondition(new NoLinkWithURLCondition("uicomponent=UIPortletSelecttor&op=selecPortlet&objectId=${category}/${portletname}")).
      addValidator(new ExpectTextValidator("${portletname}"))
    ) ;           
    //-----Seclect a portlet in expanded content category---------
    addWebUnit(
      new ClickURLLinkUnit("Select'${portletname}'portlet", "Select the a portlet").      
      setURL("uicomponent=UIPortletSelecttor&op=selecPortlet&objectId=${category}/${portletname}").
      addValidator(new ExpectLinkWithURLValidator("componentId=${portletname}&portal:windowState=minimized")).        
      addValidator(new ExpectLinkWithURLValidator("componentId=${portletname}&portal:windowState=maximized"))
    ) ;
  }
}