/**************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved. *
 * Please look at license.txt in info directory for more license detail.  *
 **************************************************************************/
package suites.user;

import condition.* ;
import suites.share.* ;

import org.exoplatform.test.*;
import org.exoplatform.test.web.*;
import org.exoplatform.test.web.unit.*;
import org.exoplatform.test.web.validator.*;

/**
 * Created by The eXo Platform SARL
 * Author : Hoa  Pham
 *          hoapham@exoplatform.com,phamvuxuanhoa@yahoo.com
 * Nov 8, 2005
 */
public class UserProfilePortletSuite extends WebUnitSuite {
  
  public UserProfilePortletSuite() {
    super("UserProfilePortletSuite", "User Information Administration") ;    
    addWebUnit(CommonUnit.CLICK_EDIT_PAGE_MODE) ;
    //---Add UserInforPortlet in home page--
    addWebUnit(
        new ClickURLLinkUnit("AddPortlet(onPage)", "tell web client click'addPortlet' on page").
        setURL("componentId=page&portal:action=addPortlet")        
    ) ;    
    addWebSuite(new AddPortletSuite("user","UserInfo")) ;
    addWebUnit(CommonUnit.CLICK_SAVE_PAGE) ;
    //-----Back to view page-------------    
    addWebUnit(CommonUnit.CLICK_VIEW_MODE) ;
    //----Edit profile Information------
    addWebSuite(new EditUserProfileSuite("#{client.name}")) ;
    addWebSuite(new UserLogoutSuite()) ;
    //----login as admin to view all profile infomation is updated
    addWebSuite(new UserLoginSuite()) ;
    goToPage("/Site Map/Management") ;
    
    addWebUnit(
        new ClickURLLinkUnit("GoToUserTab", "Click on the groups tab").
        setURL("uicomponent=organization-portlet&op=selectNode&objectId=usernode").              
        addValidator(new ExpectLinkWithURLValidator("op=viewProfile&objectId=#{client.name}"))
      ) ;    
    addWebUnit(
        new ClickURLLinkUnit("ClickViewUserProfile", "Click the view user profile icon").
        setURL("op=viewProfile&objectId=#{client.name}").
        addValidator(new ExpectTextValidator("Info")).
        addValidator(new ExpectTextValidator("#{client.name}")).
        addValidator(new ExpectTextValidator("family name")).
        addValidator(new ExpectTextValidator("personal@exo.com")).
        addValidator(new ExpectTextValidator("www.personal.com")).
        //----business information
        addValidator(new ExpectTextValidator("084")).
        addValidator(new ExpectTextValidator("business@exo.com")).
        addValidator(new ExpectTextValidator("Your Country")).
        addValidator(new ExpectTextValidator("www.exoplatform.com"))   
      ) ;    
    addWebUnit(
        new ClickLinkWithText("ClickBackLink", "Go back to the user list screen").
        setTextLink("back")
      ) ;
  }
  public java.util.List getRequiredSuites() {     
    String[] roles = ["user"] ;
    return [new NewAccountSuite(), new UserLoginSuite("#{client.name}", "#{client.name}", roles)] ;  
  } 
}
