/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.maven2.plugin.exo;

import java.io.File;

import org.apache.maven.plugin.MojoExecutionException;
import org.codehaus.plexus.util.FileUtils;
import org.exoplatform.maven2.plugin.Utils;
/**
 * Created by The eXo Platform SARL
 * Author : Phung Hai Nam
 *          phunghainam@gmail.com
 * Dec 14, 2005
 */
/**
 * @goal jcrWar
 * 
 * @requiresDependencyResolution runtime
 * @description mvn exo:jcrWar 
 */
public class ExoJCRStandalone extends ExoPackaging {
  /**
   * Single directory for extra files to include in the WAR.
   *
   * @parameter expression="${basedir}/src/webapp"
   * @required
   */
  private File warSourceDirectory;
  /**
   * The name of the generated war.
   *
   * @parameter expression="${project.build.finalName}"
   * @required
   */
  private String warName; 
  
  public void execute() throws MojoExecutionException {
    try{
      File webappDest = new File(outputDirectory + "/" + warName) ;
      Utils.copyDirectoryStructure(warSourceDirectory, webappDest, Utils.getDefaultIgnoreFiles());
      //copy classes 
      File classesSrc = new File(outputDirectory +  "/classes") ;
      if(!classesSrc.exists()) classesSrc.mkdir() ;
      File webappClassDest = new File(outputDirectory + "/" + warName + "/WEB-INF/classes") ;
      if(!webappClassDest.exists()) webappClassDest.mkdir() ;
      FileUtils.copyDirectoryStructure(classesSrc, webappClassDest);
//      File libDir = new File(outputDirectory + "/" + warName + "/WEB-INF/lib") ;
//      if(!libDir.exists()) libDir.mkdir() ;
//      Utils.deployedDependency(libDir,null,project, getIgnoreProjects()) ;
      
      File warFile = new File( outputDirectory, warName + ".war" );
      performPackaging(warFile, webappDest);
    } catch (Exception exe) {
      throw new MojoExecutionException("Error", exe) ;
    }
  }
}
